commit 5dfa8c23f13f5cafac5cf56f34888a6e01dc79ba
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 6 01:25:17 2007 -0800

    NEWS: Note the x86 nature of the quoted performance results
    
    And mention that embedded systems often did even better.

 NEWS |    9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit d7df4d4d4c52c0934bec0c8edad96bb2ea82dc04
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 6 01:20:45 2007 -0800

    Increment cairo version to 1.4.0

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d0d2c4030741619accd1eb554531bb6a97dd7ae4
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 6 01:20:03 2007 -0800

    Clarify that extra elements in cairo_path_data is only available in cairo >= 1.4

 src/cairo.h |   14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 0578929fa4add0cf366e200a5bd6b9f2dfcd0b79
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 6 01:09:02 2007 -0800

    NEWS: Add release notes for 1.4.0 release

 NEWS |  251 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 250 insertions(+), 1 deletion(-)

commit 66d1dc8b9c3d7c1e26321bdb621ef55779c2fd6d
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 5 23:55:05 2007 -0800

    Update AUTHORS with 47 (!) new authors since 1.0

 AUTHORS |   52 +++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 47 insertions(+), 5 deletions(-)

commit 2f4ddc85a50641a7f6e1f467fa94610875f8ed02
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 5 22:48:27 2007 -0800

    Mark 5 tests that are currently failing as XFAIL (that is, not to be fixed before 1.4)
    
    The 5 additional bugs that will be shipped with 1.4 are
    
    	ft-text-vertical-layout-type1
    	radial-gradient
    	surface-pattern
    	surface-pattern-scale-down
    	surface-pattern-scale-up
    
    Most of these are non-issues, (unbundled font for
    ft-text-vertical-layout-type1), or very minor issues (radial-gradient
    and surface-pattern). The only things in here that look like a real
    bug are the surface-pattern-scale-down and surface-pattern-scale-up
    tests where the xlib backend results have some non-1.0 alpha that is
    very unexpected.

 test/Makefile.am                  |    5 +++++
 test/radial-gradient.c            |    3 ++-
 test/surface-pattern-scale-down.c |    3 ++-
 test/surface-pattern-scale-up.c   |    3 ++-
 test/surface-pattern.c            |    3 ++-
 5 files changed, 13 insertions(+), 4 deletions(-)

commit aa883123d2af905c846a8c0a67ff63fa6b16cd2b
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 5 16:48:05 2007 -0800

    Optimize filling of a path that is a single device-axis-aligned rectangle.
    
    It turns out that this case is extremely common and worth avoiding
    the overhead of the path iteration and tessellation code.
    
    The optimization here works only for device-axis-aligned rectangles
    It should be possible to generalize this to catch more cases, (such
    as any convex quadrilateral with 4 or fewer points).
    
    This fix results in a 1.4-1.8x speedup for the rectangles perf case:
    
    image-rgb  rectangles-512  7.80 1.22% -> 4.35 1.62%: 1.79x speedup
    ▊
    image-rgba rectangles-512  7.71 4.77% -> 4.37 0.30%: 1.77x speedup
    ▊
     xlib-rgba rectangles-512  8.78 5.02% -> 5.58 5.54%: 1.57x speedup
    ▋
     xlib-rgb  rectangles-512 11.87 2.71% -> 8.75 0.08%: 1.36x speedup
    ▍
    
    Which conveniently overcomes the ~ 1.3x slowdown we had been seeing
    for this case since 1.2. Now, compared to 1.2.6 we see only a speedup:
    
    image-rgba rectangles-512  6.19 0.29% -> 4.37 0.30%: 1.42x speedup
    ▎
    image-rgb  rectangles-512  6.12 1.68% -> 4.35 1.62%: 1.41x speedup
    ▎
     xlib-rgba rectangles-512  7.48 1.07% -> 5.58 5.54%: 1.34x speedup
    ▏
     xlib-rgb  rectangles-512 10.35 1.03% -> 8.75 0.08%: 1.18x speedup
    ▏

 src/cairo-path-fill.c |   93 +++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 93 insertions(+)

commit e15bb8efe62a4d2ffd1df31b092ca1fdd2743e43
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Tue Mar 6 00:40:56 2007 +0000

    [quartz] remove unnecessary flushes
    
    Removing calls to CGContextFlush; these were slowing down the
    mac and on other platforms it is up to the client to flush
    the surface.

 src/cairo-quartz-surface.c |    4 ----
 1 file changed, 4 deletions(-)

commit 393908c34dbf2484b811b84581984563a7115e38
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 19:22:41 2007 -0500

    [test] Modify extend-reflect to need a smaller reference image

 test/extend-reflect-ref.png |  Bin 589279 -> 153571 bytes
 test/extend-reflect.c       |   17 ++++++-----------
 2 files changed, 6 insertions(+), 11 deletions(-)

commit 4716ed760c1cc8095587af130964fbc3432ed14d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 19:15:35 2007 -0500

    [test] Remove some ref images from random-intersections
    
    Each one is larger than 100kb, so paint background black to reuse
    same ref image for rgb24 and argb32 cases.  Also remove Quartz ref
    images for now.

 test/Makefile.am                               |    3 ---
 test/random-intersections-ps-argb32-ref.png    |  Bin 107578 -> 89416 bytes
 test/random-intersections-quartz-ref.png       |  Bin 203877 -> 0 bytes
 test/random-intersections-quartz-rgb24-ref.png |  Bin 179204 -> 0 bytes
 test/random-intersections-ref.png              |  Bin 177153 -> 132210 bytes
 test/random-intersections-rgb24-ref.png        |  Bin 132210 -> 0 bytes
 test/random-intersections.c                    |    4 ++++
 7 files changed, 4 insertions(+), 3 deletions(-)

commit feba319413bde73f8c1454fc0f3a1b3af03dfde4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 19:02:59 2007 -0500

    [test] Remove unused variable

 test/clip-operator.c   |    2 --
 test/operator-clear.c  |    2 --
 test/operator-source.c |    2 --
 3 files changed, 6 deletions(-)

commit e1a598211b1944bad6b32148da052208d9b58093
Author: Emmanuel Pacaud <emmanuel.pacaud@lapp.in2p3.fr>
Date:   Mon Mar 5 16:03:40 2007 -0800

    Use the offset attribute to improve cairo-svg handling of EXTEND_REPEAT and EXTEND_REFLECT
    
    With this change, the cairo-svg output is perfectly fine with
    CAIRO_EXTEND_REPEAT, but is still very slightly wrong with
    CAIRO_EXTEND_REFLECT, (though *much* better than it was before
    this fix).

 src/cairo-svg-surface.c |   30 +++++++++++++++++++++++-------
 1 file changed, 23 insertions(+), 7 deletions(-)

commit 47f2bf4e28b80102f10505916be2bf4c01ce9354
Author: Emmanuel Pacaud <emmanuel.pacaud@lapp.in2p3.fr>
Date:   Mon Mar 5 15:57:28 2007 -0800

    Remove broken special-casing of radial gradient fx,fy under CAIRO_EXTEND_NONE
    
    Carl can't explain why he added this special-case, and removing it
    eliminates one failure case from the radial-gradient test matrix.

 src/cairo-svg-surface.c |    9 ++-------
 1 file changed, 2 insertions(+), 7 deletions(-)

commit a724f816e17bfe3d9abefb1f6dcfe30480a0d143
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Mon Mar 5 23:19:24 2007 +0000

    [quartz,atsui] separate the quartz surface and atsui font backend
    
    Make it possible to use the --enable-quartz and --enable-atsui
    independently. Quartz on its own will use the ft font backend.

 configure.in               |   17 +++++++----------
 src/cairo-atsui-font.c     |   12 ++++++------
 src/cairo-quartz-private.h |    8 +++++---
 src/cairo-quartz-surface.c |    8 +++++++-
 4 files changed, 25 insertions(+), 20 deletions(-)

commit 83fcce0e93071cffe20377ab3fe6281204b2f80d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 17:56:57 2007 -0500

    [quartz] Make utility functions static

 src/cairo-quartz-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d25548d679b8a7fce12c9a55e728539e408c75a1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 17:11:39 2007 -0500

    In cairo_append_path(), allow excess path_data elements

 src/cairo-path.c |    8 ++++----
 src/cairo.h      |   11 +++++++++--
 2 files changed, 13 insertions(+), 6 deletions(-)

commit 3ab9ca54aa490438dbbfae7b5f1cde0bd98352cd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 16:33:46 2007 -0500

    In cairo_text_path(), bail out if zero glyphs

 src/cairo.c |    9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit 4f138e4af56da60a83fd187f87cde19544ba3ab1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 16:28:31 2007 -0500

    Uniform object handling in _reference(), _destroy(), and _get_reference_count()
    
    All three now regard NULL and nil inputs the same.  This is new for
    _get_reference_count().  It now returns 0 on NULL too, like it does on
    nil objects.

 src/cairo-font.c        |   12 +++---------
 src/cairo-pattern.c     |   12 +++---------
 src/cairo-scaled-font.c |   12 +++---------
 src/cairo-surface.c     |   12 +++---------
 src/cairo.c             |   12 +++---------
 5 files changed, 15 insertions(+), 45 deletions(-)

commit cc12c5acc41f452edff3f4ad8fafe1aebf1810aa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 16:19:28 2007 -0500

    Make cairo_text_path() set current point correctly
    
    This fixes the bitmap-text test that I just made reveal a bug.

 src/cairo.c |   38 +++++++++++++++++++++++++++++++++-----
 1 file changed, 33 insertions(+), 5 deletions(-)

commit b63f5ae58f6617b9a2c9f3434bc1c9f3c72612ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 16:15:09 2007 -0500

    [test] In the bitmap-font test, break cairo_text_path() call into two
    such that it checks current-point handling after that call.  It fails now,
    because cairo_text_path does not set current-point explicitly.

 test/bitmap-font.c |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit a487d094212d6bc4a06d5bfc774ba6d575165aa5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:59:43 2007 -0500

    Rename all mutex variables to start with an underscore
    since they are not static in some of the implementations (win32, ...)

 src/cairo-beos-surface.cpp |   12 ++++++------
 src/cairo-font.c           |   24 ++++++++++++------------
 src/cairo-ft-font.c        |   12 ++++++------
 src/cairo-os2-surface.c    |   30 +++++++++++++++---------------
 src/cairo-scaled-font.c    |   12 ++++++------
 src/cairo-win32-surface.c  |   18 +++++++++---------
 src/cairoint.h             |    2 +-
 7 files changed, 55 insertions(+), 55 deletions(-)

commit c8b84a4735c46a33620260de0618296df1e12574
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:46:19 2007 -0500

    [beos] Update mutex initializers
    
    This should be the last one.  We are going to move to a central
    mutex initialization scheme right after 1.4.0 is out.

 src/cairo-beos-surface.cpp |    8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit b8e2888fbed2aefa368d9bab4010c1e807d6389f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:45:45 2007 -0500

    [OS2] Add mutex initializer for cairo_font_face_mutex

 src/cairo-os2-surface.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit 403b4b7c163e78446035ec5144ad9e3674577d5d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:39:09 2007 -0500

    [OS2] Remove unused mutex cairo_toy_font_face_hash_table_mutex

 src/cairo-os2-surface.c |    6 ------
 1 file changed, 6 deletions(-)

commit 6358ec539df67ec7725b0687c16f2175386f1b0b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:38:52 2007 -0500

    [WIN32] Make cairo_ft_unscaled_font_map_mutex initialization conditional of ft

 src/cairo-win32-surface.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit 972f7d9fc8d40fb5c698e1a94fba4f28600b215d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:36:51 2007 -0500

    [WIN32] Remove unused mutex cairo_toy_font_face_hash_table_mutex

 src/cairo-win32-surface.c |    3 ---
 1 file changed, 3 deletions(-)

commit 0cdb96544eda163de050c65f7e7cd413b21f61cc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 15:10:35 2007 -0500

    [SVG] Cast -1 values to unsigned to indicate we really did mean to type them

 src/cairo-svg-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bbc341614455b22210c818eca01cf4618989565c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Mar 5 14:51:25 2007 -0500

    [ROADMAP] Remove 1.3.14 items, add 1.4.2 ones

 ROADMAP |   20 +++++++++++++-------
 1 file changed, 13 insertions(+), 7 deletions(-)

commit d6ac9b47704d671c192da509571b3721756c1347
Author: Dave Yeo <daveryeo@telus.net>
Date:   Mon Mar 5 13:36:32 2007 -0500

    [test] Fix build on Win32

 test/Makefile.am |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ffa86b17abbaa2190a4d7eadcc555aac6770bd6c
Author: Mathias Hasselmann <mathias.hasselmann@gmx.de>
Date:   Sun Mar 4 16:39:00 2007 -0500

    [test/pdiff] Fix build problem with certain flavors of make

 test/pdiff/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 325e75239098e640ed05ade39ec2b9f74ae30d3d
Author: Hans Breuer <hans@breuer.org>
Date:   Sat Mar 3 22:50:16 2007 -0800

    Fix mutex initialization for win32 (missing cairo_font_face_mutex)
    
    We've currently got a problem where it's easy to add a mutex
    for a POSIX system and easy to forget to add its intialization
    for other systems. Behdad has cooked up a plan for fixing this
    properly:
    
    	http://lists.freedesktop.org/archives/cairo/2007-February/009679.html
    
    In the meantime, we'll just kkeping breaking things, and patches
    like this will be needed to fix up our mistakes.
    
    This fix closes the following bug report:
    
    	cairo_font_face_mutex missing from cairo-win32-surface.c
    	https://bugs.freedesktop.org/show_bug.cgi?id=10175

 src/cairo-win32-surface.c |    3 +++
 1 file changed, 3 insertions(+)

commit 5f2b5f1f92d74fbc2d8f97fb547e160e370d4c40
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sun Mar 4 03:01:22 2007 +0000

    [configure.in] --enable-quartz should require atsui and no xlib
    
    Recent changes have made quartz and atsui interdependent. It is also
    no longer possible to build quartz with xlib enabled due to a redefinition
    of the 'Picture' symbol. This change makes '--enable-atsui' unnecessary
    and refuses to switch on quartz when it cannot be built because xlib
    is enabled.

 configure.in |   16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit 1720d0b9508b70ac0c5f2436c3b80a2ab801f138
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:42:09 2007 -0500

    [Makefile.am] --enable-test-surfaces in distcheck

 Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 79acd268d9ac91f0e9f03467b220241cda3457a5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:41:32 2007 -0500

    [Makefile.am] Remove releasing instructions that are in RELEASING already

 Makefile.am |   15 ++-------------
 1 file changed, 2 insertions(+), 13 deletions(-)

commit f9f71457a5d1e002f7f6b08232892ba61fef8ead
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:37:45 2007 -0500

    [RELEASING] Update announcement mail instructions

 RELEASING |   11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 454c6a62a93d4d9e933a4e401997a16f1b0a569b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:35:25 2007 -0500

    [RELEASING] Note that two versions should be added to bugzilla

 RELEASING |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 57e1b6fa98d688b72dd3617e8313ea35f8ce78e1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:34:19 2007 -0500

    [RELEASING] Reorder pushing tag and commits
    
    We should push the tag only after pushing the actually release commit.

 RELEASING |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 052acc95e9c354981eea0968c5727e4a0568a959
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 15:32:42 2007 -0500

    [RELEASING] Fix git-tag invocation

 Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f0a1648b7886714e5c742119083414fcc92dc82
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 00:22:53 2007 -0500

    [configure.in] Increase version to 1.3.17 post-release

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b3e1fd8c1cbfc4db88bec4bb52821ed9380dbb4f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 00:07:34 2007 -0500

    [configure.in] Increase version to 1.3.16 in preparation for release

 configure.in |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit c6541b9ac23bcd88202049960ee5a7503a4f0449
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 00:07:03 2007 -0500

    [RELEASING] Add note about ChangeLog sanity

 RELEASING |    2 ++
 1 file changed, 2 insertions(+)

commit 9aecd7c815b81b61ff408d51bdf8e1c6663a3954
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Mar 3 00:05:40 2007 -0500

    [test] Include romedalen.png in dist, oops

 test/Makefile.am |    7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 2f497c25f98cdb4be60b7391a672280ae09f1d67
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 23:59:55 2007 -0500

    [Makefile.am] Check for ChangeLog sanity in release-publish

 Makefile.am |   10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit eb8214c9602319d716b8cd39a1c5dd1dd278b96e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 23:49:27 2007 -0500

    [ChangeLog.mk] Adapt to latest git-describe output format

 ChangeLog.mk |    9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit 8a69a327952173a714dfbe1e8967ebb7bdbbacbd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 23:21:39 2007 -0500

    [test] Update list of refrerence images

 test/Makefile.am |  392 ++++++++++++++++++++++++++++++------------------------
 1 file changed, 216 insertions(+), 176 deletions(-)

commit 55d480612754dca652b5324d815e0429c745fec3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:52:38 2007 -0500

    [NEWS] Add note about documentation improvements

 NEWS |    7 +++++++
 1 file changed, 7 insertions(+)

commit 77b27fd06b9f0e7ff5dedd4b41327e456d33e3cf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:45:50 2007 -0500

    [doc] Update templates

 doc/public/tmpl/cairo-font.sgml        |   33 ++++++++------
 doc/public/tmpl/cairo-pattern.sgml     |   37 ++++++++++++++--
 doc/public/tmpl/cairo-scaled-font.sgml |   31 +++++++++++++
 doc/public/tmpl/cairo-surface.sgml     |   74 ++++++++++++++++++--------------
 doc/public/tmpl/cairo-text.sgml        |   33 ++++++++------
 doc/public/tmpl/cairo.sgml             |   40 +++++++++++++++++
 6 files changed, 188 insertions(+), 60 deletions(-)

commit 1082fed6929a696455f27821819c6af4f575156d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:42:17 2007 -0500

    [doc] Docuemnt all symbols but cairo_filter_t and cairo_operator_t
    
    Lets see if this is enough to push Carl Worth document those two.

 src/cairo-font.c        |    5 +++-
 src/cairo-pattern.c     |    3 ++
 src/cairo-scaled-font.c |    3 ++
 src/cairo-surface.c     |    3 ++
 src/cairo.c             |    3 ++
 src/cairo.h             |   74 +++++++++++++++++++++++++++++++++++++++++++++--
 6 files changed, 88 insertions(+), 3 deletions(-)

commit e37b6ca3e2c55256debf1fdfde83934fa9b28c1d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:03:27 2007 -0500

    Beautify cairo.h

 src/cairo.h |   42 +++++++++++++++++++++---------------------
 1 file changed, 21 insertions(+), 21 deletions(-)

commit 9be961eb0c8c85b04287a5b85f7fd72dac160949
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:01:15 2007 -0500

    [doc] Some documentation love

 src/cairo-font.c          |    2 +-
 src/cairo-pattern.c       |   19 ++++++++++++
 src/cairo-surface.c       |    6 ++--
 src/cairo-win32-font.c    |   24 ++++++++++++--
 src/cairo-win32-surface.c |    1 +
 src/cairo.c               |   76 ++++++++++++++++++++++++++++++++++++++++-----
 src/cairo.h               |   40 +++++++++++++++++++++++-
 7 files changed, 154 insertions(+), 14 deletions(-)

commit 8a6308e1448f402bd4f32b18ba2c60a4bcdbbe6f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 22:00:25 2007 -0500

    [doc] Update list of header files to ignore

 doc/public/Headers.mk |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fed13e77e1de071ddaaf829aced10b02f6bc8c90
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 16:49:47 2007 -0500

    [NEWS] Fix typos

 NEWS |   14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit ab1887f4b08784789f39396b3012dffede845466
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 2 13:30:31 2007 -0800

    [quartz] Bug 3939 - Fix Quartz backend endianness problem
    
    Add kCGBitmapByteOrder32Host to CGImageCreate call in release_dest_image
    of Quartz surface.

 src/cairo-quartz-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2640aa7e99453f17e9a2cb9084e0760d767cfeab
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 13:18:11 2007 -0800

    Add notes for 1.3.16
    
    Now, maybe we won't actually make a 1.3.16 snapshot, but these are all
    the things that will be new in 1.4.0 compared to 1.3.14.

 NEWS |  139 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 139 insertions(+)

commit a0bc2ada784f24ca784617ac18b470745e8152c0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Mar 2 15:45:02 2007 -0500

    [test] Support passing extra valgrind flags
    using EXTRA_VALGRIND_FLAGS make variable or CAIRO_EXTRA_VALGRIND_FLAGS
    env variable.

 test/Makefile.am |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit cd43c03d162efc87a1845c7ffbadfab00ac23d1f
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 12:30:53 2007 -0800

    Fix leak of an output stream in cairo_type1_font_destroy

 src/cairo-type1-fallback.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 8c579ef8354720c06db702db1e6e2aaab0efed82
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 12:30:14 2007 -0800

    More tightening of test cleanup to avoid valgrind complaints.

 test/cairo-test.c          |    8 ++++----
 test/fallback-resolution.c |    2 ++
 test/font-face-get-type.c  |    2 ++
 test/pdf-features.c        |    9 +--------
 test/ps-features.c         |    9 +--------
 test/pthread-show-text.c   |    8 +-------
 6 files changed, 11 insertions(+), 27 deletions(-)

commit 9854d01a8d3a1f9f6148dfd6e22623c4586aaa96
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 11:32:47 2007 -0800

    Fix leak in pattern-getters test (missing cairo_pattern_destroy)

 test/pattern-getters.c |    2 ++
 1 file changed, 2 insertions(+)

commit b52dda62fea0745cc28d6149dc4688ade524b4df
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 11:31:13 2007 -0800

    Augment cairo_test_init with cairo_test_fini to avoid leak
    
    Without this, any tests that were using cairo_test_init rather than
    cairo_test would end up leaking a FILE* for the log file. So this
    keeps valgrind much more happy with the test suite.

 test/cairo-test.c              |    8 +++++++-
 test/cairo-test.h              |   14 +++++++++-----
 test/copy-path.c               |    2 ++
 test/create-for-stream.c       |    2 ++
 test/in-fill-empty-trapezoid.c |    2 ++
 test/multi-page.c              |    2 ++
 test/pattern-get-type.c        |    2 ++
 test/svg-clip.c                |    2 ++
 test/svg-surface.c             |    2 ++
 test/truetype-tables.c         |    2 ++
 test/xlib-surface.c            |   32 +++++++++++++-------------------
 11 files changed, 45 insertions(+), 25 deletions(-)

commit 7d6e21c7e298e1795f36fdf021d61ef4ed0ca0fa
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 11:29:40 2007 -0800

    Add even more XrmGetFileDatabase leaks to the valgrind suppressions file

 test/.valgrind-suppressions |   24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit e054314e5ec1f3fbdc97ed2175dd3d26d7581a5f
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 09:34:46 2007 -0800

    Add a couple of missing test cases to .gitignore

 test/.gitignore |    2 ++
 1 file changed, 2 insertions(+)

commit 02f2ece88dbceaf2466bd61410dd8e88a4c95e08
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 09:32:14 2007 -0800

    Fix leak in pdiff lpyramid
    
    This was a leak in the test suite only, (and then only when tests failed).

 test/pdiff/lpyramid.c |    2 ++
 1 file changed, 2 insertions(+)

commit 6da7f140334835be9a972db75de78d99b8bd24b1
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 03:49:11 2007 -0800

    Fix INVALID_RESTORE case to avoid crashes
    
    Previously, an INVALID_RESTORE error would leave cr->gstate as NULL,
    (which is generally impossible/invalid). This seems safe enough as
    most cairo functions check cr->status first and bail if anything
    looks fishy.
    
    However, the many cairo_get functions happily march along in spite
    of any current error. We could instrument all of those functions to
    check for the error status and return some dummy value in that case.
    But it's much easier to get the same basic effect by simply creating
    a non-NULL cr->gstate which will hold all those dummy values, and
    we can eliminate the crashes without having to touch up every
    cairo_get function.
    
    This fixes the bug reported here:
    
    	evolution crash to _cairo_gstate_backend_to_user()
    	https://bugs.freedesktop.org/show_bug.cgi?id=9906
    
    It also eliminates the crash that was added to the nil-surface test
    with the previous commit.

 src/cairo.c |   10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 36590fd4702cc24acacd20e4394c902e44be46c6
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 03:43:46 2007 -0800

    Add test of cairo_get_* after INVALID_RESTORE to nil-surface
    
    This new test demonstrates a crash condition as reported here:
    
    	evolution crash to _cairo_gstate_backend_to_user()
    	https://bugs.freedesktop.org/show_bug.cgi?id=9906

 test/nil-surface.c |   23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 712447856dc5cf559fcdbceaf902a39fd5eddef9
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 03:15:35 2007 -0800

    Fix yet another backend (quartz) for the gradient renaming
    
    So it looks like it took us three commits before we finally got
    all of the users of inner/outer switched to c1/c2. Hopefully
    someday we'll have the compiler passing over all of cairo's
    source code even if the backends aren't available to be run
    on a particular system.

 src/cairo-quartz-surface.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 4e0f0d9425e2677e75681b2416e7ee4c4e87440c
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 03:11:10 2007 -0800

    Don't crash if backend->create_similar returns a nil surface
    
    This fixes the bug reported here:
    
    	cairo crashes in cairo_create_simular if nil surface returned by other->backend->create_similar
    	https://bugs.freedesktop.org/show_bug.cgi?id=9844

 src/cairo-surface.c |   11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit b0c086fce45a72ea3bf0052641de63bf08e5e5d5
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 02:51:53 2007 -0800

    Update documentation for cairo_get_scaled_font and cairo_get_font_face
    
    There was some leftover cut-and-paste description of get_font_face
    in the documentation for get_scaled_font. That turned out to be a
    good thing as it alerted me to the fact that the get_font_face
    documentation was stale as well.
    
    Add description of the 'nil' object return values, rather than NULL.

 src/cairo.c |   32 +++++++++++++++++++++++---------
 1 file changed, 23 insertions(+), 9 deletions(-)

commit 5f386bb15a234983090beb4f85dfee200dac1b4b
Author: Jeff Muizelaar <jeff@infidigm.net>
Date:   Wed Feb 28 13:37:21 2007 -0500

    Use a closed interval when eliminating outliers from performance measurements
    
    When choosing the samples that are not outliers we use a half-open interval
    (outlier_min <= x < outlier_max). This causes all of the samples to be
    discarded when the interquartile range is 0 because none of them are less
    than outlier_max. Fix the problem and make the test more consistent by
    using a closed interval (outliner_min <= x <= outlier_max).

 perf/cairo-stats.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d48f31370172cddb85ae17a12faed2abf651ee83
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Fri Mar 2 18:37:06 2007 +0800

    glitz: fix build error.
    
    Rename radial gradient inner/outer to c1/c2.

 src/cairo-glitz-surface.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit c12a4571affe9fdd2bb4620c448aded43584bb54
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 00:37:21 2007 -0800

    Cast -1 values to unsigned to quiet the compiler.
    
    Marking the magic values to indicate we really did mean to type them.

 src/cairo-pattern.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 3685a66b5b9cb0af10b44985dc1e9ef1c82ad77b
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 2 00:22:57 2007 -0800

    Cast away a const to quiet a compiler warning.

 src/cairo-ps-surface.c |    7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit d48bb4fbe876a93199ba48fcf5f32734fbe18ba9
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 1 23:34:34 2007 -0800

    Implement CAIRO_MUTEX_INIT with memcpy instead of pthread_mutex_init
    
    The trick here is that with the weak symbol support for pthreads,
    pthread_mutex_init can be a NOP leaving the mutex uninitialized.
    Then, if some pthread-using library is dynamically loaded, the
    non-NOP pthread functions get used and we end up trying to lock
    an uninitialized mutex.
    
    This should fix the bugs reported here:
    
    	Cairo 1.3.14 deadlocks in cairo_scaled_font_glyph_extents or _cairo_ft_unscaled_font_lock_face
    	https://bugs.freedesktop.org/show_bug.cgi?id=10035

 src/cairoint.h |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit df2d42ac7fb71997abd406fb5716c0bd85037c04
Merge: ec11ca3 97dbbae
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 1 17:08:03 2007 -0800

    Merge branch 'radial-gradient-fixes' into cairo

commit ec11ca33a7ebcc752218e63c57f861de6e23a86a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 19:14:40 2007 -0500

    [PS/PDF] Mark CAIRO_EXTEND_PAD for surface patterns as natively supported
    since the image surface does not implement that case either, so image
    fallbacks have no benefit.

 src/cairo-pdf-surface.c |   12 +++++++-----
 src/cairo-ps-surface.c  |   12 +++++++-----
 2 files changed, 14 insertions(+), 10 deletions(-)

commit 4ee6cda6e5e69361d3ca247322c92d0ae30e0458
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 19:13:19 2007 -0500

    [test] Move .la dependencies around

 test/Makefile.am |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit ff06ea1abf2dcfe28a4c1f192782bc85aebfdd92
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 19:12:58 2007 -0500

    [boilerplate] Add correct dependency on libcairo.la

 boilerplate/Makefile.am |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 4b1f450f4cf056b4cc28502dcf72eaf54f257c3a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 18:36:27 2007 -0500

    [test] Add more valgrind suppressions

 test/.valgrind-suppressions |   19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit dcdcb7ac2acf39c54da855b6a2af4d02a7165a24
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 18:36:16 2007 -0500

    Fix leak in rectilinear stroking code
    
    The code was not cleaning up after itself when rejecting a path as
    rectilinear.

 src/cairo-path-stroke.c |   15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit 2acd5b52774e2324df3e6b5b07a0d2790df3a60b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 18:34:53 2007 -0500

    [test] Add leak-revealing path to rectilinear-stroke
    
    Based on this thread:
    http://lists.freedesktop.org/archives/cairo/2007-March/009860.html

 test/rectilinear-stroke.c |    8 ++++++++
 1 file changed, 8 insertions(+)

commit 97dbbae62182c2e40f5f98278e08c92e14b92731
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 1 15:17:19 2007 -0800

    SVG: Support CAIRO_EXTEND_NONE for radial gradients.
    
    This is as simple as adding transparent color stops on either end.

 src/cairo-svg-surface.c |   31 +++++++++++++++++++++++++++----
 1 file changed, 27 insertions(+), 4 deletions(-)

commit bd2cd2c868864d5ec2a2c2e4bf16ff406be8afe2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 18:14:33 2007 -0500

    [test] Plug a leak in the test suite

 test/buffer-diff.c |    1 +
 1 file changed, 1 insertion(+)

commit 7de96a1faabfc2aa84dac38f5b63c2ba3538bb3c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 18:00:23 2007 -0500

    [xlib] Drop XrmFinalize() stuff.  That didn't ever exist in any public X server

 configure.in            |    4 ----
 src/cairo-xlib-screen.c |    5 -----
 2 files changed, 9 deletions(-)

commit fe68e8aa32cc5a9f4d9f9302644ca66d8b691d65
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 28 00:41:47 2007 -0800

    Fix gradient walker to not reset needlessly
    
    Previously the gradient walker was doing excessive resets, (such
    as on every pixel in constant-colored regions or outside the
    gradient with CAIRO_EXTEND_NONE). Don't do that.

 pixman/src/fbcompose.c |   17 ++++++++++-------
 1 file changed, 10 insertions(+), 7 deletions(-)

commit 9a5dfe1415dce9d726c93cd08c532f26512a70ee
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 1 14:53:48 2007 -0800

    Fix implementation of radial gradients for inner radius != 0
    
    The previous implementation fell apart quite badly when neither radius
    value was equal to 0.0. I derived the math from scratch, (much thanks to
    Vincent Torri <vtorri@univ-evry.fr> for guiding me to a simpler derivation
    than I was doing originally), and it's working much better now without
    being any slower, (in fact, cairo-perf shows speedup of 1.05x to 1.58x on
    my laptop here).
    
    This work also provides groundwork for defining the behavior of radial
    gradients where neither circle is wholly contained within the other, (though
    we haven't done that definition yet---it will require a new test case and a
    very little bit of work on the implementation).
    
    This is a fix for the following bug report:
    
    	Radial Gradients with nonzero inner radius misplace stops
    	https://bugs.freedesktop.org/show_bug.cgi?id=7685

 pixman/src/fbcompose.c |  196 ++++++++++++++++++++++++++++++++++++------------
 pixman/src/icimage.c   |   22 ++----
 pixman/src/icimage.h   |   13 ++--
 pixman/src/icint.h     |    1 +
 4 files changed, 165 insertions(+), 67 deletions(-)

commit 0439f4c4f7e7374b4f9699f664fc0e157628b190
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Feb 25 16:01:10 2007 +0100

    Rename radial gradient inner/outer to c1/c2
    
    The inner/outer names were totally bogus. It is quite
    legitimate to have the first circle's radius be larger than
    that of the second.

 pixman/src/icimage.c    |   12 ++++++------
 pixman/src/pixman.h     |    4 ++--
 src/cairo-pattern.c     |   36 ++++++++++++++++++------------------
 src/cairo-pdf-surface.c |   12 ++++++------
 src/cairo-svg-surface.c |   12 ++++++------
 5 files changed, 38 insertions(+), 38 deletions(-)

commit d65455ed3800f9ec3115bbed96a5b2328ee60b57
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Feb 23 07:12:03 2007 +0100

    Add radial-gradient test case
    
    Embarrassingly enough, the test suite previously never called
    into cairo_pattern_create_radial at all. Unsurprisingly, this
    has led to bugs creeping into the radial gradient implementation.

 test/.gitignore              |    1 +
 test/Makefile.am             |    1 +
 test/radial-gradient-ref.png |  Bin 0 -> 91159 bytes
 test/radial-gradient.c       |  110 ++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 112 insertions(+)

commit 17f6174bb2b877447e524715792c7adc84fb25e4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 13:50:23 2007 -0500

    [TODO] Add cairo_surface_copy_page()

 TODO |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit c9ddb86e67154624f08a30599ba6f8d77f731b3a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Mar 1 13:49:13 2007 -0500

    [paginated] Also increase page number in copy_page

 src/cairo-paginated-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit dc0043383b24425282ce38ba06422991c37c1d7e
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Thu Mar 1 23:39:10 2007 +1030

    PDF: Ensure ToUnicode CMap name is unique
    
    and remove an unused printf argument.

 src/cairo-pdf-surface.c |   11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit 7d03fe94d76eee7b3e4bcc274effaa26bc9bd9af
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 17:08:23 2007 -0500

    [RELEASING] Add notifying desktop-devel-list

 RELEASING |    6 ++++++
 1 file changed, 6 insertions(+)

commit 1dd647e26552961d2823ce4ee7cbd354450adf60
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 16:55:30 2007 -0500

    [TODO] Add/remove items

 TODO                            |   49 +++++++++++++++------------------------
 boilerplate/cairo-boilerplate.c |    1 +
 2 files changed, 20 insertions(+), 30 deletions(-)

commit d0fe666a6ab1664af36a7b242d763c72f4e9f81b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 14:58:57 2007 -0500

    Revert the solid-pattern cache
    
    This reverts the following commits:
    
    	2715f2098127d04d2f9e304580a26cd0842c0e64
    	67e3b3c53bdd69e4d3503eed2db66953f1ac038c
    
    See this thread for an analysis of the problems it caused:
    
    	http://lists.freedesktop.org/archives/cairo/2007-February/009825.html
    
    In short, a single cache for all backends doesn't work, as one thread
    using any backend can cause an unused xlib pattern to be evicted from
    the cache, and trigger an xlib call while the display is being used
    from another thread.  Xlib is not prepared for this.

 src/cairo-color.c            |    7 ----
 src/cairo-debug.c            |    2 -
 src/cairo-directfb-surface.c |   12 +-----
 src/cairo-glitz-surface.c    |   24 +----------
 src/cairo-pattern.c          |   91 ++++--------------------------------------
 src/cairo-surface.c          |   26 ------------
 src/cairo-win32-surface.c    |   13 +-----
 src/cairo-xcb-surface.c      |   17 +-------
 src/cairo-xlib-surface.c     |   17 +-------
 src/cairoint.h               |   15 -------
 10 files changed, 12 insertions(+), 212 deletions(-)

commit 5f5afac8f470ae13ab2827f04e05ca585d69b898
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 14:32:11 2007 -0500

    [boilerplate/test-paginated] Issue a show_page before writing buffer
    
    This is needed since cairo-test does not issue a show_page now, and
    the one coming from paginated layer is too late (around finish).
    
    The way we force the show_page is kinda funny.  That is, we create
    a temporary cairo_t and call cairo_show_page() on it.  But works.

 boilerplate/cairo-boilerplate.c |    5 +++++
 1 file changed, 5 insertions(+)

commit efe8c82738bd417402a18871c40cf831e4df31e4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 14:19:18 2007 -0500

    [paginated] Also do an automatic show page if nothing ever drawn
    
    That is, we always emit at least one page of output.  Otherwise our
    PS/PDF/SVG files would be corrupt, and output with zero pages does
    not make much sense.

 src/cairo-paginated-surface.c |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 07d61af8093be501e93d64cc7df69f95ecb83b6c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 28 13:46:27 2007 -0500

    [paginated] Automatically issue a final cairo_show_page()
    
    This means, PS/PDF/SVG do not need the final cairo_show_page() anymore.
    If there is any drawing in the page, a cairo_show_page() is done
    automatically.

 src/cairo-paginated-surface.c |   18 +++++++++++++-----
 test/cairo-test.c             |    2 --
 2 files changed, 13 insertions(+), 7 deletions(-)

commit d30178b3dcebcdd89dc773881fc1b9097f1f50a7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 20:22:05 2007 -0500

    [doc] Add new APIs to cairo-sections.txt

 doc/public/cairo-sections.txt |   27 +++++++++++++++++++--------
 1 file changed, 19 insertions(+), 8 deletions(-)

commit ef53465a032a74fd50b7edaef19cae08586f44d4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 20:18:16 2007 -0500

    Slim-hidden cairo_scale()

 src/cairo.c    |    1 +
 src/cairoint.h |    1 +
 2 files changed, 2 insertions(+)

commit ed75e24898a5ccd7836596122b9a801294122874
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 20:09:22 2007 -0500

    Implement cairo_get_scaled_font()

 TODO                          |    2 --
 doc/public/cairo-sections.txt |    7 ++++---
 src/cairo-gstate.c            |   15 +++++++++++++++
 src/cairo-scaled-font.c       |    2 +-
 src/cairo.c                   |   30 ++++++++++++++++++++++++++++++
 src/cairo.h                   |    3 +++
 src/cairoint.h                |    5 +++++
 test/font-face-get-type.c     |   14 ++++++++++++--
 8 files changed, 70 insertions(+), 8 deletions(-)

commit d64b194a45d90b24d1cc01de0fa2cb4edc3a240b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 20:03:26 2007 -0500

    [quartz] Remove comment syntax that is recognized by gtkdoc from regular comments

 src/cairo-quartz-surface.c |   24 ++++++++++++------------
 1 file changed, 12 insertions(+), 12 deletions(-)

commit 65ab63cb8dc1da949dc831691cf1db5b6b92d749
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 19:45:10 2007 -0500

    [cairo.c] Reorder some function implementations for clarity

 src/cairo.c |   56 ++++++++++++++++++++++++++++----------------------------
 1 file changed, 28 insertions(+), 28 deletions(-)

commit ed933a199c07997cf1dfb5ef2e345d754e2433f3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 19:43:18 2007 -0500

    [cairo.h] Reorder function prototypes a bit for clarity

 src/cairo.h |   20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 153465bfe5346b9e1ebdbd4f794bd11868ee7458
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 19:28:37 2007 -0500

    [test] Add ref images for new tests

 test/surface-pattern-scale-down-pdf-argb32-ref.png |  Bin 0 -> 1565 bytes
 test/surface-pattern-scale-down-ps-argb32-ref.png  |  Bin 0 -> 1400 bytes
 test/surface-pattern-scale-down-ref.png            |  Bin 0 -> 1784 bytes
 test/surface-pattern-scale-down.c                  |    3 +--
 test/surface-pattern-scale-up-pdf-argb32-ref.png   |  Bin 0 -> 3886 bytes
 test/surface-pattern-scale-up-ps-argb32-ref.png    |  Bin 0 -> 1011 bytes
 test/surface-pattern-scale-up-ref.png              |  Bin 0 -> 3825 bytes
 test/surface-pattern-scale-up.c                    |    3 +--
 test/surface-pattern.c                             |    3 +--
 9 files changed, 3 insertions(+), 6 deletions(-)

commit e2ce27db302a185e6e80ead699c01e43921939ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 18:47:47 2007 -0500

    [PS/PDF] Fix xstep/ystep values for CAIRO_EXTEND_NONE
    
    This fixes the fallback-resolution test, as well as the two of
    surface-pattern-scale-up and surface-pattern-scale-down.

 src/cairo-pdf-surface.c |   36 +++++++++++++++---------------------
 src/cairo-ps-surface.c  |   43 ++++++++++++++++++++++++++++---------------
 2 files changed, 43 insertions(+), 36 deletions(-)

commit de0a6522b00822305fa5a0e32c4821628425ebdc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 17:33:17 2007 -0500

    [test] Add tests that show xstep/ystep failures in PS/PDF backends
    with surface patterns.  One test scaled the pattern up, another scales
    down.  We observe that both PS and PDF are broken when scaling down.
    This is the reason that PDF is failing in the fallback-resolution test
    too.

 test/.gitignore                   |    2 ++
 test/Makefile.am                  |    2 ++
 test/surface-pattern-scale-down.c |   69 +++++++++++++++++++++++++++++++++++++
 test/surface-pattern-scale-up.c   |   69 +++++++++++++++++++++++++++++++++++++
 4 files changed, 142 insertions(+)

commit 4c1d788219ae62bb9e8a7723d5a73d70eb42e69a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 27 13:33:53 2007 -0500

    [Makefile.am] Remove ChangeLog.cache-* in distclean

 ChangeLog.mk |    2 ++
 1 file changed, 2 insertions(+)

commit 7185c00e15aecf14d1957ba2e4f386ecb4e2a635
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 16:21:28 2007 -0500

    [PS] Add note about possible need for fix.

 src/cairo-ps-surface.c |    5 +++++
 1 file changed, 5 insertions(+)

commit aa3ebdbd01eb27e205b44728f9f5d9332c5ad450
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 16:19:04 2007 -0500

    [TODO] More TODO items

 TODO |   15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit 38b590d8b7f1f955653bca5cf4cceb723e173ade
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 16:18:00 2007 -0500

    [SVG] Fix warnings

 src/cairo-svg-surface.c |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 69edcd4623ae4e1ef16c5a8d16a5ebd0c79d685f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 16:15:44 2007 -0500

    [SVG] Rename a local variable for clarity

 src/cairo-svg-surface.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 11b3f43e927919a46909900a63386a1af788529a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 16:14:37 2007 -0500

    [TODO] Add various TODO items

 src/cairo-image-surface.c |    1 +
 src/cairo-pattern.c       |    1 +
 2 files changed, 2 insertions(+)

commit 2d908e6a957c8b1e7f369621aaace2fc7277a941
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 18:24:19 2007 -0500

    [test] Add a new, XFAIL, extend-pad test

 test/.gitignore         |    1 +
 test/Makefile.am        |    3 ++
 test/extend-pad-ref.png |  Bin 0 -> 616 bytes
 test/extend-pad.c       |   74 +++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 78 insertions(+)

commit 289ac33fa28216cc6cc3e3d415cc4ff96cb17e12
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 18:23:10 2007 -0500

    [PS] Fix surface patterns with transforms
    
    Previously we were generating an image object with the desired
    transform and then a pattern with only a translation.  This means,
    the pattern was alwasys axis-aligned.  Obviously this does not
    work correctly with repeated rotated patterns.
    
    We now use an identity matrix for the image and put all the
    pattern transformation (well, it's inverse) into the pattern.
    This fixes the issue nicely.
    
    The surface-pattern test is still failing even with a reference
    image, because the gs rendering of the normal case and the
    device-offset=25 case are different and both have seams.

 src/cairo-ps-surface.c                 |   42 +++++++++++---------------------
 test/surface-pattern-ps-argb32-ref.png |  Bin 0 -> 2520 bytes
 2 files changed, 14 insertions(+), 28 deletions(-)

commit 16013ced09c8d6e2a967b9192f8545716a423504
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 18:07:22 2007 -0500

    [test] Remove non-existing test extend-pad

 test/Makefile.am |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit c87edd9e10c2a60e11c8cd954860fb03f6425132
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 16:03:47 2007 -0500

    [test] Update surface-pattern test to include transformations
    
    The surface-pattern test was very naive, painting a surface pattern
    repeated at identity size.  With the new test, the surface pattern
    is scaled and rotated.  This reveals a serious bug in the PS backend.

 test/surface-pattern-pdf-argb32-ref.png |  Bin 0 -> 14880 bytes
 test/surface-pattern-ref.png            |  Bin 194 -> 11439 bytes
 test/surface-pattern-svg-ref.png        |  Bin 0 -> 17663 bytes
 test/surface-pattern.c                  |   94 ++++++++++++++-----------------
 4 files changed, 43 insertions(+), 51 deletions(-)

commit 7c39276366f91de151c775fa8293783f39247896
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 13:40:55 2007 -0500

    [PS/PDF] Accept CAIRO_EXTEND_REFLECT surface patterns natively
    
    With the hack in _cairo_pattern_acquire_surface to return a 2x2
    surface for reflected patterns, we can now accept REFLECT surface
    patterns natively in all backends.  SVG was already doing that.
    The PDF case needed some changes to go through
    _cairo_pattern_acquire_surface.  A similar change to the recent
    change in SVG.

 src/cairo-pdf-surface.c |   19 +++++++++++++++----
 src/cairo-ps-surface.c  |    4 ++--
 2 files changed, 17 insertions(+), 6 deletions(-)

commit 3405fb870e520bcc5588602317693837b59d1ee4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 13:10:34 2007 -0500

    [test] Increase size of extend-reflect test to see that pattern repeats

 test/Makefile.am            |    1 +
 test/extend-reflect-ref.png |  Bin 287611 -> 589279 bytes
 test/extend-reflect.c       |    2 +-
 3 files changed, 2 insertions(+), 1 deletion(-)

commit 63c011bb6bcbe484915b5bb28da087b14bd572a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 18:29:25 2007 -0500

    [surface] Copy device_transform_inverse in _cairo_surface_clone_similar

 src/cairo-surface.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 3516d8092b6297b8e4a3919c09e47f2bd4dd600a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 18:13:16 2007 -0500

    [SVG] Use _cairo_pattern_acquire_surface instead of _cairo_surface_acquire_source_image
    
    This change is required for the upcoming hack to support
    CAIRO_EXTEND_REFLECT.  In short, the idea is that the surface returned
    by _cairo_pattern_acquire_surface may look different from the one
    returned by _cairo_surface_acquire_source_image, to support some pattern
    modes not supported by the backends directly.

 src/cairo-svg-surface.c |   23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

commit 8d812ae9a670b2eeff4f0508e2c8c082e7900a7c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 14:13:33 2007 -0500

    [cairo-pattern] Correctly delegate device_transform so tests pass again

 src/cairo-pattern.c |    7 +++++++
 1 file changed, 7 insertions(+)

commit 7cbfb9556d869310c48c106a9929c292110685ce
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 12:56:05 2007 -0500

    [cairo-pattern] Fall back on cairo_surface_create_similar in _cairo_pattern_acquire_surface_for_surface
    
    This was needed for SVG backend because it does not implement clone_similar.
    However, I'm worried about possible infinite recursion here.  Not sure what
    to do.

 src/cairo-pattern.c |   18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 5562050bcf68923986b597f3aca1e285a466fa6c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 18:16:34 2007 -0500

    Support CAIRO_EXTEND_REFLECT on surface patterns
    
    We do this through a hack, that is, we make
    _cairo_pattern_acquire_surface to return a surface that has four
    copies of the original surface painted such that this image can
    be simply repeated to get the effect of reflecting the original
    surface.
    
    This fixes the formerly XFAIL test extend-reflect.

 src/cairo-pattern.c         |   58 ++++++++++++++++++++++++++++++++++++++++++-
 test/Makefile.am            |    2 +-
 test/extend-reflect-ref.png |  Bin 287611 -> 287611 bytes
 test/extend-reflect.c       |    4 +--
 4 files changed, 59 insertions(+), 5 deletions(-)

commit 81935bb13120898a8581d8266041d3292558710a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 18:06:02 2007 -0500

    [PS] Update surface_pattern_supported() from PDF
    
    The PS backend was accepting all surface patterns, just to ASSERT_NOT_REACHED
    later if extend type of the pattern was PAD or REFLECT.  That didn't make
    sense and was causing crash for PAD (surprisingly not for REFLECT.  Not sure
    why).  So now it rejects those types of surface patterns, just like the PDF
    surface does.

 src/cairo-ps-surface.c |   24 +++++++++++++++++++++++-
 1 file changed, 23 insertions(+), 1 deletion(-)

commit 4e30919f30e7618dbb62d7de2931efaac26c1785
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 18:03:52 2007 -0500

    [cairo-surface] Do not err on CAIRO_EXTEND_PAD and CAIRO_EXTEND_REFLECT
    
    for surface patterns.
    
    Right before releasing cairo 1.2, Carl and I decided to return error on
    CAIRO_EXTEND_PAD and CAIRO_EXTEND_REFLECT for surface patterns, as they
    are not implemented and one was causing crashes.  Well, that was probably
    the worst decision we could make (other than ignoring the problem).  A
    much better decision would have been to make them act like
    CAIRO_EXTEND_NONE and CAIRO_EXTEND_REPEAT respectively.  Anyway, remove
    the error paths.

 src/cairo-surface.c |   30 ------------------------------
 1 file changed, 30 deletions(-)

commit a57bc6b6973a270ef85d73089ebd9d10b3bc5aa8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 17:59:28 2007 -0500

    [test] Add ref image for extend-reflect

 test/extend-reflect-ref.png |  Bin 0 -> 287611 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 5a72aac5982015a2b237afeb13164e0c5f5185ed
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Feb 23 14:24:04 2007 -0800

    [core] put back REF_COUNT_INVALID to be -1, fix finish
    
    Previous commit broke cairo_surface_finish, since it was checking for
    ref_count == CAIRO_REF_COUNT_INVALID and bailing.  But, that condition
    was reached from destroy, so finish was bailing out early.

 src/cairo-font.c        |    3 +++
 src/cairo-pattern.c     |    3 +++
 src/cairo-scaled-font.c |    3 +++
 src/cairo-surface.c     |    3 +++
 src/cairo.c             |    3 +++
 src/cairoint.h          |    2 +-
 6 files changed, 16 insertions(+), 1 deletion(-)

commit cf7311852298e7d86d065a12fa962ba10fe60dcc
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Feb 23 13:05:18 2007 -0800

    [core] Add user_data and reference count getters to all objects
    
    user_data setters/getters were added to public refcounted objects
    that were missing them (cairo_t, pattern, scaled_font).  Also,
    a refcount getter (cairo_*_get_reference_count) was added to all
    public refcounted objects.

 src/cairo-font.c        |   18 +++++++++++
 src/cairo-pattern.c     |   76 +++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-private.h     |    2 ++
 src/cairo-scaled-font.c |   78 +++++++++++++++++++++++++++++++++++++++++++++--
 src/cairo-surface.c     |   17 +++++++++++
 src/cairo.c             |   75 +++++++++++++++++++++++++++++++++++++++++++++
 src/cairo.h             |   45 +++++++++++++++++++++++++++
 src/cairoint.h          |   17 ++++++-----
 8 files changed, 319 insertions(+), 9 deletions(-)

commit 67e3b3c53bdd69e4d3503eed2db66953f1ac038c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 23 10:59:57 2007 -0500

    [xlib/xcb] Check for same_screen in is_compatible
    
    Two drawables can be used in an X and Render operation only if they share
    the same screen.  Previously we were only checking for the same display
    in is_compatible.  Check for the same screen now.

 src/cairo-xcb-surface.c  |    2 +-
 src/cairo-xlib-surface.c |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit a1e5b91588a4f51c03487b480f13c100d07f64f8
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 23 22:55:29 2007 +1030

    Subsetting: Add check for malloc() error

 src/cairo-scaled-font-subsets.c |    9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 27312591fe7ce14f65aac88ee7206ddcf3cbd0b1
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 23 22:14:42 2007 +1030

    Win32: Fix _cairo_win32_scaled_font_map_glyphs_to_unicode return type

 src/cairo-win32-font.c |    6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 3b168e45510e02caf54e4b3cd0df76df6420d304
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 22 23:14:58 2007 -0500

    [FreeType] Truely return unhinted advance width if metrics hinting is off
    
    David Turner said:
    The returned 26.6 advance is always rounded, even with FT_LOAD_NO_HINTING.
    You can however retrieve the linearly scaled value as a 16.16 fixed float
    number through face->glyph->linearHoriAdvance. This works even with hinted
    glyphs.

 src/cairo-ft-font.c |   15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit 0ff5192e4cb5b1113bed3c9cf1c0275065aafd14
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 15:57:21 2007 -0500

    [Makefile.am] Include boilerplate/ in SUBDIRS

 Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1bc1f8ef46a27aa21f8d29b39e645ee5a0e95cda
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Wed Feb 21 23:23:32 2007 +0100

    Set overflow to visible for symbols.
    
    It makes viewers implementing correctly the SVG specification show texts.

 src/cairo-svg-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7d91c8a2cb3f2a5e0afe0d0c90956add51a4e27c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 15:47:43 2007 -0500

    [test] Fix syntax typo in text-rotate

 test/text-rotate.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 155a1b48f6c8265ad5dd594354b66b3e8341bade
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 13:52:17 2007 -0500

    [test] Remove text-rotate test from XFAIL as the bugs are fixed now
    
    All missing is subpixel text positioning, but we don't need an XFAIL test
    to remind us for that.

 test/Makefile.am                   |    6 +++---
 test/text-rotate-ps-argb32-ref.png |  Bin 0 -> 7198 bytes
 test/text-rotate-ref.png           |  Bin 12300 -> 17775 bytes
 test/text-rotate-rgb24-ref.png     |  Bin 5640 -> 0 bytes
 test/text-rotate-svg-ref.png       |  Bin 0 -> 18301 bytes
 test/text-rotate.c                 |   12 +++++++++++-
 6 files changed, 14 insertions(+), 4 deletions(-)

commit b54174e917e273143455661d565412fb9a185bfb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 13:43:08 2007 -0500

    [PS] Fix rotated image pattern emission by correcting setting the bbox
    
    The bug was that the bounding box of the image was computed by transforming
    the vector (width,height) and then using 0,0,width,height as the bounding box.
    This is obviously wrong.  We use _cairo_matrix_transform_bounding_box() now.
    This fixes the XFAIL test rotate-image-surface-paint.

 src/cairo-ps-surface.c                            |   31 ++++++++++++++-------
 test/Makefile.am                                  |    1 -
 test/rotate-image-surface-paint-ps-argb32-ref.png |  Bin 0 -> 276 bytes
 3 files changed, 21 insertions(+), 11 deletions(-)

commit 6ae4a4fd71b030376ec373f2a787eac32b21d7f3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 12:57:09 2007 -0500

    [test] Remove ft-text-vertical-layout-type1 from XFAIL
    and update reference images.  This test was fixed some time ago
    where I disabled type1 subsetting for vertical layouts, then
    turned XFAIL again when Carl Worth didn't have the same fonts as me.
    I've not updated reference images to work on FC6 and hoping that it
    works for Carl too.

 test/Makefile.am                               |    1 -
 test/ft-text-vertical-layout-type1-ref.png     |  Bin 3970 -> 3960 bytes
 test/ft-text-vertical-layout-type1-svg-ref.png |  Bin 3948 -> 3934 bytes
 3 files changed, 1 deletion(-)

commit c6a067f967f9b92328e7d1ca2a4eba6fb4c6dfdf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 21 11:50:24 2007 -0500

    [test] Add test case for bug #7965 to the get-path-extents test

 test/get-path-extents.c |   13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 363b1a40b5719582c670bdb9e7cd8087bcbf9666
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 20 16:18:27 2007 -0800

    [quartz] Remove (disabled) support for rendering via AGL/CGGL

 src/cairo-quartz-private.h |   10 -----
 src/cairo-quartz-surface.c |  106 ++------------------------------------------
 src/cairo-quartz.h         |   11 -----
 3 files changed, 3 insertions(+), 124 deletions(-)

commit e4a1410514471c2cb290d691ca77c4ab24a6541c
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 20 16:16:18 2007 -0800

    [quartz] Rename public function parameter from surf -> surface

 src/cairo-quartz-surface.c |    8 ++++----
 src/cairo-quartz.h         |    2 +-
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 28c1e46b8e082f65fc94c984ea3b66df5adaa529
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 20 13:22:11 2007 -0800

    [quartz] rename test override images from nquartz to quartz

 test/caps-joins-alpha-nquartz-ref.png                 |  Bin 2466 -> 0 bytes
 test/caps-joins-alpha-quartz-ref.png                  |  Bin 0 -> 2466 bytes
 test/clip-nesting-nquartz-ref.png                     |  Bin 1067 -> 0 bytes
 test/clip-nesting-nquartz-rgb24-ref.png               |  Bin 956 -> 0 bytes
 test/clip-nesting-quartz-ref.png                      |  Bin 0 -> 1067 bytes
 test/clip-nesting-quartz-rgb24-ref.png                |  Bin 0 -> 956 bytes
 test/clip-push-group-nquartz-ref.png                  |  Bin 203 -> 0 bytes
 test/clip-push-group-quartz-ref.png                   |  Bin 0 -> 203 bytes
 test/clip-twice-nquartz-ref.png                       |  Bin 1171 -> 0 bytes
 test/clip-twice-nquartz-rgb24-ref.png                 |  Bin 1111 -> 0 bytes
 test/clip-twice-quartz-ref.png                        |  Bin 0 -> 1171 bytes
 test/clip-twice-quartz-rgb24-ref.png                  |  Bin 0 -> 1111 bytes
 test/dash-caps-joins-nquartz-ref.png                  |  Bin 4727 -> 0 bytes
 test/dash-caps-joins-quartz-ref.png                   |  Bin 0 -> 4727 bytes
 test/degenerate-path-nquartz-rgb24-ref.png            |  Bin 188 -> 0 bytes
 test/degenerate-path-quartz-rgb24-ref.png             |  Bin 0 -> 188 bytes
 test/fill-and-stroke-alpha-add-nquartz-ref.png        |  Bin 603 -> 0 bytes
 test/fill-and-stroke-alpha-add-quartz-ref.png         |  Bin 0 -> 603 bytes
 test/fill-and-stroke-alpha-nquartz-ref.png            |  Bin 550 -> 0 bytes
 test/fill-and-stroke-alpha-quartz-ref.png             |  Bin 0 -> 550 bytes
 test/fill-and-stroke-nquartz-ref.png                  |  Bin 286 -> 0 bytes
 test/fill-and-stroke-nquartz-rgb24-ref.png            |  Bin 264 -> 0 bytes
 test/fill-and-stroke-quartz-ref.png                   |  Bin 0 -> 286 bytes
 test/fill-and-stroke-quartz-rgb24-ref.png             |  Bin 0 -> 264 bytes
 test/fill-degenerate-sort-order-nquartz-ref.png       |  Bin 2470 -> 0 bytes
 test/fill-degenerate-sort-order-nquartz-rgb24-ref.png |  Bin 2098 -> 0 bytes
 test/fill-degenerate-sort-order-quartz-ref.png        |  Bin 0 -> 2470 bytes
 test/fill-degenerate-sort-order-quartz-rgb24-ref.png  |  Bin 0 -> 2098 bytes
 test/fill-rule-nquartz-ref.png                        |  Bin 2079 -> 0 bytes
 test/fill-rule-nquartz-rgb24-ref.png                  |  Bin 1790 -> 0 bytes
 test/fill-rule-quartz-ref.png                         |  Bin 0 -> 2079 bytes
 test/fill-rule-quartz-rgb24-ref.png                   |  Bin 0 -> 1790 bytes
 test/new-sub-path-nquartz-ref.png                     |  Bin 386 -> 0 bytes
 test/new-sub-path-nquartz-rgb24-ref.png               |  Bin 357 -> 0 bytes
 test/new-sub-path-quartz-ref.png                      |  Bin 0 -> 386 bytes
 test/new-sub-path-quartz-rgb24-ref.png                |  Bin 0 -> 357 bytes
 test/operator-clear-nquartz-ref.png                   |  Bin 1195 -> 0 bytes
 test/operator-clear-nquartz-rgb24-ref.png             |  Bin 1244 -> 0 bytes
 test/operator-clear-quartz-ref.png                    |  Bin 0 -> 1195 bytes
 test/operator-clear-quartz-rgb24-ref.png              |  Bin 0 -> 1244 bytes
 test/random-intersections-nquartz-ref.png             |  Bin 203877 -> 0 bytes
 test/random-intersections-nquartz-rgb24-ref.png       |  Bin 179204 -> 0 bytes
 test/random-intersections-quartz-ref.png              |  Bin 0 -> 203877 bytes
 test/random-intersections-quartz-rgb24-ref.png        |  Bin 0 -> 179204 bytes
 test/rel-path-nquartz-ref.png                         |  Bin 212 -> 0 bytes
 test/rel-path-nquartz-rgb24-ref.png                   |  Bin 228 -> 0 bytes
 test/rel-path-quartz-ref.png                          |  Bin 0 -> 212 bytes
 test/rel-path-quartz-rgb24-ref.png                    |  Bin 0 -> 228 bytes
 test/source-clip-scale-nquartz-ref.png                |  Bin 148 -> 0 bytes
 test/source-clip-scale-quartz-ref.png                 |  Bin 0 -> 148 bytes
 test/trap-clip-nquartz-ref.png                        |  Bin 5814 -> 0 bytes
 test/trap-clip-nquartz-rgb24-ref.png                  |  Bin 5385 -> 0 bytes
 test/trap-clip-quartz-ref.png                         |  Bin 0 -> 5814 bytes
 test/trap-clip-quartz-rgb24-ref.png                   |  Bin 0 -> 5385 bytes
 54 files changed, 0 insertions(+), 0 deletions(-)

commit be451cd83d8178bfaf28a1c7dec59601d97cff8d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 20 12:54:03 2007 -0800

    [quartz] rename NQUARTZ -> QUARTZ in defines

 perf/cairo-perf.c          |    1 -
 src/cairo-quartz-private.h |    4 +++-
 src/cairo-quartz-surface.c |   18 +++++++++---------
 src/cairo-quartz.h         |   10 +++++-----
 4 files changed, 17 insertions(+), 16 deletions(-)

commit 4c201723ce8139c2e6620881583bc08e3aa1bad7
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 20 12:15:35 2007 -0800

    [quartz] Rename nquartz to quartz

 boilerplate/cairo-boilerplate.c |   47 +-
 configure.in                    |    7 -
 src/Makefile.am                 |    6 -
 src/cairo-atsui-font.c          |   33 +-
 src/cairo-nquartz-surface.c     | 1864 --------------------------------------
 src/cairo-nquartz.h             |   80 --
 src/cairo-quartz-private.h      |   30 +-
 src/cairo-quartz-surface.c      | 1899 ++++++++++++++++++++++++++++++++++++---
 src/cairo-quartz.h              |   39 +-
 src/cairo.h                     |    1 -
 test/get-clip.c                 |    3 +-
 11 files changed, 1819 insertions(+), 2190 deletions(-)

commit 641f0919d53691e561aa665d31cc43524d861215
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Feb 21 00:32:07 2007 +1030

    PDF/PS: Don't embed multiple copies of the same font
    
    cairo-scaled-font-subsets stores two sets of subsets -
    scaled and unscaled. The first time each glyph is mapped,
    _cairo_scaled_glyph_lookup() is called to determine if
    the glyph is bitmap or outline. Outline glyphs are put
    in the unscaled subsets. Bitmap glyphs are put in the
    scaled subsets. The unscaled subsets hash table keyed is
    the scaled_font->font_face to ensure only one font for
    each font face is created. The scaled subsets hash
    table is keyed by scaled_font.
    
    _cairo_scaled_font_subsets_create() now takes two arguments
    to specify the maximum size of the scaled and unscaled subsets.
    If the unscaled max size is set to 0 all glyphs are mapped
    to scaled subsets.
    
    A separate foreach function is provided for scaled and unscaled
    subsets. The PDF and PS backends iterate over the unscaled
    subsets to emit CFF, TrueType, and Type1 fonts. The scaled
    subsets are iterated to emit Type3 bitmap fonts.

 src/cairo-pdf-surface.c                 |   24 +++-
 src/cairo-ps-surface.c                  |   24 +++-
 src/cairo-scaled-font-subsets-private.h |   61 ++++++--
 src/cairo-scaled-font-subsets.c         |  235 +++++++++++++++++++++++++------
 src/cairo-svg-surface.c                 |    8 +-
 5 files changed, 288 insertions(+), 64 deletions(-)

commit f65c33edbecc1f0e285814995dc1a51748310e36
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 20 01:00:53 2007 -0500

    [win32] Make win32-surface compile without win32-font
    
    Hacking on the win32 code, thanks to winelib.  Yay!

 src/cairo-win32-surface.c |    8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 2335a23a16d84e6ebdde7afbeb1fbceb3bdbe6b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 20 01:00:17 2007 -0500

    [test/Makefile.am] Document why svg2png and pdf2png use LDADD
    
    This is to make librsvg and poppler to use the compiled cairo instead
    of whatever is on the system, such that the test suite does not depend
    on a good version of cairo being installed already.

 test/Makefile.am |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 8133530ae5848b0a34c299e0c71360931fe383df
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 20 00:57:25 2007 -0500

    [configure] Improve win32 detection
    
    We now test for windows.h availability to automatically enable win32
    backends.  This nicely enables compiling cairo against libwine by just
    setting CC=winegcc LD=winegcc during configure.  This currently only
    generates static libs though.

 configure.in    |   27 ++++++++++++++++++---------
 src/Makefile.am |    7 +++++--
 2 files changed, 23 insertions(+), 11 deletions(-)

commit 0fcd6cfe0edff25ad3d11af056ba611bd8d9d8c8
Author: Jeff Smith <whydoubt@yahoo.com>
Date:   Mon Feb 19 16:06:57 2007 -0500

    Clean up some inconsistent spacing in the stroking code

 src/cairo-path-stroke.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 89010db3ad3ce0a9afaf28fd313da86ebc864c7c
Author: Jeff Smith <whydoubt@yahoo.com>
Date:   Mon Feb 19 16:06:57 2007 -0500

    Add or reword several comments in the stroking code

 src/cairo-path-stroke.c |   14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit adb573d0bafd7b555bda0effcbd94b9144981ad6
Author: Jeff Smith <whydoubt@yahoo.com>
Date:   Mon Feb 19 16:06:57 2007 -0500

    Minor changes to shorten the stroking code

 src/cairo-path-stroke.c |   26 +++++++++-----------------
 1 file changed, 9 insertions(+), 17 deletions(-)

commit fb29fddd40aeb4c2f1a42f88eddec5c06adf0583
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:57 2007 -0500

    Rename tmp to step_length because that is what it actually is.

 src/cairo-path-stroke.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit afd5f92195335a88d7c1ff181a1bd03ca01b424f
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:57 2007 -0500

    Fix several issues with dashed stroking code, particularly 'leaky-dash'
    
    Adds some state, 'dash_starts_on', to keep track of whether a dashed path
    starts with dash_on or not. This fixes the 'leaky-dash' bug (#4863) and
    some other degenerate cases. The new version is, in my opinion,
    considerably cleaner and more understandable than the old code.
    
    Finally, the rewrite changes the behaviour of dashing to add degenerate
    caps around corners that start at the same place as a dash begins. This
    matches the behaviour seen in acroread.
    
    This rewrite is based on an initial rewrite done by Jeff Smith.

 src/cairo-path-stroke.c           |   85 +++++++++++++++++--------------------
 test/Makefile.am                  |    1 -
 test/dash-caps-joins-ref.png      |  Bin 4680 -> 4718 bytes
 test/dash-scale-ref.png           |  Bin 7791 -> 7908 bytes
 test/leaky-dash-ps-argb32-ref.png |  Bin 0 -> 286 bytes
 test/leaky-dash-ref.png           |  Bin 241 -> 243 bytes
 6 files changed, 39 insertions(+), 47 deletions(-)

commit 78ae474d96b48ccba3d18dc26c416ebd6daab502
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Rename has_sub_path to has_initial_sub_path
    
    has_initial_sub_path more accurately describes the condition we want to
    track. This flag is used to indicate when an initial sub_path needs capping
    but has no associated slope and thus no associated faces.

 src/cairo-path-stroke.c |   16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 9f3fb4f753eabc84f19d808df64a718991269670
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Add a comment about the point choice when capping degenerate paths

 src/cairo-path-stroke.c |    3 +++
 1 file changed, 3 insertions(+)

commit a1a4d6966e1d9c8ccf84c9972a4f9560553948f6
Author: Jeff Smith <whydoubt@yahoo.com>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Modify how _cairo_stroker_add_caps handles zero-length sub-paths
    
    For zero-length sub-paths, _cairo_stroker_add_caps sets up a dummy face,
    then lets later parts of the function add the caps.

 src/cairo-path-stroke.c |   11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit 849a9ef81b99d05d8f3ceb4f73bf5e52c90b24af
Author: Jeff Smith <whydoubt@yahoo.com>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Change type of cairo_stroker_t's dash_on from int to cairo_bool_t

 src/cairo-path-stroke.c |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 74ded42327e87b40de434a28620d0a3fc8e4d249
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Add a new dashing test
    
    This new dashing test, based on some code from Jeff Smith, does a pretty
    good job exploring all the cases that the dashing code needs to deal with.

 test/Makefile.am                  |    2 ++
 test/dash-state-ps-argb32-ref.png |  Bin 0 -> 8652 bytes
 test/dash-state-ref.png           |  Bin 0 -> 9389 bytes
 test/dash-state.c                 |   72 +++++++++++++++++++++++++++++++++++++
 4 files changed, 74 insertions(+)

commit 1c1697398c5ef17e38bc031e8c067113a6c10287
Author: Jeff Muizelaar <jrmuizel@uwaterloo.ca>
Date:   Mon Feb 19 16:06:56 2007 -0500

    Add two new test cases to degenerate-path test
    
    These new cases deal with degenerate paths at the end of dashed paths. They
    currently fail.

 test/degenerate-path-ps-argb32-ref.png |  Bin 303 -> 390 bytes
 test/degenerate-path-ref.png           |  Bin 216 -> 257 bytes
 test/degenerate-path-rgb24-ref.png     |  Bin 189 -> 224 bytes
 test/degenerate-path.c                 |   23 ++++++++++++++++++++++-
 4 files changed, 22 insertions(+), 1 deletion(-)

commit 9927dde5334322c97942982f9bf632e74502d628
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 17 10:55:14 2007 +1030

    TrueType: fix bug #9998 - build error with gcc 2.95

 src/cairo-truetype-subset-private.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9bae496a0a057bb0de70b078ee5cde265663dc86
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Feb 15 23:08:40 2007 +0000

    [ATSUI] implement load_truetype_table
    
    Implements load truetype table, allowing selection of
    text and searching in pdfs generated using the atsui
    font backend.

 src/cairo-atsui-font.c |   26 +++++++++++++++++++++++++-
 1 file changed, 25 insertions(+), 1 deletion(-)

commit 16e20568a502b86d96c3087515e663bb7996f167
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 16 08:38:26 2007 +1030

    TrueType: Add post table and 3,0 cmap encoding
    
    Commit 05ff2c77da86c7be95924f9af4d3ad944afbbf66 contained
    a fix for the acroread printing problem. However this
    patch caused a problem for the Mac Preview PDF viewer.
    
      http://lists.freedesktop.org/archives/cairo/2007-February/009615.html
    
    This patch fixes the Mac Preview problem. The patch
    
    - Adds a platform 3, encoding 0 cmap table
    - Adds a post table that maps the glyph names in the
      PDF truetype font dictionary (/g0 /g1 /g2 ...)
      to glyph indices in the font.

 src/cairo-truetype-subset-private.h |    1 +
 src/cairo-truetype-subset.c         |   69 +++++++++++++++++++++++++++++++----
 2 files changed, 63 insertions(+), 7 deletions(-)

commit 2715f2098127d04d2f9e304580a26cd0842c0e64
Author: Jorn Baayen <jorn@openedhand.com>
Date:   Wed Feb 14 18:28:56 2007 -0800

    [cairo-pattern] Cache surface for solid patterns
    
    We use a small cache of size 16 for surfaces created for solid patterns.
    This mainly helps with the X backends where we don't have to create a
    pattern for every operation, so we save a lot on X traffic.  Xft uses a
    similar cache, so cairo's text rendering traffic with the xlib backend
    now completely matches that of Xft.
    
    The cache uses an static index variable, which itself acts like a cache of
    size 1, remembering the most recently used solid pattern.  So repeated
    lookups for the same pattern hit immediately.  If that fails, the cache is
    searched linearly, and if that fails too, a new surface is created and a
    random member of the cache is evicted.
    
    Only surfaces that are "compatible" are used.  The definition of compatible
    is backend specific.  For the xlib backend, it means that the two surfaces
    are allocated on the same display.  Implementations for compatibility are
    provided for all backends that it makes sense.

 src/cairo-color.c            |    7 ++++
 src/cairo-debug.c            |    2 +
 src/cairo-directfb-surface.c |   12 +++++-
 src/cairo-glitz-surface.c    |   24 ++++++++++-
 src/cairo-pattern.c          |   91 ++++++++++++++++++++++++++++++++++++++----
 src/cairo-surface.c          |   26 ++++++++++++
 src/cairo-win32-surface.c    |   13 +++++-
 src/cairo-xcb-surface.c      |   17 +++++++-
 src/cairo-xlib-surface.c     |   17 +++++++-
 src/cairoint.h               |   15 +++++++
 10 files changed, 212 insertions(+), 12 deletions(-)

commit b31179478bf8c18245917caa1bee19bb61f336c1
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 14 00:48:42 2007 -0800

    Bump cairo version to 1.3.15 after making the 1.3.14 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 90e453fc22398f31996a6fdbeec6da98e25a160e
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 14 00:34:18 2007 -0800

    Increment cairo version to 1.3.14 (and libtool versioning to 12:4:10)

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 513f21140bae549e088909333598e73e5dac4a44
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 14 00:32:54 2007 -0800

    NEWS: Add notes for the 1.3.14 snapshot

 NEWS |   56 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 56 insertions(+)

commit 51ca187d3e5d613a583daf4fa5b244157e3a2c4f
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 13 23:55:03 2007 -0800

    Mark test/rotate-image-surface-paint as XFAIL
    
    This test has always failed with the ps backend since the test
    was initially written.

 test/Makefile.am                  |    1 +
 test/rotate-image-surface-paint.c |    3 ++-
 2 files changed, 3 insertions(+), 1 deletion(-)

commit 9966551dc7640ae7901ffed0e15f0fbf7e603d5d
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 13 23:49:26 2007 -0800

    Fix cairo_ft_unscaled_font_t to have a lock_count again not an is_locked Boolean
    
    This was inadvertently changed as part of fdffde8b9e7a2308b822ddef7b02a8e85cc8ba1e
    
    With the Boolean, pango-using programs that locked the same
    unscaled_font multiple times would crash with a message such as:
    
     cairo-ft-font.c:569: _cairo_ft_unscaled_font_unlock_face: Assertion `unscaled->is_locked' failed.

 src/cairo-ft-font.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 7adab2866be21207a15f07aab01fb17edd0e661f
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 13 22:05:57 2007 -0800

    Add missing call to set_scale of unscaled_font in scaled_glyph init
    
    This fixes a regression introduced with commit:
    
    	25a370d7992d7f70d8cf79f1b328e40437b40ac4
    
    This was showing up as a failure of the bitmap-font test case
    with the ps, pdf, and svg backends.

 src/cairo-ft-font.c |    3 +++
 1 file changed, 3 insertions(+)

commit 17b4496ae9df539c48c830b21c4477e763ba4e5d
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Wed Feb 14 11:52:11 2007 +0800

    type1-subset: fix error handling.
    
    This fixes potenial memory leak and leaving font face locked on error.

 src/cairo-type1-subset.c |   34 +++++++++++++++++++++++-----------
 1 file changed, 23 insertions(+), 11 deletions(-)

commit 01a133167c48e7985515ae29f4a87de7952d1373
Author: Dan Amelang <dan@amelang.net>
Date:   Sun Feb 11 00:16:52 2007 -0800

    Update Win32 makefiles
    
    Since the last time these makefiles were last updated some new source
    files have been added and one renamed. In addition, a "clean" rule
    needed to be added to the pixman makefile. And the "clean" rule in the
    main cairo makefile wasn't working properly for me.

 pixman/src/Makefile.win32 |    2 ++
 src/Makefile.win32        |    8 ++++++--
 2 files changed, 8 insertions(+), 2 deletions(-)

commit b8987dd12c3269c1d7978338cd356b9fe3ad420e
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 13 16:47:30 2007 -0800

    ROADMAP: Note that text spacing issues for win32 are fixed

 ROADMAP |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f0a16b5bddc5c162c78ae976093fe8bb2b756e04
Author: Dan Amelang <dan@amelang.net>
Date:   Sun Feb 11 03:34:27 2007 -0800

    Fix Win32 text spacing problem
    
    Thanks to Jordan Miner for reporting the problem and a fix.

 src/cairo-win32-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit aad1374caab3a05893c9f1f2605131edd9f62409
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 10 09:39:24 2007 -0800

    Rename cairo_toy_font_face_hash_table_mutex to cairo_font_face_mutex
    
    The new name more accurately reflects its recently expanded role.

 src/cairo-font.c |   31 +++++++++++++++++++------------
 1 file changed, 19 insertions(+), 12 deletions(-)

commit e107b70b4d282d78ebe32f4d2381fcf98df324f6
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 10 09:39:09 2007 -0800

    Add locking to cairo_font_face_reference/destroy
    
    The reference count of cairo_font_face_t is rather intimately tied,
    (for toy font faces), with the cairo_font_face_hash_table, so we
    expand the existing cairo_toy_font_face_hash_table_mutex to cover
    the manipulation of font_face->ref_count as well.
    
    This commit eliminates an assertion failure that is (occasionally)
    exposed by the pthread-show-text test case:
    
    lt-pthread-show-text: cairo-hash.c:196: _cairo_hash_table_destroy: Assertion `hash_table->live_entries == 0' failed.

 src/cairo-font.c |   21 +++++++++++++++++----
 1 file changed, 17 insertions(+), 4 deletions(-)

commit d6d1767f9a89bf7e16288d0a90e5fafc5ad2d9d6
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 10 09:38:13 2007 -0800

    Increase pthread-show-text thread count and add cairo_select_font_face to expose more bugs.

 test/pthread-show-text.c |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit fdffde8b9e7a2308b822ddef7b02a8e85cc8ba1e
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 10 09:14:07 2007 -0800

    Add mutex to implement _cairo_ft_unscaled_font_lock_face and _cairo_ft_unscaled_font_unlock_face
    
    Previously we just had an integer counter here, but that is not
    sufficient as multiple cairo_scaled_font_t objects, (which are
    implicitly shared through the font caches), can reference the
    same cairo_ft_unscaled_font_t so real locking is needed here.
    
    This commit eliminates an assertion failure exposed by the
    pthread-show-text test case:
    
    lt-pthread-show-text: cairo-ft-font.c:562: _cairo_ft_unscaled_font_unlock_face: Assertion `unscaled->lock > 0' failed.

 src/cairo-ft-font.c |   82 +++++++++++++++++++++++++++++++++------------------
 1 file changed, 53 insertions(+), 29 deletions(-)

commit 25a370d7992d7f70d8cf79f1b328e40437b40ac4
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 13 10:40:53 2007 -0800

    Avoid public cairo_ft_scaled_font_lock_face for internal use
    
    We're planning to change the implementation of the public function,
    (which will remove some locking safety), so use the safe, locked
    _cairo_ft_unscaled_font_lock_face for internal use instead.

 src/cairo-ft-font.c |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 7e1301ffb066b04d95dc71144d86e660f0155bba
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 10 09:12:38 2007 -0800

    Add missing _cairo_ft_unscaled_font_unlock_face to _cairo_ft_scaled_font_create

 src/cairo-ft-font.c |    2 ++
 1 file changed, 2 insertions(+)

commit 6f7cfdf5c79c3c09a0241ae25ff540fb0d893d31
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 13 23:53:38 2007 +1030

    PDF: Add missing character code to Differences array

 src/cairo-pdf-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 88cae7766d6006e4169da1dcddc14a52e210cae5
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 13 23:29:05 2007 +1030

    output-stream: coding style fix

 src/cairo-output-stream.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 88f7ea4ad7926b135c987d3d75c029310c328010
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 13 22:52:53 2007 +1030

    CFF: Fix Visual C++ compile problem
    
    Don't use structure intitialization for assigning
    structure values.
    
    Add a new field to cff_charset_t to point to the sids
    charset array instead of casting it into the data field.

 src/cairo-cff-subset.c |   25 ++++++++++++++-----------
 1 file changed, 14 insertions(+), 11 deletions(-)

commit ac01dcb5ad077d8ea08a93348fc23d4a891abaae
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 11 23:14:40 2007 +1030

    PDF: Remove dead code
    
    The function _cairo_pdf_surface_write_fonts is the
    original PDF TrueType font embedding function that was
    disabled in commit f500cef19f049a4a0ed296172618db2f26794932
    shortly before Type3 font support was added.
    
    TrueType font embedding was later reintroduced as new code
    making this function obsolete.

 src/cairo-pdf-surface.c |  108 -----------------------------------------------
 1 file changed, 108 deletions(-)

commit d6f15b26009ff8e1d52a037265bcaa80c5ce6735
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 11 22:20:58 2007 +1030

    Output-stream: Omit the minus sign from negative zero

 src/cairo-output-stream.c |    4 ++++
 1 file changed, 4 insertions(+)

commit a2fefcc9e962e81a00fb16ae3d1bc29d9e61eaa0
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 11 21:57:43 2007 +1030

    PDF: Compress Type3 fonts

 src/cairo-pdf-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f47879ae31f003be3b32f9ecb3efb3486d72cc7
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 11 21:50:46 2007 +1030

    PDF: Fix Type3 font metrics to make text selection work

 src/cairo-pdf-surface.c |   66 ++++++++++++++++++++++++++++++++++++++++-------
 1 file changed, 56 insertions(+), 10 deletions(-)

commit 9dce321a113871ade7de244d3abf9ed08f43dd85
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sun Feb 11 01:42:22 2007 +0000

    [ATSUI] scale fonts using font size not font matrix
    
    Mozilla bug #327522 - fonts scaled up over 16pt on mac
    had nonsensical extents. The scaling was being done using
    the font matrix, it turns out this does not work for 16x
    scaling and up. This patch switches back to using the
    font size to scale fonts, with emboldening and condensing
    effects applied separately using the font matrix.

 src/cairo-atsui-font.c |   22 +++++++++-------------
 1 file changed, 9 insertions(+), 13 deletions(-)

commit eec62c297589ca20f4128c889ecad9e96736a07f
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Feb 10 00:20:40 2007 +0000

    Unreleased lock typo in cairo-scaled-font.c
    
    One path through _cairo_scaled_font_text_to_glyphs grabbed
    the mutex but didn't release it, causing hangs in all
    text rendering on the mac.

 src/cairo-scaled-font.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a37f21cb17a24643f7513dff06bc2b5fd38e2583
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Thu Feb 8 15:29:58 2007 -0800

    [PS/PDF/SVG] Return a write_error nil surface on write errors

 src/cairo-pdf-surface.c |    4 +++-
 src/cairo-ps-surface.c  |    4 +++-
 src/cairo-surface.c     |    1 +
 src/cairo-svg-surface.c |    4 +++-
 src/cairoint.h          |    1 +
 5 files changed, 11 insertions(+), 3 deletions(-)

commit bf3cbe7660f03f6b4139f4cf79a4007c682a84bd
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Thu Feb 8 15:28:14 2007 -0800

    [cairo-surface] Use a macro definition for all nil surfaces

 src/cairo-surface.c |  139 ++++++++++++++-------------------------------------
 1 file changed, 38 insertions(+), 101 deletions(-)

commit aea0831d24c3fca59b9eb9dd8acce9d9cdd13f26
Author: Kalle Vahlman <kalle.vahlman@gmail.com>
Date:   Thu Feb 8 15:07:45 2007 -0800

    [cairoint] Make it compile with libpng disabled

 src/cairoint.h |    7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 4773b8a6d25e4b228471ad48616c08367ee84809
Author: Peter Weilbacher <pmw@avila.aip.de>
Date:   Thu Feb 8 20:34:26 2007 +0100

    Oops, correct typo in previous commit
    
    FALSA -> FALSE

 src/cairoint.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e711700d5d766b4b923a10bfaabb57163b55a21d
Author: Peter Weilbacher <pmw@avila.aip.de>
Date:   Thu Feb 8 20:29:18 2007 +0100

    Correct scaled font mutex definitions for OS/2
    
    Using a zero without brackets to quiet remaining GCC compilation warning.
    Use FALSE so that the mutex does not block on creation.

 src/cairoint.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 2d1db24d1e7f3967b7ab498ce0ed29508c08a04b
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Feb 7 23:10:47 2007 +1030

    PDF: Another fix for TrueType metrics
    
    Not all TrueType fonts have an em size of 2048.

 src/cairo-pdf-surface.c                 |   20 ++++++++++----------
 src/cairo-scaled-font-subsets-private.h |    6 +++---
 src/cairo-truetype-subset.c             |   22 +++++++++++++---------
 3 files changed, 26 insertions(+), 22 deletions(-)

commit 274dfa4598bcb11b9f8330d23934a4ef1797fdbf
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Feb 7 22:35:59 2007 +1030

    PDF: Make text selection and extraction work
    
    - Add a to_unicode array to the scaled_font_subsets
      for mapping glyphs to unicode characters
    
    - Add a function to the TrueType subsetting for
      performing a reverse cmap for mapping glyph indices
      to unicode characters.
    
    - Add a new scaled font backend function for mapping
      glyph indices to unicode characters. Provide FreeType
      and Win32 implementations of the font backend mapping
      function.
    
    - Modify the PDF backend to embed ToUnicode streams
      into each font. The unicode mapping is obtained by
      first trying the reverse cmap. If this fails the font
      backend mapping function is called.

 src/cairo-atsui-font.c                  |    2 +
 src/cairo-ft-font.c                     |   33 +++++++
 src/cairo-pdf-surface.c                 |  126 +++++++++++++++++++++++++--
 src/cairo-scaled-font-subsets-private.h |   29 ++++---
 src/cairo-scaled-font-subsets.c         |   15 +++-
 src/cairo-truetype-subset-private.h     |   23 +++++
 src/cairo-truetype-subset.c             |  144 +++++++++++++++++++++++++++++++
 src/cairo-win32-font.c                  |   17 ++++
 src/cairoint.h                          |   18 ++++
 9 files changed, 385 insertions(+), 22 deletions(-)

commit 97a2522e0bbe8464028b9b42c79e0b3559b532be
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 21:19:30 2007 -0800

    Add missing locking to _cairo_scaled_font_text_to_glyphs
    
    We recently added locking to cairo_scaled_font_glyph_extents and
    to _cairo_surface_show_glyphs, but we had neglected the third
    separate entry point into scaled_font code that does cache-using
    glyph lookups, namely: _cairo_scaled_font_text_to_glyphs.
    
    These three separate functions are plainly visible in the
    implementation of cairo_show_text.

 src/cairo-scaled-font.c |   15 ++++++++++-----
 1 file changed, 10 insertions(+), 5 deletions(-)

commit 1503a41c7f115033b10470574027cffab0730687
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 20:32:08 2007 -0800

    Expand font_map locking to cover call to backend->scaled_font_create
    
    It seemed like a good idea to avoid holding the lock over the call
    into the backend. But the procedure in place was quite broken:
    
    	LOCK
    	Fail to find font in hash table
    	UNLOCK
    	Create font
    	LOCK
    	Insert font into hash table
    	UNLOCK
    
    since while we're busy creating the font and unlocked, another thread
    can insert the font. Our paranoid hash table implementation noted
    the problem quite readily.
    
    This patch simply removes the internal UNLOCK/LOCK to hold the mutex
    over the whole procedure.

 src/cairo-scaled-font.c |    9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit fc3ce1e80a89aab4f1ec75946771f6c2a79f0b90
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 20:41:58 2007 -0800

    test/pthread-show-text: Increease iterations to expose locking bug
    
    With 50 iterations I'm seeing the following assertion failure:
    
    cairo-hash.c:477: _cairo_hash_table_insert: Assertion `NOT_REACHED' failed.
    
    Thanks to Jan Slupski <jslupski@juljas.net> for pointing out this bug.

 test/pthread-show-text.c |    7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit d07827ba2a225f880f4bbf6980872f5ae8898288
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 19:06:23 2007 -0800

    ROADMAP: Drop 1.3.6 which is already in the past and note 8379 fix and pixman gradient improvements

 ROADMAP |    8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit 672a668da1002dbcecda2e4805c6b54c86d4cff7
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 19:05:07 2007 -0800

    ROADMAP: Note that the 8801 locking bug is fixed.

 ROADMAP |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit db3493bef7dba1e960f59563925fd9c5e75cb4ca
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 18:28:44 2007 -0800

    Remove dead cff_dict_remove function
    
    I assume this was just a leftover that was meant to be removed
    earlier. If not, please feel free to bring it back again.

 src/cairo-cff-subset.c |   14 --------------
 1 file changed, 14 deletions(-)

commit 89cf8dbf522ce7ada0ee4cf9ea016ac2a89c8a75
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 18:27:33 2007 -0800

    Remove half-leftover debugging code from previous commit
    
    This was leading to link failures on CAIRO_LOCK_FILE, etc.

 src/cairoint.h |    3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 5d58e7ee66166b19e673c247fe41eae51f72fd92
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Feb 5 16:45:25 2007 -0800

    Add scaled_font->mutex to allow locking for all subordinate objects
    
    A cairo_scaled_font_t can be implicitly shared among multiple threads
    as the same cairo_scaled_font_t can be returned from different calls
    to cairo_scaled_font_create. To retain the illusion that these
    different calls produce distinct objects, cairo must internally lock
    access when modifying them.
    
    Each glyph in the scaled font is represented by a cairo_surface_t
    which is used when rendering the glyph. Instead of attempting to push
    fine-grained locking of these surfaces down to the backend rendering
    functions, a simple per-cairo_scaled_font_t lock has been introduced
    which protects the entire rendering path against re-entrancy.
    
    Some care was required to ensure that existing re-entrancy was handled
    appropriately; these cases are in the wrapping surfaces
    (cairo-paginated, test-meta and test-paginated).
    
    Thanks to Vladimir Vukicev and Peter Weilbacher for testing/providing
    the mutex definitions for win32 and os2 (respectively).

 src/cairo-paginated-surface.c |   21 ++++++++++++---
 src/cairo-scaled-font.c       |   17 ++++++++----
 src/cairo-surface.c           |   19 ++++++++------
 src/cairoint.h                |   58 +++++++++++++++++++++++++++++++++++++++--
 src/test-meta-surface.c       |   21 ++++++++++++---
 src/test-paginated-surface.c  |   19 ++++++++++++--
 6 files changed, 132 insertions(+), 23 deletions(-)

commit 765715ad93d3daad1b8b53f6ea9fee82737923ea
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 17:29:03 2007 -0800

    Move scaled font holdovers magic from reference to create to fix race condition
    
    Previously, with the magic in _cairo_scaled_font_reference(),
    cairo_scaled_font_create() was releasing its lock just before
    calling into reference() which would re-acquire the lock.
    That left a window open during which a font we just discovered
    in the holdovers table could be destroyed before we had a chance
    to give it its initial reference back.

 src/cairo-scaled-font.c |   57 +++++++++++++++++++++--------------------------
 1 file changed, 26 insertions(+), 31 deletions(-)

commit 9c359d61fc5df3e925e4b63503d60dc8fe8be6b3
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 17:40:17 2007 -0800

    Avoid holding lock when calling _cairo_scaled_font_fini
    
    As in the previous commit with the backend->scaled_font_create
    function, we also don't want to hold the lock when calling into
    the backend's fini function.

 src/cairo-scaled-font.c |   24 ++++++++++++++----------
 1 file changed, 14 insertions(+), 10 deletions(-)

commit 258175ffcd89dcc949c3dc6ee3cd660d057a1966
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Feb 6 17:21:22 2007 -0800

    Don't hold mutex over backend->scaled_font_create
    
    This also allows some cleanup of the error-handling in
    cairo_scaled_font_create, (no more goto statements).

 src/cairo-scaled-font.c |   48 +++++++++++++++++++++++------------------------
 1 file changed, 24 insertions(+), 24 deletions(-)

commit fc660511ec7a51be909e5ed940354d39ef7ad633
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Feb 7 11:05:33 2007 +1030

    PDF: Correct the y value of Td in show_glyphs
    
    This bug would occur if the y coordinate of all the glyphs
    in a single cairo_show_glyphs() call was not the same.

 src/cairo-pdf-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 908469b5fcdc311a89868ab44baa85d0744985d1
Author: Soren Sandmann Pedersen <ssp@dhcp83-218.boston.redhat.com>
Date:   Tue Feb 6 16:37:45 2007 -0500

    Apply patch from Marco Gritti and Jordan Crouse to correctly detect
    AMD CPU's. Bug 9615.

 pixman/src/fbpict.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 9d3f537423b3cc0cb6a4b2607e9307c1eef9e074
Author: Soren Sandmann Pedersen <ssp@dhcp83-218.boston.redhat.com>
Date:   Tue Feb 6 16:27:42 2007 -0500

    Remove left-over assert and some alpha checks from
    fbCompositeSrc_8888x0565mmx(). Bug 9893.

 pixman/src/fbmmx.c |   52 +++++++++++++---------------------------------------
 1 file changed, 13 insertions(+), 39 deletions(-)

commit a8f8efb750fd3a8857c7f519b8645e578f75442b
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Feb 5 18:29:30 2007 +1030

    PS: Correct the TrueType Encoding and Charstrings
    
    The offsets and count was out by one as a result of the
    change to include .notdef on the TrueType font.

 src/cairo-ps-surface.c |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 28e3a20d79c3390547d3e53435c06442ca8ac8a2
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 4 23:47:28 2007 +1030

    PDF: Fix TrueType font metrics

 src/cairo-pdf-surface.c |   19 +++++++++++--------
 1 file changed, 11 insertions(+), 8 deletions(-)

commit 05ff2c77da86c7be95924f9af4d3ad944afbbf66
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 4 19:00:16 2007 +1030

    PDF: Add Encoding dictionary to TrueType fonts
    
    This is a fix for the bugs reported here
    
      http://lists.freedesktop.org/archives/cairo/2006-December/008984.html
    
      http://lists.freedesktop.org/archives/cairo/2007-January/009387.html
    
    Cairo PDFs will not print correctly from Adobe Reader. The symptoms are
    that all the glyphs on the page are replaced with the same glyph.
    
    According to the PDF Reference an Encoding dictionary is not required
    for the symbolic fonts used by cairo. However including the Encoding
    dictionary fixes the printing problem.

 src/cairo-pdf-surface.c |   21 +++++++++++++++++++--
 1 file changed, 19 insertions(+), 2 deletions(-)

commit 3f8d5f505af4d7569ce38452f1be5d40bf6a00b4
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 4 18:21:50 2007 +1030

    TrueType: Include notdef glyph in the subset
    
    Required by the TrueType specification.

 src/cairo-truetype-subset.c |   23 ++++++++++++++++-------
 1 file changed, 16 insertions(+), 7 deletions(-)

commit d22ba141e6c78bf1fc3dfc02c9aaf6d725233444
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 4 16:54:57 2007 +1030

    TrueType Subsetting: Whitespace change

 src/cairo-truetype-subset.c |   20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit e4a5011a2787bbb7ced338aaff2752aa23ac7892
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 4 16:51:44 2007 +1030

    TrueType Subsetting: Add comment

 src/cairo-truetype-subset.c |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 7d05b9bdd328c7ec0422f45893fa0e0d6e9bb135
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Sun Feb 4 16:26:18 2007 +1030

    TrueType Subsetting: Sort table directory
    
    The TrueType specification requires the table directory
    to be sorted by tag.

 src/cairo-truetype-subset.c |   25 +++++++++++++------------
 1 file changed, 13 insertions(+), 12 deletions(-)

commit 8b3176158351e62185294d512030c7af1ec4fabc
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Sun Feb 4 16:22:12 2007 +1030

    TrueType Subsetting: Correct the checksum calculation of 'head' table
    
    Checksum field should be zero before calculating checksum.

 src/cairo-truetype-subset.c |    3 +++
 1 file changed, 3 insertions(+)

commit 0bf5e18b14f2bbaf3be3b31c4eb54ea3183f488a
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Sun Feb 4 16:19:05 2007 +1030

    TrueType Subsetting : Correct the checksum calculation

 src/cairo-truetype-subset.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2bd590b64987b7f0eb7310666ac20a8309e32842
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Feb 2 16:43:27 2007 -0800

    ROADMAP: Note that linear gradient bug is fixed.

 ROADMAP |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ae4f37e0a32c3e231c38434846e80fd90162d888
Author: David Turner <digit@mounini.par.corp.google.com>
Date:   Fri Feb 2 10:30:24 2007 +0100

    fixing gradient repeat mode computations
    
    This fixes the regression of linear gradient as demonstrated
    by the recently added linear-gradient-reflect test.

 pixman/src/fbcompose.c |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 0b7ba5ccfa21265c1b36919ff08bd3a1f0d1075b
Author: T Rowley <tor@cs.brown.edu>
Date:   Fri Feb 2 16:36:12 2007 -0800

    Add linear-gradient-reflect test case
    
    This testcase works before the
    e9bef30d2bcdf41c7b7f20b3517839c37e752f75 landing, and has visual
    artifacts afterwards.

 test/Makefile.am                     |    2 +
 test/linear-gradient-reflect-ref.png |  Bin 0 -> 216 bytes
 test/linear-gradient-reflect.c       |   74 ++++++++++++++++++++++++++++++++++
 3 files changed, 76 insertions(+)

commit 1757b49ebda3ec464a442d8c4f5ba39c88c1e3e5
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 1 16:17:29 2007 -0800

    ROADMAP: Add bug about broken cairo_show_text on win32

 ROADMAP |    1 +
 1 file changed, 1 insertion(+)

commit c621201a41639be8ba9ee735c2859aa117ba4216
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 1 16:05:59 2007 -0800

    Don't finish a finished surface in cairo_surface_destroy
    
    Calling cairo_surface_finish from cairo_surface_destroy was
    triggering an error due to finish being called twice. The
    error was usually hidden as the surface would still eventually
    be destroyed. But it did clutter things up quite badly if a
    user was trying to break on _cairo_error to track down a
    problem.
    
    Thanks again to Stuart Parmenter <stuartp@gmail.com>
    for pointing out the problem.

 src/cairo-surface.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 159359325d4f8306feef6bebabecb31cbf0b9bf5
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 1 15:22:27 2007 -0800

    Fix crashes in cairo_surface_finish for NULL or nil
    
    Thanks to Stuart Parmenter for alerting us of this bug.

 src/cairo-surface.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit 26ef4746e66dccd8e0eb651db3e7f2826c068029
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 1 15:21:12 2007 -0800

    Add two tests of cairo_surface_finish to test/nil-surface.c
    
    This tests calling cairo_surface_finish with either NULL or
    with a nil surface, (either currently causes a crash).

 test/nil-surface.c |   11 +++++++++++
 1 file changed, 11 insertions(+)

commit 382e021ccb657ab1e342e0d0eee402ff5eb89e5d
Author: Dan Amelang <dan@amelang.net>
Date:   Wed Jan 31 11:53:06 2007 -0800

    Add "rectangles" perf test
    
    This test draws many small, solid pixel-aligned rectangles one at a
    time.

 perf/Makefile.am  |    1 +
 perf/cairo-perf.c |    1 +
 perf/cairo-perf.h |    1 +
 perf/rectangles.c |   71 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 74 insertions(+)

commit 7abfb39709342fc3d95269ad2d76a5e1e8f8d38f
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Sun Jan 28 19:01:38 2007 +1030

    CFF Subsetting: Add charset data to embedded font
    
    Current code for subsetting CFF fonts does not write charset information
    into it. According to spec this means that font have ISOAdobe charset.
    This charset contains only 228 names (excluding .notdef). This is not
    enough for subfonts with 256 glyphs and causes bugs when viewing
    generated PDFs.

 src/cairo-cff-subset.c |  253 +++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 252 insertions(+), 1 deletion(-)

commit a63ceef06c2c015c8e5f0ad7b756ff6801996096
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 26 18:03:18 2007 -0800

    Fix _cairo_pattern_acquire_surface_for_surface to not clone outside surface extents
    
    Rotation and other transformations would cause extents to be
    computed which were outside the bounds of the surface to be
    cloned, (and for non repeating patterns). Now we simply
    restrict the computed extents to the surface extents.
    
    This fixes the xlib failure of the recent rotate-image-surface-paint
    test, (the apparently distinct ps failure remains).

 ROADMAP             |    2 +-
 src/cairo-pattern.c |   21 +++++++++++++++------
 2 files changed, 16 insertions(+), 7 deletions(-)

commit ebc1cd91f80ee154c02651b2db034a4335ca021c
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 00:50:38 2007 -0800

    Add rotate-image-surface-paint test case
    
    This test exercises a clone_similar extents bug noticed by
    Benjamin Otte. As expected, the xlib backend fails due to
    that bug, (and interestingly, the ps backend is showing a
    failure as well).

 test/.gitignore                                    |    1 +
 test/Makefile.am                                   |    1 +
 test/rotate-image-surface-paint-pdf-argb32-ref.png |  Bin 0 -> 209 bytes
 test/rotate-image-surface-paint-ref.png            |  Bin 0 -> 232 bytes
 test/rotate-image-surface-paint-svg-ref.png        |  Bin 0 -> 248 bytes
 test/rotate-image-surface-paint.c                  |   97 ++++++++++++++++++++
 6 files changed, 99 insertions(+)

commit 691f9d1c0c4c98f6e6aa7b2f41fa0b8670e6205d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Jan 24 17:34:57 2007 -0800

    [mmx] avoid casts between int32 and __m64 types
    
    The MS compiler doesn't like this; _mm_cvtsi32_si64 and _mm_cvtsi64_si32
    must be used.

 pixman/src/fbmmx.c |   10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 8ff70d6b9106b2dc57e903104237285a7062c2f0
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Jan 24 16:47:48 2007 -0800

    [win32] regression with win32 glyph y-offsets (mozbug#365021)

 src/cairo-win32-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0231d18a57dd31d9d619d53b70e71c1b916e0d75
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Jan 24 16:46:36 2007 -0800

    [atsui] add function prototype for a public 10.4 function that's

 src/cairo-atsui-font.c |    3 +++
 1 file changed, 3 insertions(+)

commit 50136a78063137ebca16bcb839bec33e2917824e
Author: Eugeniy Meshcheryakov <eugen@debian.org>
Date:   Wed Jan 24 15:51:00 2007 -0500

    [PDF-CFF] Fix bad /LastChar value for CFF fonts in PDF backend
    
    PDF backend sets /LastChar value in Type1C font dictionary incorrectly.
    acroread then complains about incorrect /Widths in font.
    The last char is numchars - 1, since it's zero-based.

 src/cairo-pdf-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bb02b4e5ec40ac37462f487f2ad74b0123814277
Merge: 48c2896 3b77512
Author: Michael Emmel <memmel@debian.localdomain>
Date:   Tue Jan 23 22:22:20 2007 -0800

    Merge branch 'master' of ssh+git://git.cairographics.org/git/cairo

commit 48c2896f694872a55a43e12fc375bde2ce2650a9
Author: Michael Emmel <memmel@debian.localdomain>
Date:   Tue Jan 23 22:17:24 2007 -0800

    Turned off acclerated rectangle drawing in dfb backend
    causes bugs in gtk

 src/cairo-directfb-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3b7751279c034caf2f86464cd1936d7ce1736ccc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 22 14:42:48 2007 -0500

    [pixman/src/fbmmx.c] Add comment around M64
    
    /* cast to void* in the middle to shut gcc up warning about
     * "dereferencing type-punned pointers".
     */

 pixman/src/fbmmx.c |    3 +++
 1 file changed, 3 insertions(+)

commit c316b7220dcd59653533a487d81c5e3d71729218
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Mon Jan 22 01:13:50 2007 +0000

    [ATSUI] Some glyph operations cannot be 'unsupported'. (#9530)
    
    The atsui font backend returned the internal 'unsupported' error
    code for errors in operations that do not have fallbacks. Now that
    the underlying cause, deleted glyphs, has been fixed, I'm changing
    the status code returned to the public 'no memory' one; it should
    be the only condition triggering the failure now.

 src/cairo-atsui-font.c |    9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit 49b9f0c082944029af8dab84da87f7746c5f72b9
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Mon Jan 22 01:10:52 2007 +0000

    [ATSUI] out-of-range glyphs should be treated as deleted. (#9530)
    
    Glyphs outside the range 0x0-0xffff are not valid in atsui, but
    scaled_glyph stores unsigned long. Ensure that invalid values do
    not cause errors.

 src/cairo-atsui-font.c |   14 +++++++++++---
 1 file changed, 11 insertions(+), 3 deletions(-)

commit 4dfa5d33e451886b05cf767ae5a538e152ec534d
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Mon Jan 22 01:09:49 2007 +0000

    [ATSUI] Handle deleted glyphs correctly. (#9530)
    
    This code ensures that deleted glyphs are not drawn.

 src/cairo-atsui-font.c |   36 +++++++++++++++++++++++++++++++-----
 1 file changed, 31 insertions(+), 5 deletions(-)

commit 1a9d3b5185f454a63bc96c2e570c931c3ecabbb5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 21 15:11:31 2007 -0500

    [configure.in] Use AC_MSG_RESULT in PKG_CHECK_MODULES's second branch
    
    If PKG_CHECK_MODULES fails, it does not print out any check results and so, no
    newlines.  This is kinda silly, at least in the case that no second branch is
    provided, but I think that's the way it is, to let users decide what to print.
    
    We now just do a AC_MSG_RESULT(no) and continue with what we used to do.
    Inspired by Tor Lillqvist's similar change in Pango.

 configure.in |   38 ++++++++++++++++++++++++--------------
 1 file changed, 24 insertions(+), 14 deletions(-)

commit 6aa8e80cc722774191c4418c9a2cd434c0538508
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 21 15:06:02 2007 -0500

    [pixman/src/fbmmx.c] Hide "dereferencing type-punned pointer" warnings
    
    The warning happens all the place when the code converts from ullong to __m64.
    The way the conversion is done is a C idiom: 1) get a pointer to the value, 2)
    convert it to the suitable pointer type for the target, 3) dereference it.
    That is "*(__m64*)(&m)" in this case.  This is necessarily (as opposed to just
    casting to target type) because the two types may not be "compatible" from the
    compiler's point of view.  Example of types that are not compatbile is structs
    vs anything.
    
    The "dereferencing type-punned pointer will break strict-aliasing rules" from
    gcc exactly means: "some code may be assuming that pointers with different
    types do not compare equal (or otherwise share the same target object).  If
    you case a pointer to a different type and dereference it, it may happen
    here."  However, in our usecase, it's clear that the compiler cannot make any
    false assumptions.  So we just go ahead and hide it by using a middle cast to
    "void *".  Since the compiler does not many any aliasing assumptions about
    generic pointers, it will not warn either. (Though the problems if any, will
    still occure.  So this is not an ideal solution to this problem and should be
    used very carefully, to no hide useful warnings for when things go loose on
    some weird architecture.)
    
    Another solution would have been to use gcc's "may_alias" function attribute,
    but trying to define a may_alias version of __m64 hit a bug in gcc.  That is,
    try replacing "__m64" with "m64" and define:
    
      typedef __m64 m64 __attribute__((may_alias));
    
    and see it fail to compile.  This seems to be because of the special vector
    type that __m64 has.

 pixman/src/fbmmx.c |   34 ++++++++++++++++++----------------
 1 file changed, 18 insertions(+), 16 deletions(-)

commit 1a8d0a33ce589367f0e46006caecb544a3945048
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jan 20 13:01:35 2007 -0500

    PDF: Fix approximate diagonal in recent commit
    
    Use x+y as an upper bound for sqrt(x*x+y*y), not x*y.

 src/cairo-pdf-surface.c |    3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 1e52ce5a0981aac72452f1f7d7988e6382b0abcc
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 03:20:30 2007 -0800

    doc tmpl churn

 doc/public/tmpl/cairo.sgml |   11 -----------
 1 file changed, 11 deletions(-)

commit 53358ddc73b985b5cf6493dc48c54073fd7c59fc
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 03:20:18 2007 -0800

    configure.in: Increment version to 1.3.13 after making the 1.3.12 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c34a1a75fdb886b7a69875fb92d30c6dfd9d39cb
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 03:04:31 2007 -0800

    configure.in: Increment cairo version to 1.3.12

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 26e6c73aab3fbfb4e2c893b4064cd8e85dc25346
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 02:58:15 2007 -0800

    NEWS: Add notes for 1.3.12 snapshot

 NEWS |   93 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 93 insertions(+)

commit 87b3ac10af6b18d57236ae7e595e84e11e12eaad
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 02:01:29 2007 -0800

    cairo-wideint: Fix to eliminate comparison of signed and unsigned values

 src/cairo-wideint.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit d6bb0d772018809caaa215d562292c8aeb2990d3
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 01:47:06 2007 -0800

    .gitignore: Add text-glyph-range

 test/.gitignore |    1 +
 1 file changed, 1 insertion(+)

commit b06222b99091796486cc0f938dd7487c66dd8420
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 20 00:56:07 2007 -0800

    ROADMAP: Add 3 bugs to fix before the next snapshot

 ROADMAP |    7 +++++++
 1 file changed, 7 insertions(+)

commit 6c40575a225e3d6d138adae9d492881b8358f881
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 19 23:23:32 2007 -0800

    Fix two misspellings in a recent comment.

 src/cairo-pdf-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5f9d70a56158e468683dba953d6eaceea4dfd644
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 19 23:11:09 2007 -0800

    PDF: Fix CAIRO_EXTEND_NONE for source surface patterns
    
    The former workaround for the lack of non-repeating patterns in PDF
    (as far as we can tell) was broken for a source pattern matrix that
    resulted in scaling the source surface pattern down. This was
    demonstrated by the failure of the scale-down-source-surface-paint
    test which now passes.
    
    The old code would have also allowed for bogus repeated pattern
    instances to appear if the source surface pattern was translated
    sufficiently far off the destination surface in just the right
    direction. This bug is also fixed.

 src/cairo-pdf-surface.c |   41 +++++++++++++++++++++++++++++++++--------
 1 file changed, 33 insertions(+), 8 deletions(-)

commit 2f6d184e6659e91909ed933d36bef441f1b5df4d
Author: Kalle Vahlman <kalle.vahlman@gmail.com>
Date:   Sat Jan 13 12:36:03 2007 +0200

    Add --use-ms option to cairo-perf-diff-files
    
    This allows for comparing perf files generation on different hardware
    platforms, (since the ticks can be very different on different hardware).

 perf/cairo-perf-diff-files.c |   16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

commit 8354906381b2ccc3211214bad55c1f505d3dce3a
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sat Dec 16 22:21:36 2006 +0200

    Make UTF-8 output from cairo-perf-diff-files optional
    
    This patch adds options to disable the UTF-8 change bars and replace
    them with ASCII '*' gfx. The motivation is that UTF-8 really does some
    damage to some terminals, and some always forget to pipe stuff through
    a pager to make it safe. The new options for cairo-perf-diff-files are:
    
    	--no-utf
    	--no-bars

 perf/cairo-perf-diff-files.c |  135 ++++++++++++++++++++++++++++++------------
 1 file changed, 98 insertions(+), 37 deletions(-)

commit d91d5d12f3a40beebefcd8a5d8b912f5492e112b
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 19 15:52:06 2007 -0800

    Add new scale-down-source-surface-paint test
    
    This new test case demonstrates a bug in the PDF backend, (source
    surface patterns are repeated even with a pattern extend of NONE).
    
    Thanks to Romuald <mydevel@free.fr> and Claudio Saavedra
    <csaavedra@alumnos.utalca.cl> for pointing out the bug.

 test/.gitignore                              |    1 +
 test/Makefile.am                             |    2 +
 test/scale-down-source-surface-paint-ref.png |  Bin 0 -> 133 bytes
 test/scale-down-source-surface-paint.c       |   72 ++++++++++++++++++++++++++
 4 files changed, 75 insertions(+)

commit d08502d939b44956591f2865a73264713427194b
Merge: eefcfbf 28d6a22
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 18 16:50:41 2007 -0800

    Merge branch 'master' of git+ssh://git.cairographics.org/git/cairo

commit eefcfbf5a168569518a8dcf099b5f41b570f504b
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 18 16:49:42 2007 -0800

    [nquartz] add test reference files for nquartz backend

 test/caps-joins-alpha-nquartz-ref.png                 |  Bin 0 -> 2466 bytes
 test/clip-nesting-nquartz-ref.png                     |  Bin 0 -> 1067 bytes
 test/clip-nesting-nquartz-rgb24-ref.png               |  Bin 0 -> 956 bytes
 test/clip-push-group-nquartz-ref.png                  |  Bin 0 -> 203 bytes
 test/clip-twice-nquartz-ref.png                       |  Bin 0 -> 1171 bytes
 test/clip-twice-nquartz-rgb24-ref.png                 |  Bin 0 -> 1111 bytes
 test/dash-caps-joins-nquartz-ref.png                  |  Bin 0 -> 4727 bytes
 test/degenerate-path-nquartz-rgb24-ref.png            |  Bin 0 -> 188 bytes
 test/fill-and-stroke-alpha-add-nquartz-ref.png        |  Bin 0 -> 603 bytes
 test/fill-and-stroke-alpha-nquartz-ref.png            |  Bin 0 -> 550 bytes
 test/fill-and-stroke-nquartz-ref.png                  |  Bin 0 -> 286 bytes
 test/fill-and-stroke-nquartz-rgb24-ref.png            |  Bin 0 -> 264 bytes
 test/fill-degenerate-sort-order-nquartz-ref.png       |  Bin 0 -> 2470 bytes
 test/fill-degenerate-sort-order-nquartz-rgb24-ref.png |  Bin 0 -> 2098 bytes
 test/fill-rule-nquartz-ref.png                        |  Bin 0 -> 2079 bytes
 test/fill-rule-nquartz-rgb24-ref.png                  |  Bin 0 -> 1790 bytes
 test/new-sub-path-nquartz-ref.png                     |  Bin 0 -> 386 bytes
 test/new-sub-path-nquartz-rgb24-ref.png               |  Bin 0 -> 357 bytes
 test/operator-clear-nquartz-ref.png                   |  Bin 0 -> 1195 bytes
 test/operator-clear-nquartz-rgb24-ref.png             |  Bin 0 -> 1244 bytes
 test/random-intersections-nquartz-ref.png             |  Bin 0 -> 203877 bytes
 test/random-intersections-nquartz-rgb24-ref.png       |  Bin 0 -> 179204 bytes
 test/rel-path-nquartz-ref.png                         |  Bin 0 -> 212 bytes
 test/rel-path-nquartz-rgb24-ref.png                   |  Bin 0 -> 228 bytes
 test/source-clip-scale-nquartz-ref.png                |  Bin 0 -> 148 bytes
 test/trap-clip-nquartz-ref.png                        |  Bin 0 -> 5814 bytes
 test/trap-clip-nquartz-rgb24-ref.png                  |  Bin 0 -> 5385 bytes
 27 files changed, 0 insertions(+), 0 deletions(-)

commit 7b67c20a013ed45a10676cb129794ccfb66dc04c
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 18 16:49:14 2007 -0800

    [nquartz] use pattern snapshots, and correctly setup/teardown source
    
    Use a snapshot for the pattern, to avoid the pattern being freed undreneath
    us before we actually render (as when rendering to a CG PDF context).  Also
    correctly return UNSUPPORTED from setup source, avoiding brokenness when
    the source isn't torn down correctly.

 src/cairo-nquartz-surface.c |   81 ++++++++++++++++++++++++++++++++++++-------
 1 file changed, 68 insertions(+), 13 deletions(-)

commit 28d6a228f030dbec05ab5b0ba680db272df67c49
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Jan 18 13:01:53 2007 -0800

    Fix cairo_get_dash and cairo_get_dash_count APIs
    
    Make these functions consistent with other cairo_get functions
    by making cairo_get_dash_count return the count directly, and
    removing the cairo_status_t return value from cairo_get_dash.

 src/cairo.c        |   37 +++++++++++--------------------------
 src/cairo.h        |    6 +++---
 test/get-and-set.c |   17 ++++++-----------
 3 files changed, 20 insertions(+), 40 deletions(-)

commit bc7072064e421e4c5e5043aada6cae1d8250938f
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 17 15:07:12 2007 -0800

    cairo-path-fixed: Don't add redundant, succesive MOVE_TO operations to the path
    
    Instead, we can simply tweak the argument value for the last
    MOVE_TO operation that's already at the end of the path.
    
    This helps backends like pdf that are currently emitting all
    of the redundant MOVE_TO operations in the output.

 src/cairo-path-fixed.c |   16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit d9df44d8071d038060e0cc987871c185f7733a3d
Merge: 4e1c2b1 b02b86d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Jan 17 15:08:21 2007 -0800

    Merge branch 'master' of git+ssh://git.cairographics.org/git/cairo

commit 4e1c2b1ad84a695662dea9fbe60a975c928eb277
Author: Robert O'Callahan <robert@ocallahan.org>
Date:   Wed Jan 17 15:07:31 2007 -0800

    Rename cairo_copy_clip_rectangles to cairo_copy_clip_rectangle_list

 src/cairo-clip-private.h |    2 +-
 src/cairo-clip.c         |    2 +-
 src/cairo-gstate.c       |    4 ++--
 src/cairo.c              |    6 +++---
 src/cairo.h              |    2 +-
 src/cairoint.h           |    2 +-
 test/get-clip.c          |   26 +++++++++++++-------------
 7 files changed, 22 insertions(+), 22 deletions(-)

commit b02b86da5c6c82f9b653698f8480855a35777155
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Sep 24 00:55:20 2006 +0930

    PDF: Compress the content stream
    
    Use cairo-deflate-stream to compress all content streams emitted by the
    PDF surface.

 src/cairo-pdf-surface.c |   32 +++++++++++++++++++++++++++++---
 1 file changed, 29 insertions(+), 3 deletions(-)

commit 7f246462eb3cc2576387755fa2d554394e86225c
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Sep 24 00:52:01 2006 +0930

    Add cairo-deflate-stream.c
    
    Add a new stream type that compresses the stream using the zlib deflate method.
    This is intended for use by the PDF surface.

 src/Makefile.am                   |    1 +
 src/cairo-deflate-stream.c        |  142 +++++++++++++++++++++++++++++++++++++
 src/cairo-output-stream-private.h |    4 ++
 3 files changed, 147 insertions(+)

commit b3440e85305af4f5ceef9437af7c26d3232dc55a
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Sep 24 00:48:36 2006 +0930

    PDF: Use Td where possible instead of Tm for positioning glyphs
    
    This avoids emitting the font matrix for every single glyph.

 src/cairo-pdf-surface.c |   38 ++++++++++++++++++++++++++------------
 1 file changed, 26 insertions(+), 12 deletions(-)

commit 5c2136ea7c3aea1ae90b46b0dd645a4e1b5cc9a1
Author: Dan Williams <dcbw@redhat.com>
Date:   Wed Jan 17 15:47:24 2007 -0500

    Implement pixman fbCompositeSrc_8888x0565mmx
    
    MMX-accelerate for fbCompositeSrc_8888x0565.  Upstream X bug for the
    same issue:
    
    http://bugs.freedesktop.org/show_bug.cgi?id=9682

 pixman/src/fbmmx.c        |  122 +++++++++++++++++++++++++++++++++++++++++++++
 pixman/src/fbmmx.h        |   13 +++++
 pixman/src/fbpict.c       |   14 +++++-
 pixman/src/pixman-remap.h |    1 +
 4 files changed, 148 insertions(+), 2 deletions(-)

commit a2ec383ff128617d33efa5760ec4b5f9688e8a13
Author: Pavel Roskin <proski@gnu.org>
Date:   Sun Aug 13 01:57:56 2006 -0400

    Clean up _fbOnes()
    
    The implementation of _FbOnes in iccolor.c would not work on 64-bit
    longs correctly.  Fortunately, it's only used on integers, so make it
    explicit in the declaration.
    
    Use an inline function for the gcc builtin implementation to make sure
    that it's never used with arguments of incorrect size.
    
    There is no __INT_MIN__ in gcc 4.1.1, but it's not an issue now because
    the argument is 32-bit.
    
    Signed-off-by: Pavel Roskin <proski@gnu.org>

 pixman/src/iccolor.c |    4 ++--
 pixman/src/icint.h   |   12 ++++++------
 2 files changed, 8 insertions(+), 8 deletions(-)

commit 9e332eadad00e115fdcdbc816608a0537f5a9b9c
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Tue Jan 16 01:25:53 2007 +0000

    [test] Test handling of out-of-range glyph indexes. (#9530)
    
    Adds a test for missing and out-of-range glyph indexes. The expected
    ATSUI renderings are added as references, please replace these with
    FT renderings when they become available.

 test/Makefile.am                    |    4 ++
 test/text-glyph-range-ref.png       |  Bin 0 -> 1810 bytes
 test/text-glyph-range-rgb24-ref.png |  Bin 0 -> 1645 bytes
 test/text-glyph-range.c             |  133 +++++++++++++++++++++++++++++++++++
 4 files changed, 137 insertions(+)

commit 9cabf5b5f7dd840f91b5be29567cf11cf40fc998
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 15 00:26:20 2007 -0500

    [TODO] Move some items from ROADMAP, and some new ones, into TODO

 ROADMAP |   17 -----------------
 TODO    |   40 ++++++++++++++++++++++++++++++++++------
 2 files changed, 34 insertions(+), 23 deletions(-)

commit 1002d016834926a771aa0a6cc4bdf83cb009173a
Author: Kjartan Maraas <kmaraas@gnome.org>
Date:   Thu Jan 11 17:59:16 2007 -0500

    Remove unused variables (#7963)

 src/cairo-pdf-surface.c |    3 +--
 src/cairo-ps-surface.c  |    3 +--
 src/cairo-svg-surface.c |    3 +--
 3 files changed, 3 insertions(+), 6 deletions(-)

commit eff6d3c7a013476a7e4cf56c05ad95c9f01fe793
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 15:49:50 2006 -0500

    [cairo-type1-subset] Do not use an array of pointers, to reduce .data size
    
    We use a string pool plus lookup indices tables now, generated by perl code
    embedded before the tables.  The table in question is the default PS encoding
    table, so no changes are expected in the future.

 src/cairo-type1-subset.c |  107 +++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 105 insertions(+), 2 deletions(-)

commit cf1d95e714d0814e52910c4306d090ef6d989093
Author: Soeren Sandmann <sandmann@daimi.au.dk>
Date:   Tue Jan 9 15:05:29 2007 -0800

    Add SRC and IN implementations to avoid CompositeGeneral in some cases hit by PDF rendering
    
    The patch implements a few more operations with special cases MMX
    code. On my laptop, applying the patch to cairo speeds up the
    benchmark (rendering page 14 of a PDF file[*]) from 20.9 seconds
    to 14.9 seconds, which is an improvement of 28.6%.
    
    [*] http://people.redhat.com/jakub/prelink.pdf
    
    This also benefits the recently added unaligned_clip perf case:
    
    image-rgb  unaligned_clip-100 0.11 -> 0.06: 1.65x speedup
    ▋
    image-rgba unaligned_clip-100 0.11 -> 0.06: 1.64x speedup
    ▋

 pixman/src/fbmmx.c  |  226 +++++++++++++++++++++++++++++++++++++++++++++++++++
 pixman/src/fbmmx.h  |   43 ++++++++++
 pixman/src/fbpict.c |   98 +++++++++++++++++++++-
 3 files changed, 366 insertions(+), 1 deletion(-)

commit d5531c4f506caa9ad66fbeef1822a7036d4dd528
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 9 14:27:32 2007 -0800

    Add unaligned_clip perf case courtesy of Jeff Muizelaar
    
    Conflicts:
    
    	perf/Makefile.am
    	perf/cairo-perf.c
    	perf/cairo-perf.h

 perf/Makefile.am      |    9 ++++---
 perf/cairo-perf.c     |    1 +
 perf/cairo-perf.h     |    1 +
 perf/unaligned-clip.c |   66 +++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 73 insertions(+), 4 deletions(-)

commit 504cbdae37232d65f5c1f8913e55ac63397ad4f0
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 03:12:53 2007 +0000

    [ATSUI] [2/2] Implement CAIRO_SCALED_GLYPH_INFO_SURFACE support.(#9467)
    
    All non-quartz surfaces need to fall back to using glyph surfaces,
    in order to clip correctly. This second patch implements glyph
    surface support, correcting the unclipped text seen in the clip-operator
    test.

 src/cairo-atsui-font.c |  113 +++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 111 insertions(+), 2 deletions(-)

commit 77171cb8e23704db3eeddfe92cc4e0e83d02b36b
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 02:16:47 2007 +0000

    [ATSUI] [1/2] Implement CAIRO_SCALED_GLYPH_INFO_SURFACE support.(#9467)
    
    All non-quartz surfaces need to fall back to using glyph surfaces,
    in order to clip correctly. The bug being fixed is visible in the
    clip-operator test. This first patch takes out direct rendering support
    for non-quartz surfaces, causing all image tests to fail.

 src/cairo-atsui-font.c |   77 +++++++++++++++++++++++++++---------------------
 1 file changed, 44 insertions(+), 33 deletions(-)

commit 116ae23fc64a8477a116bd6f3b60c7b5404af1c5
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Mon Jan 8 16:51:28 2007 +0800

    Glitz: position large glyph correctly.
    
    I introduced this bug while fixing test glyph-cache-pressure
    (commit 3b1d0d3519a7d0328f897927d3534f10750d30db). I also changed
    GLYPH_CACHE_MAX_HEIGHT and GLYPH_CACHE_MAX_HEIGHT to 96, then we
    still can cache at least 28 glyphes per font(512 ^ 2 / 96 ^ 2).
    This make us not hit slow path too much and improve performance
    a lot.

 src/cairo-glitz-surface.c |    9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit aed4029a104d22cbd363ab9e365320980d22bc86
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 02:13:05 2007 +0000

    [ATSUI] Refactor code for creating CGBitmapContexts from cairo surfaces.
    
    No changes to test output. This just prepares code for reuse when
    implementing support for CAIRO_SCALED_GLYPH_INFO_SURFACE.

 src/cairo-atsui-font.c |   85 +++++++++++++++++++++++++++---------------------
 1 file changed, 48 insertions(+), 37 deletions(-)

commit 9a005c6221cc279e65d94956c74028a84baf1716
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 02:09:16 2007 +0000

    [ATSUI] correct the rotation of glyph paths. (#9378)
    
    This fixes a bug visible in the text-rotate test when
    CAIRO_TEST_GENERATE_REFERENCE_IMAGE is defined.

 src/cairo-atsui-font.c |   92 ++++++++++++++++++++++++++++++++++--------------
 1 file changed, 65 insertions(+), 27 deletions(-)

commit 58265f3508959298eabab55ec28dc6d9516eedc3
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 05:54:52 2007 +0000

    [ATSUI] Select Bitstream Vera and CSS font families reliably.
    
    Previously the code selected using the family name; this intermittently
    selected a bold or italic face instead of the regular one. The new approach
    is to select the desired font instance directly if possible, and only use
    the family lookup if that fails. This isn't 100% correct but should always
    provide the correct font instance for CSS generic font families. The
    bug was sometimes reproducible with the select-font-face test.

 src/cairo-atsui-font.c |   56 ++++++++++++++++++++++++++++++++++--------------
 1 file changed, 40 insertions(+), 16 deletions(-)

commit 22e271d687ad871a4e8a069ee2945c42062c1cb4
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 15:06:48 2007 +0000

    [perf/cairo-perf-diff] Pass CAIRO_AUTOGEN_OPTIONS to autogen.
    
    Makes it was possible to run cairo-perf-diff with different
    configurations, eg with quartz enabled.

 perf/cairo-perf-diff |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit d30b1bf157126668c4309731022b2ded2ad09571
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Thu Jan 4 01:36:32 2007 +0000

    [ATSUI] Scale glyphs using _cairo_matrix_compute_scale_factor (#9350)
    This bug shows up in the text-rotate test.

 src/cairo-atsui-font.c |   24 ++++++++++++++++--------
 1 file changed, 16 insertions(+), 8 deletions(-)

commit ded08256ef7fdc9e9468342cf5635c5e99d4d64d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 7 02:08:15 2007 -0500

    Spell check the docs

 doc/public/tmpl/cairo-version.sgml |   10 +++++-----
 src/cairo-array.c                  |    2 +-
 src/cairo-cache.c                  |   12 ++++++------
 src/cairo-font-options.c           |    6 +++---
 src/cairo-ft-font.c                |    6 +++---
 src/cairo-gstate.c                 |    4 ++--
 src/cairo-image-surface.c          |    4 ++--
 src/cairo-lzw.c                    |    2 +-
 src/cairo-meta-surface.c           |    2 +-
 src/cairo-path-stroke.c            |    4 ++--
 src/cairo-pattern.c                |   10 +++++-----
 src/cairo-pdf-surface.c            |    2 +-
 src/cairo-ps-surface.c             |    4 ++--
 src/cairo-scaled-font.c            |    4 ++--
 src/cairo-surface.c                |    2 +-
 src/cairo-type1-fallback.c         |    4 ++--
 src/cairo-unicode.c                |    4 ++--
 src/cairo-wideint.c                |    2 +-
 src/cairo-win32-surface.c          |    4 ++--
 19 files changed, 44 insertions(+), 44 deletions(-)

commit caa3c2e1e7901031488f5dae243a755a4e4daec9
Author: Alp Toker <alp@atoker.com>
Date:   Sun Jan 7 02:03:30 2007 +0000

    Fix various code/comment typos

 pixman/src/pixregion.c    |    2 +-
 src/cairo-matrix.c        |    2 +-
 src/cairo-pdf-surface.c   |   20 ++++++++++----------
 src/cairo-win32-surface.c |    2 +-
 src/cairo-xcb-surface.c   |    4 ++--
 src/cairo-xlib-surface.c  |   10 +++++-----
 6 files changed, 20 insertions(+), 20 deletions(-)

commit c96a71e709e537f690da6d4a184aa4c64fe11028
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 5 15:56:06 2007 -0800

    Restrict _clip_and_composite_trapezoids to destination extents
    
    This is a fix for a huge performance bug (as measured by perf/long-lines).
    Previously, if no explicit clip was set, _clip_and_composite_trapezoids
    would allocate a mask as large as the trapezoids and rasterize into it.
    With this fix, it restricts the mask by the extents of the destination
    surface.
    
    This doesn't address the identical performance problem with the xlib
    backend, which is due to a very similar bug in the X server.
    
    image-rgb  long-lines-uncropped-100 465.42 -> 5.03: 92.66x speedup
    █████████████████████████████████████████████▉
    image-rgba long-lines-uncropped-100 460.80 -> 5.02: 91.87x speedup
    █████████████████████████████████████████████▍

 src/cairo-surface-fallback.c |   28 ++++++++++++++++++----------
 1 file changed, 18 insertions(+), 10 deletions(-)

commit cc11c264ec0c7d6586c9349bcdbe3f4156e7ab6e
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 3 16:27:52 2007 -0800

    Add long-lines perf case
    
    This shows some very bad slowness for lines that are mostly
    offscreen (like 100x slower than just drawing the visible
    portion).

 perf/Makefile.am  |    1 +
 perf/cairo-perf.c |    1 +
 perf/cairo-perf.h |    1 +
 perf/long-lines.c |  117 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 120 insertions(+)

commit 11dd9eab693297961b988a73e22bf4d5850eb485
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 4 23:35:51 2007 -0500

    [src/Makefile.am] Don't remove cairo-features.h in "make clean"
    
    That's generated by configure, so it should be removed by "make distclean".

 src/Makefile.am |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d4a58b2437a21794562d874f3d390e0e59688bc0
Author: Jonathan Watt <jwatt@jwatt.org>
Date:   Thu Jan 4 16:46:22 2007 +0100

    Remove WINVER from public header file

 src/cairo-win32-surface.c |   10 ++++++++++
 src/cairo-win32.h         |   10 ----------
 2 files changed, 10 insertions(+), 10 deletions(-)

commit e6369f9478e84e32ca19d5f204dbe3eee828c429
Author: Peter Weilbacher <pmw@avila.aip.de>
Date:   Thu Jan 4 00:11:44 2007 +0100

    Fix for OS/2 display drivers that cannot handle 32bit output (feed them a 24bit buffer instead).

 src/cairo-os2-surface.c |   70 ++++++++++++++++++++++++++++++++++++++++-------
 1 file changed, 60 insertions(+), 10 deletions(-)

commit 26b06516a77fbbe88f2eb081e2763c1434959137
Author: Dan Amelang <dan@amelang.net>
Date:   Sat Dec 30 21:14:14 2006 -0800

    Use the "-" option (instead of "-a") when calling "strings"
    
    This is needed to fix the AX_C_FLOAT_WORDS_BIGENDIAN macro on Mac OS X 10.2,
    which was brought up here:
    
        https://bugs.freedesktop.org/show_bug.cgi?id=9124

 acinclude.m4 |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit eafd6e454a85c807f2addf7768046fea58aea3f9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 28 20:01:18 2006 -0500

    In _cairo_scaled_font_text_to_glyphs, bail if text is zero-length (#5177)

 src/cairo-scaled-font.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit ab29396ef9f68f5534f927b2b5bb0a7ffac86509
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 28 19:51:20 2006 -0500

    [test] Add new test text-zero-len (#5177)
    
    The test passes an empty string to cairo_show_text, cairo_text_path, and
    cairo_text_extents, and NULL and an invalid pointer, with zero num_glyphs to
    cairo_show_glyphs, cairo_glyph_path, and cairo_glyph_extents.

 test/.gitignore            |    1 +
 test/Makefile.am           |    2 +
 test/text-zero-len-ref.png |  Bin 0 -> 130 bytes
 test/text-zero-len.c       |   88 ++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 91 insertions(+)

commit 2d30161e8922e66b276341810c21ce1b740f6699
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Sun Dec 24 18:31:02 2006 +0800

    glitz: fix all compiler warnings in glitz backend.

 src/cairo-glitz-surface.c |   31 +++++++++++++++++++++++--------
 1 file changed, 23 insertions(+), 8 deletions(-)

commit 8fd7328ebb77b0a641cf30bded85e482ea63ad97
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 23 17:08:04 2006 -0500

    Don't call into backends if num_glyphs is zero (#5177)
    
    Just return success in _cairo_scaled_font_show_glyphs() and
    _cairo_surface_show_glyphs() if num_glyphs is zero.

 src/cairo-scaled-font.c |    3 +++
 src/cairo-surface.c     |    3 +++
 2 files changed, 6 insertions(+)

commit 3212fc4f0fcc66ec3a93994f253c1477eb434572
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 23 16:55:44 2006 -0500

    [cairo-scaled-font] Skip invisible glyphs (like space) in glyph_extents() (#9422)
    
    When computing extents for an array of glyphs, just taking min/max of x/y for
    the bounding box of each glyph doesn't work.  The reason being that an
    invisible glyph (like the space glyph) should not modify the resulting
    extents, but it will.  So now we skip invisible glyphs.

 src/cairo-scaled-font.c |   58 +++++++++++++++++++++++++++++------------------
 1 file changed, 36 insertions(+), 22 deletions(-)

commit 8368fa2fcfcf851b9a5b070d22905472f1f76234
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Dec 23 15:44:16 2006 -0500

    [test/text-rotate] Use the same text for measuring and printing

 test/text-rotate.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 261d6b805c77dacb27d29d054e48ed548f1fbcc5
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Dec 23 15:33:52 2006 -0500

    [ATSUI] Compute glyph extents from the bounding boxes of their paths (#9350)

 src/cairo-atsui-font.c |  156 +++++++++++++++++++++++++++++++++++-------------
 1 file changed, 116 insertions(+), 40 deletions(-)

commit ee01bd9e173b6d36d6255553d0fcf1b54027dffd
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Dec 23 00:47:40 2006 -0800

    Bump version to 1.3.11 after making 1.3.10 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b35cfde7f0e2896ccc1453f9716cb9b61c42cf94
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Dec 23 00:35:14 2006 -0800

    Increment cairo version to 1.3.10 (and libtool versioning to 12:3:10)

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d6895af9f165a033fc7e53233994a0885c2f817f
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Dec 23 00:29:21 2006 -0800

    NEWS: Add notes for 1.3.10 snapshot

 NEWS |   59 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 59 insertions(+)

commit f46fcd1847031b46a73780177f9cb16033169a44
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Dec 23 00:29:01 2006 -0800

    Annoying template churn

 doc/public/tmpl/cairo-text.sgml |    1 -
 1 file changed, 1 deletion(-)

commit c08bd4ec377c6b97c9edb75a25101beb9568fd5e
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Dec 23 00:03:31 2006 -0800

    Ignore another test case binary

 test/.gitignore |    1 +
 1 file changed, 1 insertion(+)

commit ba531642f79d492ecbad8f086f1e44b56e157e36
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 19 21:34:16 2006 -0800

    Add optimization for rectilinear stroke
    
    This custom stroking code allows backends to use optimized region-based
    drawing operations for rectilinear strokes. This results in a 5-25x
    performance improvement when drawing rectilinear shapes:
    
    image-rgb          box-outline-stroke-100 0.18 -> 0.01: 25.58x speedup
    ████████████████████████▋
    image-rgba         box-outline-stroke-100 0.18 -> 0.01: 25.57x speedup
    ████████████████████████▋
     xlib-rgb          box-outline-stroke-100 0.49 -> 0.06:  8.67x speedup
    ███████▋
     xlib-rgba         box-outline-stroke-100 0.22 -> 0.04:  5.39x speedup
    ████▍
    
    In other words, using cairo_stroke instead of cairo_fill to draw the
    same shape was 5-15x slower before, but is 1.2-2x faster now.

 src/cairo-path-fixed-private.h                 |    3 +-
 src/cairo-path-fixed.c                         |    4 +
 src/cairo-path-stroke.c                        |  318 +++++++++++++++++++++++-
 src/cairo.c                                    |   11 +-
 test/ft-text-vertical-layout-type3-ref.png     |  Bin 3933 -> 3934 bytes
 test/ft-text-vertical-layout-type3-svg-ref.png |  Bin 3956 -> 3957 bytes
 6 files changed, 329 insertions(+), 7 deletions(-)

commit b1189118532a1fe93e126843af739809d38a62bd
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Dec 22 17:11:08 2006 -0800

    Put ft-text-vertical-layout-type1 back on the XFAIL list
    
    I must not have the right font available, (test result is coming out
    looking like the result of ft-text-vertical-layout-type3, Vera?).
    
    We should switch this test to load a bundled font, (should do that for
    all font-using tests, too).

 test/Makefile.am                     |    1 +
 test/ft-text-vertical-layout-type1.c |    3 ++-
 2 files changed, 3 insertions(+), 1 deletion(-)

commit 7b1509f4f37118d14bd5d70365d1608ead5e2819
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 19 13:13:11 2006 -0800

    Reimplement path.has_current point as a 1-bit bitfield

 src/cairo-path-fixed-private.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9d2d3b95e359cd2829c8d02a378dbfec2065e832
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 21 08:20:20 2006 -0800

    Add new rectilinear-stroke test
    
    This is in preparation for an optimized implementation of cairo_stroke
    for rectilinear paths.

 test/.gitignore                 |    1 +
 test/Makefile.am                |    2 +
 test/rectilinear-stroke-ref.png |  Bin 0 -> 213 bytes
 test/rectilinear-stroke.c       |  138 +++++++++++++++++++++++++++++++++++++++
 4 files changed, 141 insertions(+)

commit 39ce31ade64e1c3b9e5880134ab77ca96f48f1b9
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Fri Dec 22 22:05:20 2006 +0800

    Glitz: fix a potential use after free bug in _cairo_glitz_surface_old_show_glyphs.
    
    There is a race condition between glyph unlocking and glyph cache thawing.
    Moving down _cairo_scaled_font_thaw_cache a few lines fixes the problem and make
    crashes go away.

 src/cairo-glitz-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 344901a1a128b7e843c3bff0a4a12c36be7acbc8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 20 18:03:33 2006 -0500

    [test] Fix typo in test comment, again

 test/ft-text-vertical-layout-type1.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 473ae3aa9510b750f54cbf889180e3c4784da1b7
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Dec 18 17:00:17 2006 -0800

    Rename remaining cairo_path_data to cairo_path in function names, etc.

 src/cairo-path-private.h |   19 ++--
 src/cairo-path.c         |  237 +++++++++++++++++++++++-----------------------
 src/cairo.c              |   10 +-
 3 files changed, 134 insertions(+), 132 deletions(-)

commit def0e6d41d1a9108693db112f95d76bb6cfd0aaa
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Dec 18 16:37:53 2006 -0800

    Rename cairo-path-data.c to cairo-path.c (and similar)

 src/Makefile.am               |    4 +-
 src/cairo-path-data-private.h |   58 -----
 src/cairo-path-data.c         |  497 -----------------------------------------
 src/cairo-path-private.h      |   58 +++++
 src/cairo-path.c              |  497 +++++++++++++++++++++++++++++++++++++++++
 src/cairo.c                   |    2 +-
 6 files changed, 558 insertions(+), 558 deletions(-)

commit 13c143bb52cab62a7a857a38a8463a8fa56f4632
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Dec 18 16:33:32 2006 -0800

    Rename cairo-path.c to cairo-path-fixed.c

 src/Makefile.am        |    2 +-
 src/cairo-path-fixed.c |  639 ++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-path.c       |  639 ------------------------------------------------
 3 files changed, 640 insertions(+), 640 deletions(-)

commit 267afe7be398db4ab90956660828ed25cfd19acf
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Dec 18 16:05:42 2006 -0800

    test/.gitignore: Ignore binarries for some recently added tests

 test/.gitignore |    3 +++
 1 file changed, 3 insertions(+)

commit f3b9f486cd763c7805ec041319817cfb8c51128a
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sun Dec 17 22:26:02 2006 -0500

    [ATSUI] Use screen metrics instead of ideal metrics to compute glyph extents
    
    The glyph extent computation was totally busted.  It was using "logical"
    extents and it was not correctly handling rotations, etc.  It all looks a lot
    better now.

 src/cairo-atsui-font.c |   32 +++++++++++++++++---------------
 1 file changed, 17 insertions(+), 15 deletions(-)

commit c6ec6ed696f55f65abbcfccb1e9d2c5678cf491a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 18:42:05 2006 -0500

    [tests/ft-text-vertical-layout-type3] Remove comment that this emits Type3 font
    
    This test used to be named -truetype, which reflected the type of font used in
    the test, in contrast to the -type1 test that uses a Type1 font.  However, we
    renamed this test to -type3 to emphasize the fact that a TrueType subset is
    not emitted for vertical fonts and a Type3 fallback font is generated.
    
    Now things have changed: we try generating a Type1 fallback font which is what
    is happening for this test.  Moreover, the -typ1 test also is generating a
    Type1 fallback font since the Type1 subset font is not useful for vertical
    fonts.

 test/ft-text-vertical-layout-type3.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 50efd71935d0aa8d5b780b3ea2c3fd4c5333ca82
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 18:35:16 2006 -0500

    [type1-subset] Return UNSUPPORTED for vertical fonts
    
    This fixes the last problem with vertical fonts in PS/PDF.  As such, remove
    ft-text-vertical-layout-type1 test from XFAIL and add PS-specific ref image
    to pass.

 src/cairo-type1-subset.c                             |    3 +++
 test/Makefile.am                                     |    2 +-
 test/ft-text-vertical-layout-type1-ps-argb32-ref.png |  Bin 0 -> 1877 bytes
 3 files changed, 4 insertions(+), 1 deletion(-)

commit 207e38e8ba009a5e4d7994ee490d478c6a695336
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 18:25:48 2006 -0500

    [PS] Fix typo in comment emitted for Type1 fallback font subsets

 src/cairo-ps-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0bea2ce7f7e9c4b46d1125b07ed719fbb8b7102c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 14:31:39 2006 -0500

    [pdiff] Define _GNU_SOURCE to get correct symbols out of <math.h>
    
    math.h does not define __USE_ISOC99 otherwise.

 test/pdiff/pdiff.c |    2 ++
 1 file changed, 2 insertions(+)

commit 2ca6a767ee067742205ee76f891e36c8ec36135e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 14:24:57 2006 -0500

    [pdiff] Don't use float math functions if not using gcc with C99
    
    The float version of many math functions were introduced in C99, and were
    causing compile failure on systems like OS X.  We now define them to their
    double variant if __USE_ISOC99 is not defined.  We may want to expand it later
    to cover non-gcc compilers too, but since this is pdiff only, it's not really
    important.

 test/pdiff/pdiff.c |    8 ++++++++
 1 file changed, 8 insertions(+)

commit 0d9b2d041578c183b026b90c3760ce8dc59e2834
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 14:09:15 2006 -0500

    [configure] Use AC_C_INLINE to correctly define inline
    
    Previously we were defining a symbol INLINE and use that in one place, while
    other places were using straight inline.  With the AC_C_INLINE macro we can
    just leave it to autoconf to correctly choose what inline should be defined
    to.

 configure.in    |    1 +
 src/cairo-png.c |    2 +-
 src/cairoint.h  |    7 +------
 3 files changed, 3 insertions(+), 7 deletions(-)

commit 294d1a3c4e1865763ba1c9ac8d55827cd470280b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 17 01:06:16 2006 -0500

    [test] Add ft-text-vertical-layout-type3-ps-argb32-ref.png
    
    The PS output for ft-text-vertical-layout-type3 looks correct, except for some
    antialiasing mismatch.  Ading ref image to fix this, and so, remove the test
    from XFAIL.

 test/Makefile.am                                     |    4 ++--
 test/ft-text-vertical-layout-type3-ps-argb32-ref.png |  Bin 0 -> 1879 bytes
 2 files changed, 2 insertions(+), 2 deletions(-)

commit cab3f84ad334050739e6fa05e8dbc2a7dcb9eca7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 16 18:48:59 2006 -0500

    [test] Fix typo in test comment

 test/ft-text-vertical-layout-type1.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 46add53973de5ba4ae4d6d02d1dd87e5487336c3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 16 18:46:54 2006 -0500

    [cairo-gstate] Don't bypass glyph transformation if font_matrix has translation (#9365)
    
    We have tests for this (ft-text-vertical-*), but unfortunately they didn't
    prevent the regression here because they have been marked XFAIL, since we didn't
    quite fix them for PS.

 src/cairo-gstate.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 57589a90490f9bb9e4926c0b138eb95f16db374b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 16 18:18:47 2006 -0500

    [pdiff] Use CAIRO_CFLAGS, to make sure warnings are enabled

 test/pdiff/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8f2ad0affd4fe4821992e87487bc2737e9c538e5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 16 18:16:46 2006 -0500

    [pdiff] Fix compiler warnings, that were causing crashes

 test/pdiff/pdiff.c |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit be6edd64a3f45f7fb33f7d57b71b1ef467b474e1
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Dec 16 15:43:46 2006 -0500

    [ATSUI] Round glyph locations to nearest pixel
    
    This is what cairo_scaled_font_show_glyphs() does, as well as backends like
    xlib and win32.

 src/cairo-atsui-font.c |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit bf1c2ef1e2b6cffffb0f02fe5cb8df0728026642
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Dec 16 15:40:21 2006 -0500

    [ATSUI] Support disabling antialiased text

 src/cairo-atsui-font.c |    4 ++++
 1 file changed, 4 insertions(+)

commit 4c95e2b7bf15c2c12498ae07a16d95ae98501431
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sat Dec 16 20:00:56 2006 +0200

    New performance test case "mosaic" for splines.

 perf/Makefile.am  |    4 +-
 perf/cairo-perf.c |    1 +
 perf/cairo-perf.h |    1 +
 perf/mosaic.c     |  168 ++
 perf/mosaic.h     | 4387 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 4560 insertions(+), 1 deletion(-)

commit fe21f9d8ca1e509952b1dd84a5c0430953ca663a
Author: Frederic Crozat <fcrozat@mandriva.com>
Date:   Sat Dec 16 13:55:21 2006 -0500

    [check-defs.sh] Fix make check for OPD platforms
    
    Make symbol checks work on OPD platform (such as IA64 or PPC64).

 src/check-def.sh |    7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit fa618df6e216f9418d4769ba01cd305f3f12a113
Merge: 2b946cb 81a620f
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 21:10:21 2006 -0800

    Merge branch 'master' of git.cairographics.org:/git/cairo into cairo

commit 2b946cba0e2e0bc1ddfda2aad87f1e482568c1b1
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 21:09:45 2006 -0800

    Bump cairo version to 1.3.9 after making 1.3.8 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 129b55f5fcc4c2ae5b63ac6eb73fce8a708e4874
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 20:44:25 2006 -0800

    Increment cairo version to 1.3.8 (and libtool versioning to 12:2:10)

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8fa86e897091ad8ce4c286896df56d44892040ee
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 20:43:31 2006 -0800

    NEWS: Add notes for cairo 1.3.8 snapshot

 NEWS |   21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 81a620fb66a1eb341fefaad26c9d452e494890cb
Author: Jonathan Watt <jwatt@jwatt.org>
Date:   Fri Dec 15 04:52:28 2006 +0100

    revert accidental mode changes in my previous commit

 0 files changed

commit 15e8486ef1558b8049a4c7a5c2f50a7e4a2599da
Merge: bf78be6 8b31038
Author: U-JONATHAN-X60S\jonathan <jonathan@Jonathan-X60s.(none)>
Date:   Fri Dec 15 02:31:13 2006 +0100

    Merge branch 'master' of git://git.cairographics.org/git/cairo

commit bf78be63fc35dc13899209ee818f37fe3f564fed
Author: U-JONATHAN-X60S\jonathan <jonathan@Jonathan-X60s.(none)>
Date:   Fri Dec 15 00:48:54 2006 +0100

    Fix a couple of character spacing issues on Windows

 src/cairo-win32-surface.c |  105 +++++++++++++++++++++++++--------------------
 src/cairo-win32.h         |   10 +++++
 src/cairoint.h            |   10 ++++-
 3 files changed, 76 insertions(+), 49 deletions(-)

commit 8b31038b9fb7f8fc3eb2729c3d14de5c0b130873
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 10:16:34 2006 -0800

    Fix a couple of more stale images holding up 'make distcheck'

 test/Makefile.am |    2 --
 1 file changed, 2 deletions(-)

commit e9bef30d2bcdf41c7b7f20b3517839c37e752f75
Author: David Turner <david@alice.localdomain>
Date:   Thu Dec 14 06:55:58 2006 -0800

    Optimize gradient computations
    
    We update the test suite reference images where needed, (pdiff
    avoided a few, but most still needed updating). We take advantage
    of the need for new reference images to shrink some of the giant
    tests to speed them up a bit.
    
    This optimization provides a 2x improvement in linear gradient
    generation performance (numbers from an x86 laptop):
    
    image-rgb    paint_linear_rgba_source-512 26.13 -> 11.13: 2.35x speedup
    █▍
    image-rgb    paint_linear_rgba_source-256  6.47 ->  2.76: 2.34x speedup
    █▍
    image-rgba      paint_linear_rgb_over-256  6.51 ->  2.86: 2.28x speedup
    █▎
    image-rgb      paint_linear_rgba_over-512 28.62 -> 13.70: 2.09x speedup
    █▏
    image-rgba       fill_linear_rgb_over-256  3.24 ->  1.94: 1.66x speedup
    ▋
    image-rgb     stroke_linear_rgba_over-256  5.68 ->  4.10: 1.39x speedup
    ▍

 pixman/src/fbcompose.c                |  425 +++++++++++++++++++++++----------
 test/clip-operator-ref.png            |  Bin 36956 -> 8262 bytes
 test/clip-operator-rgb24-ref.png      |  Bin 16507 -> 3258 bytes
 test/clip-operator.c                  |    6 +-
 test/mask-ref.png                     |  Bin 87899 -> 8381 bytes
 test/mask-rgb24-ref.png               |  Bin 71010 -> 7041 bytes
 test/mask-svg-argb32-ref.png          |  Bin 87728 -> 8405 bytes
 test/mask-svg-rgb24-ref.png           |  Bin 81753 -> 0 bytes
 test/mask.c                           |    6 +-
 test/operator-clear-ref.png           |  Bin 4933 -> 1084 bytes
 test/operator-clear-rgb24-ref.png     |  Bin 4218 -> 965 bytes
 test/operator-clear.c                 |    6 +-
 test/operator-source-ref.png          |  Bin 19763 -> 4422 bytes
 test/operator-source-rgb24-ref.png    |  Bin 14666 -> 3201 bytes
 test/operator-source.c                |    6 +-
 test/text-pattern-ref.png             |  Bin 1721 -> 1717 bytes
 test/text-pattern-rgb24-ref.png       |  Bin 1418 -> 1414 bytes
 test/trap-clip-ref.png                |  Bin 71832 -> 5723 bytes
 test/trap-clip-rgb24-ref.png          |  Bin 63049 -> 5365 bytes
 test/trap-clip-svg-argb32-ref.png     |  Bin 71728 -> 0 bytes
 test/trap-clip.c                      |    6 +-
 test/unbounded-operator-ref.png       |  Bin 11964 -> 2777 bytes
 test/unbounded-operator-rgb24-ref.png |  Bin 6047 -> 1315 bytes
 test/unbounded-operator.c             |    6 +-
 24 files changed, 316 insertions(+), 145 deletions(-)

commit af9cce6aa295327b5256f55900b3debf9112b6ca
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 09:18:26 2006 -0800

    Fix 'make distcheck' after recent file removals

 pixman/src/Makefile.am |    3 +--
 test/Makefile.am       |   20 --------------------
 2 files changed, 1 insertion(+), 22 deletions(-)

commit 4888a02666972e9c09d9ffd9854538191cf59d77
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 04:56:19 2006 -0800

    test: Remove ps-specific reference images no longer needed thanks to pdiff

 test/caps-joins-ps-argb32-ref.png              |  Bin 1463 -> 0 bytes
 test/caps-sub-paths-ps-argb32-ref.png          |  Bin 240 -> 0 bytes
 test/close-path-ps-argb32-ref.png              |  Bin 311 -> 0 bytes
 test/dash-offset-negative-ps-argb32-ref.png    |  Bin 204 -> 0 bytes
 test/glyph-cache-pressure-ps-argb32-ref.png    |  Bin 1672 -> 0 bytes
 test/infinite-join-ps-argb32-ref.png           |  Bin 220 -> 0 bytes
 test/leaky-polygon-ps-argb32-ref.png           |  Bin 355 -> 0 bytes
 test/line-width-ps-argb32-ref.png              |  Bin 244 -> 0 bytes
 test/select-font-face-ps-argb32-ref.png        |  Bin 1333 -> 0 bytes
 test/show-text-current-point-ps-argb32-ref.png |  Bin 1479 -> 0 bytes
 test/transforms-ps-argb32-ref.png              |  Bin 420 -> 0 bytes
 11 files changed, 0 insertions(+), 0 deletions(-)

commit 5e0818d79d13f5942485b411a04a4eebd56d36f8
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 04:33:08 2006 -0800

    test: Remove svg-specific reference images no longer needed thanks to pdiff
    
    This doesn't get rid of all the SVG reference images, but it
    does clean up quite a few.

 test/fill-and-stroke-alpha-svg-ref.png   |  Bin 509 -> 0 bytes
 test/glyph-cache-pressure-svg-ref.png    |  Bin 3165 -> 0 bytes
 test/mask-ctm-svg-rgb24-ref.png          |  Bin 118 -> 0 bytes
 test/mask-surface-ctm-svg-rgb24-ref.png  |  Bin 118 -> 0 bytes
 test/push-group-svg-rgb24-ref.png        |  Bin 2887 -> 0 bytes
 test/select-font-face-svg-ref.png        |  Bin 2430 -> 0 bytes
 test/set-source-svg-rgb24-ref.png        |  Bin 104 -> 0 bytes
 test/show-text-current-point-svg-ref.png |  Bin 2398 -> 0 bytes
 test/trap-clip-svg-rgb24-ref.png         |  Bin 73082 -> 0 bytes
 9 files changed, 0 insertions(+), 0 deletions(-)

commit c426e71141d75dbfd39730bf9c4847309fcd9d9e
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 04:17:07 2006 -0800

    Hook up pdiff to the test suite now that its written in C

 test/Makefile.am   |    2 ++
 test/buffer-diff.c |   30 ++++++++++++++++++++++++++++++
 test/cairo-test.c  |   12 +++++-------
 3 files changed, 37 insertions(+), 7 deletions(-)

commit 305cbd8e71a2d21a2c71ed2c382daa5bfcec3992
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 04:14:24 2006 -0800

    pdiff: Remove casts since we're out of the land of X++ where void* is stupidly broken

 test/pdiff/lpyramid.c |    6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit f175b23559f3ba759d222538fd28922c1cbe2196
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 03:49:31 2006 -0800

    pdiff: Rename everything to .c and fix an last littele C++ isms.
    
    The only things we had missed were a few new/delete pairs, and some
    obvious header file fixups, (like not doing <string>).

 test/pdiff/CompareArgs.cpp    |  114 -------------
 test/pdiff/Makefile.am        |    6 +-
 test/pdiff/PerceptualDiff.cpp |  101 ------------
 test/pdiff/args.c             |  119 ++++++++++++++
 test/pdiff/args.cpp           |  118 --------------
 test/pdiff/args.h             |    2 +-
 test/pdiff/lpyramid.c         |  113 +++++++++++++
 test/pdiff/lpyramid.cpp       |  113 -------------
 test/pdiff/pdiff.c            |  361 +++++++++++++++++++++++++++++++++++++++++
 test/pdiff/pdiff.cpp          |  347 ---------------------------------------
 test/pdiff/pdiff.h            |   16 +-
 test/pdiff/perceptualdiff.c   |  101 ++++++++++++
 12 files changed, 706 insertions(+), 805 deletions(-)

commit 18a4fa448fcdb6a72f427e997ee2b234f96a56f7
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 03:25:51 2006 -0800

    pdiff: Replace CompareArgs class with args_t struct
    
    This gets rid of nearly the last vestiges of C++ from the pdiff code.

 test/pdiff/CompareArgs.cpp    |    4 +-
 test/pdiff/CompareArgs.h      |   41 --------------
 test/pdiff/Makefile.am        |    4 +-
 test/pdiff/PerceptualDiff.cpp |   39 +++++++-------
 test/pdiff/args.cpp           |  118 +++++++++++++++++++++++++++++++++++++++++
 test/pdiff/args.h             |   46 ++++++++++++++++
 6 files changed, 190 insertions(+), 62 deletions(-)

commit 871aba6c80b8f3101eac51cc055ad9ca26770a95
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 03:16:18 2006 -0800

    pdiff: Fix return value from perceptualdiff program

 test/pdiff/PerceptualDiff.cpp |    3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 2174ee247554feef6a24792390d858b12fd44acd
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 03:15:14 2006 -0800

    pdiff: Remove all uses of std::string

 test/pdiff/CompareArgs.cpp    |   18 ++++++------------
 test/pdiff/CompareArgs.h      |    1 -
 test/pdiff/PerceptualDiff.cpp |   24 ++++++++----------------
 3 files changed, 14 insertions(+), 29 deletions(-)

commit 91b156b82e0219b2b851c218813f24024cad7c69
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 03:02:48 2006 -0800

    pdiff: Remove RGBAImage classes now that we're just using cairo image surfaces

 test/pdiff/CompareArgs.cpp    |    1 -
 test/pdiff/CompareArgs.h      |    3 -
 test/pdiff/Makefile.am        |    4 +-
 test/pdiff/PerceptualDiff.cpp |    1 -
 test/pdiff/RGBAImage.cpp      |  144 -----------------------------------------
 test/pdiff/RGBAImage.h        |  105 ------------------------------
 test/pdiff/pdiff.cpp          |   80 +++++++++++++++++++----
 test/pdiff/pdiff.h            |    2 +
 8 files changed, 69 insertions(+), 271 deletions(-)

commit 4c812c38e4ec9885b9451185127e5c8877354d75
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 02:10:35 2006 -0800

    pdiff: Remove hideous C++ reference passing

 test/pdiff/pdiff.cpp |   26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit 2457756afd66b69840640eff3aaf72e7ea0f64e8
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 02:08:30 2006 -0800

    pdiff: Remove intermingled statements and declarations

 test/pdiff/pdiff.cpp |   74 ++++++++++++++++++++++++++++++--------------------
 1 file changed, 44 insertions(+), 30 deletions(-)

commit e947f5a4bdf4a4134faa8961406a10f32cf4e2d6
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 01:09:05 2006 -0800

    pdiff: Add .gitignore for perceptualdiff binary

 test/pdiff/.gitignore |    1 +
 1 file changed, 1 insertion(+)

commit bb4d4dc77117ded253d1f507e771de7f98c69fb8
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 01:06:42 2006 -0800

    pdiff: Remove old, unused Yee_Compare interface

 test/pdiff/Makefile.am |    2 +-
 test/pdiff/Metric.cpp  |  295 ------------------------------------------------
 test/pdiff/pdiff.cpp   |  281 +++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 282 insertions(+), 296 deletions(-)

commit 53c3a2f75b7f065b4c769ad087bbc9aaaaf6d7ee
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 01:00:43 2006 -0800

    pdiff: Rewrite main program to use cairo-based pdiff_compare interface

 test/pdiff/CompareArgs.cpp    |   23 +++++++++-----------
 test/pdiff/CompareArgs.h      |    5 +++--
 test/pdiff/Makefile.am        |    1 -
 test/pdiff/Metric.cpp         |   35 +++++++++++++++---------------
 test/pdiff/Metric.h           |   32 ----------------------------
 test/pdiff/PerceptualDiff.cpp |   47 ++++++++++++++++++++++++++++++-----------
 6 files changed, 65 insertions(+), 78 deletions(-)

commit 358645d6eb68b4eaf79159e7aefa01bca4cb0acf
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 00:42:52 2006 -0800

    pdiff: Rip out unused ImgDiff code, (dropping -output option)

 test/pdiff/CompareArgs.cpp    |    7 -------
 test/pdiff/CompareArgs.h      |    1 -
 test/pdiff/Metric.cpp         |   11 -----------
 test/pdiff/PerceptualDiff.cpp |   14 --------------
 test/pdiff/README.txt         |    4 ++--
 5 files changed, 2 insertions(+), 35 deletions(-)

commit 4438fb6dca1b4b6c0a30d66508339c3997ee94a4
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 00:38:39 2006 -0800

    pdiff: Move function that depends on command-line argument class to same file as main

 test/pdiff/Metric.cpp         |   61 -----------------------------------------
 test/pdiff/Metric.h           |    9 ++++--
 test/pdiff/PerceptualDiff.cpp |   54 ++++++++++++++++++++++++++++++++++++
 test/pdiff/RGBAImage.h        |    2 +-
 4 files changed, 62 insertions(+), 64 deletions(-)

commit c7379fcea478fbd3fc5e09a10828586e641e2375
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 00:30:54 2006 -0800

    pdiff: Rewrite Laplacian pyramid code from C++ to C

 test/pdiff/LPyramid.cpp       |   87 -------------------------------
 test/pdiff/LPyramid.h         |   38 --------------
 test/pdiff/Makefile.am        |    4 +-
 test/pdiff/Metric.cpp         |   22 ++++----
 test/pdiff/PerceptualDiff.cpp |    2 +-
 test/pdiff/lpyramid.cpp       |  113 +++++++++++++++++++++++++++++++++++++++++
 test/pdiff/lpyramid.h         |   32 ++++++++++++
 7 files changed, 159 insertions(+), 139 deletions(-)

commit 29456d38658b8ba7267fadeac9820a68227df787
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Dec 14 00:13:23 2006 -0800

    pdiff: Convert C++-style comments to good old-fashioned C-style comments

 test/pdiff/CompareArgs.cpp |    2 +-
 test/pdiff/CompareArgs.h   |   20 ++++++++++----------
 test/pdiff/LPyramid.cpp    |   12 ++++++------
 test/pdiff/LPyramid.h      |    4 ++--
 test/pdiff/Metric.cpp      |   24 +++++++++++++-----------
 test/pdiff/Metric.h        |    5 +++--
 test/pdiff/RGBAImage.cpp   |    6 +++---
 test/pdiff/RGBAImage.h     |    2 +-
 8 files changed, 39 insertions(+), 36 deletions(-)

commit 34a6af3c55cf8bba292cec8dc42fdc1917759a08
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 13 18:10:21 2006 -0800

    pdiff: Delete all trailing whitespace.

 test/pdiff/CompareArgs.cpp    |    4 ++--
 test/pdiff/CompareArgs.h      |    4 ++--
 test/pdiff/LPyramid.cpp       |    4 ++--
 test/pdiff/LPyramid.h         |    4 ++--
 test/pdiff/Metric.cpp         |   52 ++++++++++++++++++++---------------------
 test/pdiff/PerceptualDiff.cpp |    2 +-
 test/pdiff/RGBAImage.cpp      |    8 +++----
 test/pdiff/RGBAImage.h        |    2 +-
 8 files changed, 40 insertions(+), 40 deletions(-)

commit d421a856d08fba2fa0fdbd362d947497a952b347
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 13 18:08:25 2006 -0800

    pdiff: Re-indent all code
    
    I've given up on trying to preserve the old code formatting
    for compatibility. We're not planning on augmenting the algorithm
    itself, just integrating it into cairo. So I don't expect to
    make changes that we'll be all that interested in pushing
    upstream.

 test/pdiff/CompareArgs.cpp    |  162 ++++++-------
 test/pdiff/CompareArgs.h      |   46 ++--
 test/pdiff/LPyramid.cpp       |  100 ++++----
 test/pdiff/LPyramid.h         |   38 +--
 test/pdiff/Metric.cpp         |  514 ++++++++++++++++++++---------------------
 test/pdiff/PerceptualDiff.cpp |   52 ++---
 test/pdiff/RGBAImage.cpp      |  168 +++++++-------
 test/pdiff/RGBAImage.h        |   86 +++----
 test/pdiff/pdiff.h            |   20 +-
 9 files changed, 593 insertions(+), 593 deletions(-)

commit 4f6611ef6cac3928427b6fc28dab40829ef0d748
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 13 17:40:59 2006 -0800

    pdiff: Fix line endings

 test/pdiff/LPyramid.cpp |  174 +++++++++++++++++++++++------------------------
 test/pdiff/LPyramid.h   |   76 ++++++++++-----------
 2 files changed, 125 insertions(+), 125 deletions(-)

commit ccb3a6c4deadeaecf133dce6f1b152507ab5a14f
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 12 16:49:27 2006 -0800

    pdiff: Compile pdiff algorithm as a libtool convenience library
    
    The convenience library provides a pdiff_compare function with a
    cairo interface into the perceptual diff algorithm.

 test/Makefile.am       |    2 +-
 test/pdiff/Makefile.am |   14 +++++++++-----
 test/pdiff/Metric.cpp  |   18 ++++++++++++++++++
 test/pdiff/RGBAImage.h |    2 +-
 test/pdiff/pdiff.h     |   38 ++++++++++++++++++++++++++++++++++++++
 5 files changed, 67 insertions(+), 7 deletions(-)

commit 55f776876d231a035cdc5da9bb90cbba14f19248
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 12 16:37:35 2006 -0800

    test: Rework buffer_diff interface as new compare_surfaces
    
    This is a slightly kinder interface that accepts cairo_image_surface_t
    pointers rather than pointers to the raw image data and width, height,
    stride. This brings us closer to hooking up the pdiff code.

 test/buffer-diff.c |   28 +++++++++++++---------------
 test/buffer-diff.h |   15 ++++++---------
 2 files changed, 19 insertions(+), 24 deletions(-)

commit 0d7870b6bf13edfe513e2de25a5814a0a1b78c79
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 12 16:15:08 2006 -0800

    pdiff: Teach pdiff code to accept cairo image surfaces
    
    This is a second small step in enabling cairo's test suite and the
    pdiff code to start working together.

 test/pdiff/CompareArgs.cpp |   49 +++++++++++++++------------------
 test/pdiff/CompareArgs.h   |    1 +
 test/pdiff/Makefile.am     |    1 +
 test/pdiff/RGBAImage.h     |   64 ++++++++++++++++++++++++++++++++++++++------
 4 files changed, 79 insertions(+), 36 deletions(-)

commit a87f494d4b91f3acc78d6d7dd737939633f28d71
Author: Dan Amelang <dan@amelang.net>
Date:   Tue Dec 12 16:34:50 2006 -0800

    Don't use the GNU-only grep option "-a"
    
    We now use strings first, then grep to find the magic value, as suggested
    by various people in the reports for the bugs that this fixes:
    
        https://bugs.freedesktop.org/show_bug.cgi?id=9247
        https://bugs.freedesktop.org/show_bug.cgi?id=9124

 acinclude.m4 |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 41e01d95edd7eb573a8b79acd0ab2b9de8cdab40
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 12 03:13:38 2006 -0800

    pdiff: Factor out a comparison function that doesn't read the 'args' structure
    
    This is one small step in "libifying" pdiff which will make it
    easier to share this code inside cairo's test suite.

 test/pdiff/Metric.cpp |  112 +++++++++++++++++++++++++++++++------------------
 1 file changed, 72 insertions(+), 40 deletions(-)

commit b50b8db6d7d3d0a887ee18ad5e8e0455ed794429
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 12 02:17:19 2006 -0800

    test: Simplify buffer_diff by handling device offset in advance
    
    In a manner similar to flattening in advance, we now extract the sub-
    surface of interest (when testing with device offsets) before calling
    into the buffer_diff functions. This allows these functions to accept
    a single stride value once again instead of one for each of the three
    images.

 test/buffer-diff.c  |  103 ++++++++++++++++++++++++++++++++-------------------
 test/buffer-diff.h  |    8 +---
 test/xlib-surface.c |    4 --
 3 files changed, 67 insertions(+), 48 deletions(-)

commit 1781e6018c17909311295a9cc74b70500c6b4d0a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 11 03:31:10 2006 -0500

    [Xlib] Rewrite an optimized cairo_xlib_show_glyphs()
    
    The old implementation was a very naive one that used to generate one XRender
    glyph element per glyph.  That is, position glyphs individually.  This was
    raised here:
    
      http://lists.freedesktop.org/archives/cairo/2006-December/008835.html
    
    The new implmentation is a free rewriting of the Xft logic, that is,
    compressing glyphs with "natural" advance into elements, but with various
    optimizations and improvements.
    
    In short, it works like this: glyphs are looped over, skipping those that are
    not desired, and computing offset from "current position".  Whenever a glyph
    has non-zero offsets from the current position, a new element should be
    started.  All these are used to compute the request size in the render
    protocol.  Whenever the request size may exceed the max request size, or at
    the end, glyphs are flushed.  For this to work, we now set non-zero glyph
    advances when sending glyphs to the server.
    
    Notable optimizations and improvements include:
    
      - Reusing the input glyph array (with double glyph positions) as a working
        array to compute glyph offsets.
    
      - Reusing the input glyph array as the output glyph-index array to be passed
        to XRender.
    
      - Marking glyphs to be skipped as so, avoiding a copy of the glyph array,
        which is what the old code was doing.
    
      - Skip glyphs with positions "out-of-range".  That is, those with positions
        that would cause an overflow in Xrender's glyph offset calculations.
    
    On my Fedora desktop on Pentium 4, and on a Nokia 770, it shows a 6% speedup on
    the timetext test.

 src/cairo-xlib-surface.c |  477 +++++++++++++++++++++++++---------------------
 1 file changed, 257 insertions(+), 220 deletions(-)

commit 198c1439ab21b1b19310335d93242709d1398ff3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 11 03:16:50 2006 -0500

    Cache rounded glyph advance values
    
    This is done in cairo_scaled_glyph_t->x/y_advance.  The value is mostly useful
    for raster backends, for example to set as default advance of a glyph, and
    later on optimize glyph positionings that use the default advance.

 src/cairo-scaled-font.c |   10 ++++++++++
 src/cairoint.h          |    2 ++
 2 files changed, 12 insertions(+)

commit e7ed9eee767c85853d6d2fb823ff3317c490948c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 11 03:13:34 2006 -0500

    [cairo-gstate] Use a local buffer on the stack for small glyph operations
    
    We duplicate the incoming glyph array for two reasons: 1) applying
    transformations, and 2) to let the lower level functions have a glyph array
    they can modify.  By using a 2kb array on the stack we can avoid malloc() for
    requests of less than 100 glyphs.  The size of the array can be tuned by
    setting CAIRO_STACK_BUFFER_SIZE.

 src/cairo-gstate.c |   30 +++++++++++++++++++++++-------
 1 file changed, 23 insertions(+), 7 deletions(-)

commit da60bc45f295b15c62089874fb30cedc1d70bcd2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 11 03:10:05 2006 -0500

    [cairoint] Define CAIRO_STACK_BUFFER_SIZE (defaults to 2kb)
    
    This is the suggested size in bytes of buffers allocated on the stack per
    function, mostly used for glyph rendering.  We typically use a local buffer on
    the stack to avoid mallocing for small requests.  Requests that do not fit are
    malloc()ed automatically.  The default value should be enough for about a
    100-glyph cairo_show_glyphs() operation.

 src/cairoint.h |    7 +++++++
 1 file changed, 7 insertions(+)

commit 5a9642c5746fd677aed35ce620ce90b1029b1a0c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 11 01:39:51 2006 -0500

    Add/remove const to cairo_glyph_t* arguments consistently
    
    The rule is: cairo_glyph_t* is always passed as const for measurement
    purposes.  This was not reflected in our public api previously.  Fixed
    
    Showing glyphs used to have cairo_glyph_t* always as const.  With this
    changed, it is only const on cairo_t and cairo_gstate_t operations.
    cairo_surface_t, cairo_scaled_font_t, and individual backends receive
    cairo_glyph_t* as non-const.  The desired semantics is that they may modify
    the contents of the array as long as they do not return
    CAIRO_STATUS_UNSUPPORTED.  This makes it possible to avoid copying the glyph
    array again and again, and edit it in-place.  Backends are in fact free to use
    the array as a generic buffer as they see fit.

 src/cairo-analysis-surface.c         |    2 +-
 src/cairo-atsui-font.c               |    2 +-
 src/cairo-directfb-surface.c         |    2 +-
 src/cairo-glitz-surface.c            |    2 +-
 src/cairo-gstate.c                   |   12 ++++++------
 src/cairo-meta-surface.c             |    2 +-
 src/cairo-nquartz-surface.c          |    2 +-
 src/cairo-paginated-surface.c        |    2 +-
 src/cairo-pdf-surface.c              |    2 +-
 src/cairo-ps-surface.c               |    2 +-
 src/cairo-scaled-font.c              |    4 ++--
 src/cairo-surface-fallback-private.h |    2 +-
 src/cairo-surface-fallback.c         |    4 ++--
 src/cairo-surface.c                  |    4 ++--
 src/cairo-svg-surface.c              |    2 +-
 src/cairo-win32-font.c               |    2 +-
 src/cairo-win32-surface.c            |    2 +-
 src/cairo-xcb-surface.c              |    4 ++--
 src/cairo-xlib-surface.c             |    4 ++--
 src/cairo.c                          |    4 ++--
 src/cairo.h                          |    6 +++---
 src/cairoint.h                       |   28 +++++++++++-----------------
 src/test-meta-surface.c              |    2 +-
 src/test-paginated-surface.c         |    2 +-
 24 files changed, 47 insertions(+), 53 deletions(-)

commit 70695f5c62b89b417c1e8b42451470a5a8920bf3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 10 02:32:52 2006 -0500

    [FreeType] Remove "UNSUPPORTED" show_glyphs stub and NULL its entry
    
    The fallback paths always assume UNSUPPORTED if a method is NULL, so, no need
    for a method to just return UNSUPPORTED.

 src/cairo-ft-font.c |   19 +------------------
 1 file changed, 1 insertion(+), 18 deletions(-)

commit fea60c7283172be5efb42332a96fe322466bd6ed
Author: Dan Amelang <dan@amelang.net>
Date:   Sat Dec 9 18:54:47 2006 -0800

    Change _cairo_lround to correctly handle edge cases previously missed
    
    A nice side effect of this new approach is that the valid input range
    was expanded back to (INT_MIN, INT_MAX]. No performance regressions observed.
    Also included is documentation about the internal mysteries of _cairo_lround,
    as previously promised.

 src/cairo.c |  205 +++++++++++++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 179 insertions(+), 26 deletions(-)

commit cc75159587a4479951da354cfa282d81c74b0377
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 8 16:10:57 2006 -0500

    [FreeType] Do not return large structs from functions
    
    Pass cairo_ft_options_t around by pointer, not by value.  That's what we do
    with cairo_font_options_t anyway, and there is no reason to not do the same
    here.  (makes -Waggregate-return warnings go away btw).

 src/cairo-ft-font.c |   25 +++++++++++++------------
 1 file changed, 13 insertions(+), 12 deletions(-)

commit beadc7da864c974558b8e98723e9d2533baab630
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 8 15:42:24 2006 -0500

    [docs] Update templates

 doc/public/tmpl/cairo-pattern.sgml     |   76 +++++++++++++++++++++
 doc/public/tmpl/cairo-status.sgml      |   50 +++++++-------
 doc/public/tmpl/cairo-surface.sgml     |  114 ++++++++++++++++----------------
 doc/public/tmpl/cairo-text.sgml        |    1 +
 doc/public/tmpl/cairo-win32-fonts.sgml |   18 +++++
 doc/public/tmpl/cairo-win32.sgml       |   21 ++++++
 doc/public/tmpl/cairo.sgml             |   69 +++++++++++++++++++
 7 files changed, 267 insertions(+), 82 deletions(-)

commit cdd79c104dd940077b1f3193c31272f9a4673bb5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 8 15:41:52 2006 -0500

    [docs] Generate index of new symbols in 1.4

 doc/public/cairo-docs.xml |    3 +++
 1 file changed, 3 insertions(+)

commit 16c7587f2dcab5abbbe62505e64c1ac9441dfb8e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 8 15:40:59 2006 -0500

    [slim] Define slim macros to dummy prototypes for non-gcc compilers (#9150)

 src/cairoint.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6122c30930525c0d672166eab8b05e0951c7b039
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 8 15:38:34 2006 -0500

    [pixman] Remove unused slim_internal.h

 pixman/src/slim_internal.h |  103 --------------------------------------------
 1 file changed, 103 deletions(-)

commit 734b321aab3df046716a54cfdcefbe42fa6b1a8b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 7 00:14:37 2006 -0500

    [doc] Minor wording improvement.

 doc/public/tmpl/cairo-version.sgml |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit eedd86165efed065bf79469b1cf57c0127012b98
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 7 00:08:09 2006 -0500

    [docs] Document CAIRO_VERSION_STRING.

 doc/public/tmpl/cairo-version.sgml |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 9b87fab8ce283e966da7ac850980397cb9e199cc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 6 23:52:22 2006 -0500

    [docs] Hook various new API into cairo-sections.txt

 doc/public/cairo-sections.txt |   18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 0e028ee0f3bfb95d8483bb4c84b84c4bd53b8c53
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 6 23:40:08 2006 -0500

    [doc/public/Makefile.am] Move the list of private headers generatable
    
    Move the list of private headers into separate file Headers.mk that
    Makefile.am includes (using automake).  To update the list, just remove
    Headers.mk and make.

 doc/public/Headers.mk  |   31 +++++++++++++++++++++++++
 doc/public/Makefile.am |   59 ++++++++++++++++++++----------------------------
 2 files changed, 55 insertions(+), 35 deletions(-)

commit b8e1f3778e61e3c5a809f610a1af97ea56a9960e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 6 23:38:20 2006 -0500

    [docs] Document various CAIRO_VERSION_* macros

 doc/public/tmpl/cairo-version.sgml |   20 ++++++++++++--------
 1 file changed, 12 insertions(+), 8 deletions(-)

commit fd03991a6a78d849e2184f53a2b1b6915a6a64d0
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Dec 7 04:46:07 2006 +0200

    test: random-intersections
    
    The purpose of this test case is to help make
    sure that changes to the trapezoid generation or
    intersection computation in the tessellator
    don't break it.

 test/Makefile.am                            |    4 ++
 test/random-intersections-ps-argb32-ref.png |  Bin 0 -> 107578 bytes
 test/random-intersections-ref.png           |  Bin 0 -> 177153 bytes
 test/random-intersections-rgb24-ref.png     |  Bin 0 -> 132210 bytes
 test/random-intersections.c                 |   79 +++++++++++++++++++++++++++
 5 files changed, 83 insertions(+)

commit 6301f92d2af2fd7928352965bcab42bab9deb59d
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Dec 7 02:30:41 2006 +0200

    Rework the in-fill-empty-trapezoid test to not use the cairo_test() framework.
    
    As suggested by Behdad Esfahbod, we can not use the cairo_test() framework
    when it is getting in the way.  The test itself doesn't depend on any
    particular backend.
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008809.html

 test/Makefile.am                           |    2 --
 test/in-fill-empty-trapezoid-ref.png       |  Bin 108 -> 0 bytes
 test/in-fill-empty-trapezoid-rgb24-ref.png |  Bin 107 -> 0 bytes
 test/in-fill-empty-trapezoid.c             |   54 ++++++++++++++++------------
 4 files changed, 31 insertions(+), 25 deletions(-)

commit c13a1a2ed0ce8ba2b43e4e70c66cdc5b98e80eb4
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Dec 7 01:42:07 2006 +0200

    Replace point sampling in the fill-degenerate-sort-order with rendering.
    
    Clean up the test to not even check the ps backend as per:
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008806.html

 boilerplate/cairo-boilerplate.c               |    3 +++
 test/fill-degenerate-sort-order-ref.png       |  Bin 643 -> 2397 bytes
 test/fill-degenerate-sort-order-rgb24-ref.png |  Bin 611 -> 2060 bytes
 test/fill-degenerate-sort-order.c             |   32 +++----------------------
 4 files changed, 6 insertions(+), 29 deletions(-)

commit 565a715d119d00ac141d1b235dab7985ed78113a
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Dec 7 01:16:43 2006 +0200

    Change license of tessellator tests to the MIT license.
    
    The blurb for the fill-degenerate-sort-order, fill-missed-stop and
    in-fill-empty-trapezoid tests changed to this one:
    
    http://www.opensource.org/licenses/mit-license.php
    
    c.f. http://lists.freedesktop.org/archives/cairo/2006-December/008806.html

 test/fill-degenerate-sort-order.c |   35 ++++++++++++++++++-----------------
 test/fill-missed-stop.c           |   35 ++++++++++++++++++-----------------
 test/in-fill-empty-trapezoid.c    |   35 ++++++++++++++++++-----------------
 3 files changed, 54 insertions(+), 51 deletions(-)

commit e857ac325a048799016196bc65ce6ff279c01431
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Dec 7 00:52:43 2006 +0200

    tessellator bug fix: linking fails on x86_64 due to superfluous inline attribute.
    
    Remove inline attribute from cairo_bo_event_compare_abstract()
    to fix the linking issue reported by Jinghua Luo on the mailing list:
    
    http://lists.freedesktop.org/archives/cairo/2006-November/008574.html

 src/cairo-bentley-ottmann.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 16c0db0d6843184e79b73a3613f65c0cc06a684d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 6 19:02:09 2006 -0500

    [test] Break the "make clean" target into serveral rm calls
    
    Some systems cannot handle very long list of arguments.  Carl was hitting this
    for "make clean".  Break it out into several rm calls triggered by the
    clean-local target.

 test/Makefile.am |   15 +++++++++------
 1 file changed, 9 insertions(+), 6 deletions(-)

commit 3cf994779580fe3355356c00e20a93ddb676355e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 6 18:52:45 2006 -0500

    [.gitignore] Add big-trap

 test/.gitignore |    1 +
 1 file changed, 1 insertion(+)

commit 4b43a3a1c4d4f4659e604cea1d79e1b5e18ce107
Author: Peter Weilbacher <pmw@avila.aip.de>
Date:   Thu Dec 7 00:27:29 2006 +0100

    Add OS/2 backend and its requirement to INSTALL and README, following the example of BeOS.

 INSTALL |    1 +
 README  |    9 ++++++++-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 652f73f0907c0d4b4bee155a73acb4a6a0cf5f37
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 6 13:40:52 2006 -0800

    Bump version to 1.3.7 after making 1.3.6 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 648ef4487dfa43f20fb2c73e7b8e567f8a25497a
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 6 13:22:24 2006 -0800

    Increment cairo version to 1.3.6 (and libtool versioning to 12:1:10)

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f0459b3c53d3319822ef6e5f8bc118e742dcbf5f
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 6 13:20:04 2006 -0800

    NEWS: Add notes for 1.3.6 snapshot

 NEWS |   65 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 65 insertions(+)

commit e840c120ddc5ad3adeba95c2baf5262aae57d9d1
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 6 13:19:30 2006 -0800

    Fix 'make distcheck' by mentioning test/pdiff in DIST_SUBDIRS

 test/Makefile.am |    2 ++
 1 file changed, 2 insertions(+)

commit b83f9e766a0925a59f0db488ef8c905f3fcbcbe4
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Dec 6 13:17:41 2006 -0800

    ROADMAP: Note that the Banker's rounding bug is fixed

 ROADMAP |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce58f874fe25334961807a2cecf6066b18569c05
Author: Dan Amelang <dan@amelang.net>
Date:   Tue Dec 5 23:45:15 2006 -0800

    Change _cairo_lround to use arithmetic rounding
    
    This fixes the text rendering bug reported here:
    
        https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=217819
    
    No performance impact on x86. On the 770, I see minor speedups in text_solid
    and text_image (~1.05x).

 src/cairo.c |   57 +++++++++++++++++++++++++++++++++++++++++++++------------
 1 file changed, 45 insertions(+), 12 deletions(-)

commit d0eff3919646e8a4c9981c349e33060fdb27c94e
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Wed Dec 6 05:53:53 2006 +0200

    tessellator: input validation and guard bit removal
    
    This patch removes the guard bits from the tessellator internal
    coordinates and reworks the input validation to make sure that the
    tessellator code should never die on an assert.  When the extent of a
    polygon exceeds a width or height of 2^31-1, then the rightmost
    (resp. bottommost) points are clamped to within 2^31-1 of the leftmost
    (resp. topmost) point of the polygon.  The clamping produces bad
    rendering for really large polygons, and needs to be fixed in a saner
    manner.
    
    Cleaned up as per
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008806.html

 src/cairo-bentley-ottmann.c |  147 +++++++++++++++++++++++--------------------
 1 file changed, 78 insertions(+), 69 deletions(-)

commit f8ba74917296be226f7a957ad1a26685bb6d846c
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 22:56:22 2006 +0200

    tessellator: offset working coordinates to be nonnegative
    
    This patch improves the translation invariance of the tessellator
    by offsetting all input coordinates to be nonnegative and paves
    the way for future optimisations using the coordinate range.
    
    Also changes the assertions to make sure that it is safe to add
    the guard bits.  This needs to be changed to do something sensible
    about input coordinates that are too large instead of croaking.
    The plan is to steal the guard bits from the least significant
    instead of the most significant user bits, and having all coordinates
    nonnegative will make the rounding involved there easier.

 src/cairo-bentley-ottmann.c |  126 ++++++++++++++++++++++++++++++++-----------
 1 file changed, 96 insertions(+), 30 deletions(-)

commit 633c51b4426f5405db0eac5edb81651b7e1491ef
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 21:55:50 2006 +0200

    tessellator bug fix: in-fill-empty-trapezoid
    
    The cairo_in_fill() function sometimes gives false positives
    when it samples a point on the edge of an empty trapezoid.
    This patch alleviates the bug (but doesn't fix it completely),
    for the common(?) case where the left and right edges of the
    empty trapezoid have equal top and bottom points.

 src/cairo-bentley-ottmann.c |   31 +++++++++++++++++++++----------
 1 file changed, 21 insertions(+), 10 deletions(-)

commit e6c8febca7a24f6cf4138a25c96a36e4e7721a92
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 21:38:25 2006 +0200

    tessellator bug fix: fill-missed-stop
    
    Fixes the regression exhibited by the test fill-missed-stop,
    where the tessellator would sometimes extend a trapezoid
    too far below the end of the right edge.

 src/cairo-bentley-ottmann.c |    8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 614117e487f36c66f2a479c96e1cb4daef625608
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 21:31:23 2006 +0200

    tessellator bug fix: fill-degenerate-sort-order
    
    Fixes the regression fill-degenerate-sort-order, where
    confusion arises in the event order for collinear edges.
    Also fixes (or at least hides) the issues with zrusin-another
    sometimes generating different trapezoids depending on the
    state of the random number generator in cairo-skiplist.c.

 src/cairo-bentley-ottmann.c |   40 +++++++++++++++++++++++++++++-----------
 1 file changed, 29 insertions(+), 11 deletions(-)

commit 48b42efcfee470a1224d6ad0646525964ac640c6
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 13:02:47 2006 +0200

    test: check for tessellator regression from missed stop events
    
    The new tessellator contains a regression where stop events
    that aren't followed by start events sometimes cause the
    trapezoid to the left of an edge to be too high.

 test/Makefile.am                        |    4 ++
 test/fill-missed-stop-ps-argb32-ref.png |  Bin 0 -> 564 bytes
 test/fill-missed-stop-ref.png           |  Bin 0 -> 466 bytes
 test/fill-missed-stop-rgb24-ref.png     |  Bin 0 -> 394 bytes
 test/fill-missed-stop.c                 |   89 +++++++++++++++++++++++++++++++
 5 files changed, 93 insertions(+)

commit e94e0a1ca262ef67b527b13a5e9691ad42a43204
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 12:20:17 2006 +0200

    test: check if cairo_in_fill() is reporting false positives for empty trapezoids.
    
    cairo_in_fill() may report true if a query point lands on an edge of an
    empty trapezoid.

 test/Makefile.am                           |    3 +
 test/in-fill-empty-trapezoid-ref.png       |  Bin 0 -> 108 bytes
 test/in-fill-empty-trapezoid-rgb24-ref.png |  Bin 0 -> 107 bytes
 test/in-fill-empty-trapezoid.c             |   89 ++++++++++++++++++++++++++++
 4 files changed, 92 insertions(+)

commit 00d7b6acdd263f7b46ea98c4a5b777fc93a65be5
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 11:21:14 2006 +0200

    test: tessellator event comparator test case for degenerate edges.
    
    There's currently a regression bug in the tessellation code from
    switching to the new tessellator.  The bug is caused by
    confusion in the comparator used to order events when there are
    degenerate edges.  This test is derived from the zrusin-another
    performance test case.

 test/Makefile.am                              |    3 +
 test/fill-degenerate-sort-order-ref.png       |  Bin 0 -> 643 bytes
 test/fill-degenerate-sort-order-rgb24-ref.png |  Bin 0 -> 611 bytes
 test/fill-degenerate-sort-order.c             |  110 +++++++++++++++++++++++++
 4 files changed, 113 insertions(+)

commit c92f23caa549651a05863ecda19c55c112350528
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Dec 5 11:14:49 2006 -0800

    ROADMAP: Add _cairo_lround bug for 1.3.6. Note some completed items for 1.4.0

 ROADMAP |   14 +++++++++-----
 1 file changed, 9 insertions(+), 5 deletions(-)

commit 4057a98f88947730bb0678f361278cc71cc33751
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Dec 5 05:46:26 2006 +0200

    cairo-perf-diff-files: Don't segfault reading cooked perf reports.
    
    Fixes cairo-perf-diff-files for non-raw cairo-perf reports.  Similar
    to the patch on the mailing list, only applied to the caller of
    _cairo_stats_compute():
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008720.html

 perf/cairo-perf-diff-files.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a4f5463cdd5e2b088cd009de332db821ef0bd806
Author: Mathieu Lacage <Mathieu.Lacage@sophia.inria.fr>
Date:   Tue Dec 5 03:59:11 2006 +0200

    bugfix: fix cairo-wideint.c uint64_t usage and const return qualifiers
    
    These patches were sent to the cairo mailing list by Mathieu Lacage
    <Mathieu.Lacage@sophia.inria.fr>:
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008741.html
    
      _cairo_uint_96by64_32x64_divrem(): fixes misuse of the uint64_t type
      and cairo-wideint-private.h functions.
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008742.html
    
      Remove const qualifiers from return types from cairo-wideint.c functions.
    
    http://lists.freedesktop.org/archives/cairo/2006-December/008747.html
    
      Fixes a typo in cairo-wideint-private.h: _cairo_uint128_to_int128_
      had an extra trailing underscore.

 src/cairo-wideint-private.h |    2 +-
 src/cairo-wideint.c         |   14 +++++++-------
 2 files changed, 8 insertions(+), 8 deletions(-)

commit 94e086b7b9f4129bde3e32b7005e2a33788f334a
Author: Dan Amelang <dan@amelang.net>
Date:   Sat Dec 2 11:24:35 2006 -0800

    [configure] Fix --disable-some-floating-point to force value to 'no' if none given
    
    As suggested by Behdad here:
    
        http://lists.freedesktop.org/archives/cairo/2006-December/008700.html

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 392f27bf2b210aec6f511e5dba890d5f4c3b8802
Author: Dan Amelang <dan@amelang.net>
Date:   Sat Dec 2 11:02:36 2006 -0800

    [configure] Add -a option to grep calls in AX_C_FLOAT_WORDS_BIGENDIAN
    
    This fixes bug #9124 reported here:
    
        https://bugs.freedesktop.org/show_bug.cgi?id=9124

 acinclude.m4 |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3dbe468fd6071adfba5f608da788502f1840af36
Author: Dan Amelang <dan@amelang.net>
Date:   Fri Dec 1 14:12:16 2006 -0800

    [perf] Provide watered-down implementations of getline and strndup for
    building on non-GNU toolchains.

 perf/cairo-perf-diff-files.c |   58 +++++++++++++++++++++++++++++++++++++++---
 1 file changed, 55 insertions(+), 3 deletions(-)

commit d5fcbfc29f2ae6eacdab1d00d9e7ce8d1cf39431
Author: Dan Amelang <dan@amelang.net>
Date:   Fri Dec 1 12:46:55 2006 -0800

    Purge cairo-test of all calls to round()
    
    Although round() is in the C99 standard, it isn't available in all
    toolchains on which cairo is compiled (VC++, for example).

 test/clip-operator.c      |    4 ++--
 test/operator-clear.c     |    4 ++--
 test/operator-source.c    |    4 ++--
 test/unbounded-operator.c |    4 ++--
 4 files changed, 8 insertions(+), 8 deletions(-)

commit cb9a3c264086d0d11b74c504e5d3f891f929b00e
Author: Dan Amelang <dan@amelang.net>
Date:   Fri Dec 1 12:41:55 2006 -0800

    Add configure option --disable-some-floating-point
    
    See discussion here: http://lists.freedesktop.org/archives/cairo/2006-November/008602.html

 configure.in |   23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 7fb4e978735bd7c9f3cff970ac6757feff3e74bb
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 30 09:15:00 2006 -0800

    BIBLIOGRAPHY: Add Joseph O'Rourke's book as recommended by Rafael Villar Burke

 BIBLIOGRAPHY |    7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 7fbe594d3d04137daca4d3c3a28057b71b03f33d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 30 08:43:27 2006 -0800

    Add a textbook recommendation to the bibliography
    
    Thanks to Mathieu Lacage for the recommendation of:
    
    	"Computational Geometry, Algorithms and Applications", M. de
    	Berg, M. van Kreveld, M. Overmars, M. Schwarzkopf

 BIBLIOGRAPHY |   21 +++++++++++++++++----
 1 file changed, 17 insertions(+), 4 deletions(-)

commit 170d35b034150b69717e52dd85f0f93c392d9f3c
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 29 23:01:30 2006 -0800

    pdiff: Add missing newlins at end of files.

 test/pdiff/CompareArgs.h |    2 +-
 test/pdiff/LPyramid.cpp  |    1 -
 test/pdiff/LPyramid.h    |    2 +-
 test/pdiff/Metric.cpp    |    2 +-
 test/pdiff/Metric.h      |    2 +-
 test/pdiff/RGBAImage.h   |    2 +-
 6 files changed, 5 insertions(+), 6 deletions(-)

commit c863315285911d38b64b8429e279c5e55d0089b8
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 21 14:19:35 2006 -0800

    Hook up Makefiles for perceptualdiff.

 configure.in           |    1 +
 test/pdiff/Makefile.am |   14 ++++++++++++++
 2 files changed, 15 insertions(+)

commit 6e06b68452ec68b7ab227c54284f28a605512ce4
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 21 14:19:55 2006 -0800

    Remove all libtiff-related code by #ifdef

 test/pdiff/CompareArgs.cpp |    8 ++++++++
 test/pdiff/RGBAImage.cpp   |    3 +++
 2 files changed, 11 insertions(+)

commit 2b92556abe440e9834174aed7395e2827f62897c
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 29 22:55:00 2006 -0800

    Use uint32_t instead of the non-standard uint32

 test/pdiff/RGBAImage.cpp |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 812fd53499d308ff881751e57c1e3287498ddd0f
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 21 12:15:16 2006 -0800

    Add perceptualdiff program totest/pdiff.
    
    The perceptualdiff program was written by Hector Yee with contributions
    from Scott Corley and Mick Weiss. It is hosted at http://pdiff.sourceforge.net
    The source code added here was obtained by:
    
    	svn co https://svn.sourceforge.net/svnroot/pdiff/trunk pdiff
    
    which gave revision 22 of the source code.
    
    The perceptualdiff program is available under the terms of the GNU GPL,
    so I've added a note to COPYING about this program, (and the fact that
    it is auxiliary only, and does not affect the license of the implementation
    of cairo itself).

 COPYING                       |   21 ++-
 test/pdiff/CMakeLists.txt     |   55 +++++++
 test/pdiff/CompareArgs.cpp    |  128 ++++++++++++++++
 test/pdiff/CompareArgs.h      |   44 ++++++
 test/pdiff/LPyramid.cpp       |   88 +++++++++++
 test/pdiff/LPyramid.h         |   38 +++++
 test/pdiff/Metric.cpp         |  316 ++++++++++++++++++++++++++++++++++++++
 test/pdiff/Metric.h           |   26 ++++
 test/pdiff/PerceptualDiff.cpp |   45 ++++++
 test/pdiff/README.txt         |   45 ++++++
 test/pdiff/RGBAImage.cpp      |  141 +++++++++++++++++
 test/pdiff/RGBAImage.h        |   57 +++++++
 test/pdiff/gpl.txt            |  340 +++++++++++++++++++++++++++++++++++++++++
 13 files changed, 1341 insertions(+), 3 deletions(-)

commit d9fd942e4774aa29967f908001b62dbc987d2f66
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 29 17:18:50 2006 -0800

    Add an initial BIBLIOGRAPHY for cairo

 BIBLIOGRAPHY |   70 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 70 insertions(+)

commit 8f08daade0430bf965050a81e654aac2a2375b07
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 29 17:15:29 2006 -0800

    RELEASING: Fix typo

 RELEASING |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit facffb7ea3e03d131a79486b80d4efc58c303b87
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 28 19:41:52 2006 -0500

    [configure] Remove the pkg-config minimum version requirement
    
    It was added in commit 157663e1fdf120a71c6cc8222b88d2915a5a73eb because there
    was a serious bug in the pkg.m4 file from pkg-config 0.18.  However, it was
    fixed two days later.  So, instead of requireing 0.18.1 or greater which is
    not available on Nokia 770 SDK, we just ignore the broken pkg-config 0.18.
    The problem only happens if one runs autogen.sh with against a broken
    pkg-config.  Configuring tarballs is not affected.

 configure.in |    3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 72a4a9834626ddd05c57c6b3f59e936969f0eee9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Nov 27 13:23:13 2006 -0500

    [test|perf|boilerplate/Makefile.am] Add -I$(top_builddir)/src to INCLUDES
    needed to find cairo-features.h when building out of tree.

 boilerplate/Makefile.am |    1 +
 perf/Makefile.am        |    1 +
 test/Makefile.am        |    1 +
 3 files changed, 3 insertions(+)

commit 9c3b161c7067d8eda7f8d1cfb36ca285e4e7fa35
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 19:31:56 2006 -0800

    Bump version to 1.3.5 after making 1.3.4 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 143c56cb12ee5d0b0fbc5e4039dd4fc88764254d
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 19:15:31 2006 -0800

    Increment cairo version to 1.3.4

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e9dd52a337082cebbab2224e3a09702ada8f8e87
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 19:15:00 2006 -0800

    NEWS: Add notes for 1.3.4 snapshot

 NEWS |  152 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 152 insertions(+)

commit 3329abba391ebd502ba74b00ff02b7902a39945a
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 19:11:51 2006 -0800

    Add Daniel Amelang and Joonas Pihlaja to the AUTHORS file

 AUTHORS |    2 ++
 1 file changed, 2 insertions(+)

commit a8f6d27fba582cc8e935676d26c703fa7b253822
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 18:42:48 2006 -0800

    Add some missing cairo_private decorators

 src/cairo-freelist-private.h |   12 +++++++-----
 src/cairo-skiplist-private.h |   14 ++++++++------
 src/cairoint.h               |    4 ++--
 3 files changed, 17 insertions(+), 13 deletions(-)

commit fac3684e686a259658151dac13907fa69f43f727
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Wed Nov 22 08:30:28 2006 +0200

    perf: new-tessellator: Deferred trapezoid generation (first try)

 src/Makefile.am              |    2 +
 src/cairo-bentley-ottmann.c  |  163 ++++++++++++++++++++++++++++++++++++------
 src/cairo-freelist-private.h |   71 ++++++++++++++++++
 src/cairo-freelist.c         |   72 +++++++++++++++++++
 4 files changed, 285 insertions(+), 23 deletions(-)

commit 6bd72ce74aba4a576e5aa76a5c92bd5557ae97f1
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Nov 20 04:19:17 2006 +0200

    Sort pointers instead of cairo_bo_events in the tessellator.
    
    We were spending a lot of time in memcpy.

 src/cairo-bentley-ottmann.c |   54 +++++++++++++++++++++++++++----------------
 1 file changed, 34 insertions(+), 20 deletions(-)

commit b177573b729401117a061cd6f07743fa81c01724
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Nov 20 03:56:07 2006 +0200

    Make the skip list check for uniqueness.
    
    This patch removes a redundant call to skip_list_find()
    that was being used to detect duplicate intersection events.
    Instead, skip_list_insert() now takes an additional parameter
    letting it know what to do with duplicates.

 src/cairo-bentley-ottmann.c  |   12 ++++--------
 src/cairo-skiplist-private.h |    8 +++++---
 src/cairo-skiplist.c         |   25 +++++++++++++++----------
 3 files changed, 24 insertions(+), 21 deletions(-)

commit 8bec0bac56785434f5e5860cf5f3560cac82ebb2
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Nov 20 03:45:26 2006 +0200

    Malloc less using a free list of nodes.

 src/cairo-skiplist-private.h |    1 +
 src/cairo-skiplist.c         |   45 ++++++++++++++++++++++++++++++++++--------
 2 files changed, 38 insertions(+), 8 deletions(-)

commit de0e327b3d9aec50d970d8cfc881fb3949df59cc
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Nov 20 03:14:20 2006 +0200

    Tweak comparators.

 src/cairo-bentley-ottmann.c |   60 +++++++++++++++++++++----------------------
 1 file changed, 29 insertions(+), 31 deletions(-)

commit 67359d7a58c14851936345417833b1e610987c19
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sat Nov 18 14:59:23 2006 +0200

    Separate start and stop events from intersections (first try.)
    
    Don't use the skip list for start and stop events, but presort
    those first.

 src/cairo-bentley-ottmann.c  |  119 ++++++++++++++++++++++++++++++++++--------
 src/cairo-skiplist-private.h |    7 +++
 src/cairo-skiplist.c         |   10 ++++
 3 files changed, 114 insertions(+), 22 deletions(-)

commit 97f02dca5d97c9ab815abf881525542ba86cbb11
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sat Nov 18 01:08:56 2006 +0200

    Avoid a skip-list lookup when deactivating edges.

 src/cairo-bentley-ottmann.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 99f8a5313d336a2779689122feef03b874ed930e
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sat Nov 18 01:01:04 2006 +0200

    Special cases for skip list comparators.

 src/cairo-bentley-ottmann.c |   39 +++++++++++++++++++++++++++++++++++++--
 1 file changed, 37 insertions(+), 2 deletions(-)

commit fd8cd39cda7bfde429d840ffd7d5c78ac3045505
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Fri Nov 17 12:24:44 2006 +0200

    Use an LFSR instead of random().

 src/cairo-skiplist.c |  189 +++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 188 insertions(+), 1 deletion(-)

commit d957e59744ba6fc482d3ddbce041877e703c0489
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Wed Nov 15 19:58:54 2006 +0200

    Replace the 128 bit divrem by a 96/64 bit one.

 src/cairo-bentley-ottmann.c |   78 +++++++++++++++++++++++--------------------
 1 file changed, 42 insertions(+), 36 deletions(-)

commit 1da14262ea059836ae63b875c987fdb5c526db83
Author: Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Wed Nov 15 19:57:04 2006 +0200

    A 96 by 64 bit divrem that produces a 32 bit quotient and 64 bit remainder.

 src/cairo-wideint-private.h |    8 +++
 src/cairo-wideint.c         |  152 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 160 insertions(+)

commit 762bd1330d5e3148ddd60949866227cb75b782d6
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Sep 22 17:28:00 2006 -0700

    Make event_queue_insert ignore duplicate intersection events (not duplicate start/stop events)
    
    This fixes the failures of the new tessellator with the 3 tests:
    bitmap-font, rectangle-rounding-error, and close-path
    The problem was that identical edges from separate polygons
    were not being added to the event queue, (because of a check
    that was actually only intended to prevent an intersection
    event from being scheduled multiple times).

 src/cairo-bentley-ottmann.c |   11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit 4cd871b6f371e86c252c2fa8d8af481d822a1dec
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Sep 20 10:47:58 2006 -0700

    Switch from old tessellator to new tessellator

 src/Makefile.am         |    3 +++
 src/cairo-path-fill.c   |    6 +++---
 src/cairo-path-stroke.c |    2 +-
 src/cairo-pen.c         |    2 +-
 src/cairo-traps.c       |    7 +------
 src/cairoint.h          |   10 ++++++++++
 6 files changed, 19 insertions(+), 11 deletions(-)

commit 0f7c488906128557807ca98aed5c442abf0a0b75
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Sep 20 10:47:01 2006 -0700

    Adapt new tessellator to match the interface provided by the old tessellator.

 src/cairo-bentley-ottmann.c |  163 ++++++++++++++++++++++++++++++-------------
 1 file changed, 114 insertions(+), 49 deletions(-)

commit 8921f733995bc003c6977fd071f0be9e346e0f79
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Sep 20 10:41:42 2006 -0700

    Add new tessellator (unused) in cairo-bentley-ottmann.c
    
    This is the implementation as it cooked in the new-tessellator branch
    available from:
    
    	git://people.freedesktop.org/~cworth/cairo
    
    The file here comes from commit eee4faf79900be2c5fda1fddd49737681a9e37d6 in
    that branch. It's sitting here not hooked up to anything in cairo yet,
    and still with a main function with test cases, etc.

 src/cairo-bentley-ottmann.c | 1383 +++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 1383 insertions(+)

commit c2509f8a721ec489e1b44fa8a68be165363787a7
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Sep 20 10:27:35 2006 -0700

    Add skip list implementation (many thanks to Keith Packard)
    
    The files here are copied directly from the standalone skiplist module
    available from:
    
    	git clone git://cworth.org/~cworth/skiplist
    
    In particular the files come from the double branch and the following
    commit on that branch:
    
    	8b5a439c68e220cf1514d9b3141a1dbdce8af585
    
    Also of interest is the original skiplist module hosted by Keith Packard
    that is the original implementation on which these files were based.
    Since the cworth/skiplist branched off of keithp's, Keith has also
    now implemented a doubly-linked variant which might be interesting for
    further simplification of the code. See:
    
    	git clone git://keithp.com/git/skiplist
    
    and the double-link branch there.

 src/cairo-skiplist-private.h |   87 +++++++++++++++
 src/cairo-skiplist.c         |  238 ++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 325 insertions(+)

commit 02804773e7ef521adfbd26f90f303879198acde5
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 16:52:18 2006 -0800

    give the big-trap test the XFAIL treatment.
    
    We'll need to rewrite this test (and the way cairo is compiled for
    testing) before it can exercise the bug of interest. In the
    meantime, let's just give it an "expected failure" status.

 test/Makefile.am |    1 +
 test/big-trap.c  |   36 +++++++++++++++++++++++++++++++++++-
 2 files changed, 36 insertions(+), 1 deletion(-)

commit fdbb820ece5e6ab970cf6a9b756eebf7283c0597
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 22 16:43:45 2006 -0800

    test: Use round to pass only integers to cairo_show_glyphs (in 3 more tests)
    
    This is the same fix as in the recent commit (166dffc96aa26b21f87f12af22b11630583cc85b)
    but for the same idiom that appears in the operator-clear,
    operator-source, and unbounded-operator tests. This fixes
    the failures that were introduced by the recent switch to
    _cairo_lround.

 test/operator-clear.c     |    4 ++--
 test/operator-source.c    |    4 ++--
 test/unbounded-operator.c |    4 ++--
 3 files changed, 6 insertions(+), 6 deletions(-)

commit 11d21dbaa3604951f73b641e4d88723696157a8e
Author: Dan Amelang <dan@amelang.net>
Date:   Tue Nov 21 14:50:29 2006 -0800

    Change _cairo_matrix_to_pixman_matrix to use a pixman_transform_t as the template, thus avoiding a forced memcpy

 src/cairo-matrix.c |    8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit 8a5e296239d1cac705c3c397ab1fd7f7f2ff8d58
Author: Dan Amelang <dan@amelang.net>
Date:   Tue Nov 21 12:14:05 2006 -0800

    Optimize _cairo_matrix_to_pixman_matrix for the common case of an identity matrix

 src/cairo-matrix.c |   35 ++++++++++++++++++++++++-----------
 1 file changed, 24 insertions(+), 11 deletions(-)

commit b7cd46ddc2a2523b4d33b22e07cdbdc09b90fa7d
Author: Dan Amelang <dan@amelang.net>
Date:   Mon Nov 20 14:31:28 2006 -0800

    Add and incorporate _cairo_gstate_transform_glyphs_to_backend
    
    After changing _cairo_gstate_show_glyphs and _cairo_gstate_glyph_path to use
    this function, we see a significant speedup due to the elimination of redundant
    FP calculations.

 src/cairo-gstate.c |   92 ++++++++++++++++++++++++++++++++++++++++------------
 1 file changed, 72 insertions(+), 20 deletions(-)

commit 6cfb4a01e005cb0f4f797ff9aa02e80b3d755a9e
Author: Dan Amelang <dan@amelang.net>
Date:   Mon Nov 20 14:08:46 2006 -0800

    Refactor _cairo_matrix_is_integer_translation
    
    Now that we have _cairo_matrix_is_translation, we can change
    _cairo_matrix_is_integer_translation to use it and thus reduce code
    duplication.

 src/cairo-matrix.c |   42 +++++++++++++++++++-----------------------
 1 file changed, 19 insertions(+), 23 deletions(-)

commit ca79307bdf9bc8042c9afd570bf10d605d3dfc1e
Author: Dan Amelang <dan@amelang.net>
Date:   Mon Nov 20 10:42:50 2006 -0800

    Add _cairo_matrix_is_translation

 src/cairo-matrix.c |    7 +++++++
 src/cairoint.h     |    3 +++
 2 files changed, 10 insertions(+)

commit 57fba8d9b6915fe4b0f506ecb2ef18a9002de370
Author: Daniel Amelang <dan@ereba.localdomain>
Date:   Thu Nov 2 22:24:34 2006 -0800

    Replace existing rounding code with _cairo_lround

 src/cairo-directfb-surface.c |   12 ++++++------
 src/cairo-ft-font.c          |    4 ++--
 src/cairo-glitz-surface.c    |    4 ++--
 src/cairo-scaled-font.c      |   14 ++++++--------
 src/cairo-win32-font.c       |   14 ++++++++------
 src/cairo-win32-surface.c    |    7 ++++---
 src/cairo-xcb-surface.c      |   28 ++++++++++++++--------------
 src/cairo-xlib-surface.c     |   16 ++++++++--------
 8 files changed, 50 insertions(+), 49 deletions(-)

commit efb483c3a36f8168d52086c2f61162f5a0306c15
Author: Daniel Amelang <dan@ereba.localdomain>
Date:   Thu Nov 2 22:22:17 2006 -0800

    Add _cairo_lround for much faster rounding
    
    This function uses the same "magic number" approach as _cairo_fixed_from_double.

 src/cairo.c    |   25 +++++++++++++++++++++++++
 src/cairoint.h |    3 +++
 2 files changed, 28 insertions(+)

commit 166dffc96aa26b21f87f12af22b11630583cc85b
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 21 20:57:01 2006 -0800

    test/clip-operator: Use round to pass only integers to cairo_show_glyphs
    
    We were previously passing half-integer values here, which will
    not be robust to changes in the rounding mode used for
    cairo_show_glyphs. Use round() to match the rounding expected
    by the reference images.

 test/clip-operator.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit eaaeba170d4c8313443412d88ee63311723b546d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 21 19:05:16 2006 -0500

    [SVG] Fix compiler warning
    
    cairo-svg-surface.c:980: warning: 'id' might be used uninitialized in this function

 src/cairo-svg-surface.c |  112 +++++++++++++++++++++++------------------------
 1 file changed, 55 insertions(+), 57 deletions(-)

commit c6fceb6721a26d801be0fa8ed3028f9dc8b7dfed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 21 17:52:58 2006 -0500

    [PS] Rename n_glyphs to num_glyphs_unsigned
    
    Follow-up on my previous commit.  Use a more descriptive name to avoid
    confusion between n_glyphs and num_glyphs.

 src/cairo-ps-surface.c |   18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit 75eeb889767468b374df5f0aa6fb7ba1fe6addf9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 21 12:10:36 2006 -0500

    [PS] Eliminate compiler warnings about unoptimizable loops
    
    An innocient-looking loop like this:
    
      for (j = 0; j <= last; j++)
        something();
    
    cannot be optimized, because it may loop forever!
    Imagine the case that last is MAXINT, the loop will never end.  The correct
    way to write it is:
    
      for (j = 0; j < last+1; j++)
        something();
    
    In this case, if last is MAXINT, the loop will never run.  Not correct, but
    better than looping forever.
    
    Still better would be to correctly handle the MAXINT case (even though it
    doesn't make any sense to show MAXINT number of glyphs in one operation!)  To
    do that, we can use the fact that the input num_glyphs is a signed.  If
    there is one good thing about using signed int as input length, it's that you
    can use an unsigned looping variable to avoid looping forever.  That is
    exactly what this patch does.

 src/cairo-ps-surface.c |   28 +++++++++++++++-------------
 1 file changed, 15 insertions(+), 13 deletions(-)

commit 2dbb3dfd5f7e3d802f1c3c57b39f9d69b2b7ee1e
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Tue Nov 21 14:43:43 2006 +0100

    SVG: plug a memory leak
    
    What's the point in creating a memory stream if we overload the
    pointer a couple of lines below ?

 src/cairo-svg-surface.c |    3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 12f8718a3ed40e51e3edd678874d0a13e0eaaa74
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 21 00:10:03 2006 -0500

    [SVG] Define enum _cairo_svg_version.

 src/cairo-svg.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9cffc56228498e9d9fb1c047e1e1f2daaabac698
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Nov 20 15:30:04 2006 -0800

    [test] add big-trap test
    
    This test fills a single path (a trapezoid, even) that's larger than the
    16.16 precision used in pixman and other code.  It leads to memory
    scribbling and a crash.  Note that there is no crash if a clip is not set.

 test/Makefile.am |    1 +
 test/big-trap.c  |   60 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 61 insertions(+)

commit a91c1e3ea6c5d338f2d7cd61db5eede5076de3b2
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Nov 20 14:01:50 2006 -0800

    Require librsvg 2.15.0 (was 2.14.0) for testing of SVG backend.
    
    Bryce Harrington saw off-by-one errors in output image size with
    a 2.14.x version of librsvg.

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e5bd21136cc43f569cdf424d2fd47d8298b53fb6
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Nov 20 09:32:00 2006 -0800

    Add const qualifier to cairo_path_t* parameter of cairo_append_path

 src/cairo-path-data-private.h |    4 ++--
 src/cairo-path-data.c         |    4 ++--
 src/cairo.c                   |    4 ++--
 src/cairo.h                   |    4 ++--
 4 files changed, 8 insertions(+), 8 deletions(-)

commit 10920c1326362b4fadfa01019223647c23351127
Merge: 1ed3811 2928f6e
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Sat Nov 18 12:59:12 2006 +0100

    Merge branch 'svgprint'

commit 1ed3811338a03068b7ce60f83fdd23fe01fec972
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 17 17:50:14 2006 -0800

    perf: Add box_outline test case.
    
    This test shows that drawing a 100x100 single-pixel wide box outline is
    currently 5 to 16 times slower when using the natural cairo_stroke() as
    compared to a rather awkward cairo_fill() of two rectangles.
    
    [ # ]  backend-content                    test-size min(ticks)  min(ms) median(ms) stddev. iterations
    [  0]    image-rgba         box-outline-stroke-100     301321    0.218    0.219  0.39%   5
    [  1]    image-rgba           box-outline-fill-100      18178    0.013    0.013  0.43%   5
    [  0]     xlib-rgba         box-outline-stroke-100     379177    0.275    0.276  1.39%   6
    [  1]     xlib-rgba           box-outline-fill-100      83355    0.060    0.060  0.17%   5

 perf/Makefile.am   |    1 +
 perf/box-outline.c |   93 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 perf/cairo-perf.c  |    1 +
 perf/cairo-perf.h  |    2 ++
 4 files changed, 97 insertions(+)

commit a8faa0aef11abbd743ac9dc0b3127f9384325ee2
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 17 17:48:39 2006 -0800

    cairo-perf: When iteration count is given on command-line, never execute fewer

 perf/cairo-perf.c |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit a97b697d8fbba4ffc5a45a256603232ab5a4e86d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 16 10:38:53 2006 -0800

    ROADMAP: Set cairo 1.4 to early January for sake of Gnome 2.18

 ROADMAP |   16 +++++++---------
 1 file changed, 7 insertions(+), 9 deletions(-)

commit db603d66476a7a8e6b7e52b907212d289f9fbdb4
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 15 15:33:52 2006 -0800

    Increment cairo version to 1.3.3 after 1.3.2 snapshot

 configure.in |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 804e20b55d049a26fe4d96bb6d79890c65e43ab5
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 15 13:32:15 2006 -0800

    Update cairo version and libtool version for 1.3.2 snapshot

 configure.in |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit c63fd9437b69bd2ce5d9e0f5784d13a05ac7b867
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 15 13:30:16 2006 -0800

    NEWS: Add notes for 1.3.2 snapshot

 NEWS |  179 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 179 insertions(+)

commit a2d625edc62f35b4fbcefa6986918060f23fa1e6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 2 19:52:03 2006 -0500

    Add notes for the 1.2.6 release.

 NEWS |   60 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 60 insertions(+)

commit eeb1fa42aa44e1422dcfcdc6eb772b764c3ced58
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 14 14:44:03 2006 -0800

    Add missing pattern-getters-ref.png to Makefile to avoid breaking distcheck target

 test/Makefile.am |    1 +
 1 file changed, 1 insertion(+)

commit 28a9f1dd1407b0070a2ba1c780a6f763acb47810
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 14 14:35:35 2006 -0800

    Fix get-clip test for surfaces not implementing set_clip_region

 test/get-clip.c |   24 ++++++++++++++++--------
 1 file changed, 16 insertions(+), 8 deletions(-)

commit 7b86cf513e9f6bdf68e391f6df6f859eba05ba9c
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 14 14:34:36 2006 -0800

    Remove non-existent reference images from Makefile to avoid breaking distcheck target

 test/Makefile.am |    9 ---------
 1 file changed, 9 deletions(-)

commit 0f7381b26eae74903754b4fb5c1220a8626df5f4
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 14 13:27:52 2006 -0800

    cairo-perf-diff: Run git-ls-tree from the correct directory
    
    Before this change, cairo-perf-diff would work correctly only
    if run from the top-level directory, (and if run from any other
    directory it would not pull in the latest boilerplate and perf
    files).

 perf/cairo-perf-diff |    1 +
 1 file changed, 1 insertion(+)

commit f3f6ea3092072defb958ee3a6b2271cb51b4a4ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 14 17:58:09 2006 -0500

    Fix typo.

 src/cairo-traps.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 29b01f93ca9b29699420700ea9e2817898afa3ca
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Nov 11 10:43:11 2006 -0800

    Make miter join code use tessellate_convex_quad rather than tessellate_polygon
    
    This provides an additional 22-29% speedup on top of the previous
    fix for stroking paths with many miter joins:
    
    image-rgba  world_map-800  459.73 0.27% -> 356.80 0.32%:  1.29x speedup
    ▎
    image-rgb   world_map-800  458.83 0.37% -> 358.08 0.41%:  1.28x speedup
    ▎
     xlib-rgba  world_map-800  566.57 0.23% -> 463.84 0.31%:  1.22x speedup
    ▎
     xlib-rgb   world_map-800  562.31 0.64% -> 460.51 0.83%:  1.22x speedup
    ▎

 src/cairo-path-stroke.c |   20 +++++++-------------
 1 file changed, 7 insertions(+), 13 deletions(-)

commit 3d53f623faed4aed2517e207d77a6da7e3b74fbd
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 12:56:32 2006 -0800

    Make _cairo_stroker_add_sub_edge use tessellate_convex_quad rather than tessellate_polygon
    
    This gives a 17-20% speedup for stroking polygons with many
    straight line segments as seen in the world_map test case:
    
    Speedups
    ========
    image-rgba  world_map-800  555.41 0.17% -> 460.69 0.20%:  1.21x speedup
    ▎
    image-rgb   world_map-800  554.91 0.25% -> 460.73 0.26%:  1.20x speedup
    ▎
     xlib-rgb   world_map-800  669.85 3.70% -> 570.31 0.24%:  1.17x speedup
    ▏
     xlib-rgba  world_map-800  663.71 0.46% -> 567.74 0.19%:  1.17x speedup
    ▏

 src/cairo-path-stroke.c |   31 ++++++-------------------------
 1 file changed, 6 insertions(+), 25 deletions(-)

commit fefa7d9b993b1fc0759cfe1f8faff8dec9dc5c85
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 12:53:33 2006 -0800

    Rewrite tessellate_rectangle as tessellate_convex_quad to make it more useful
    
    Currently there aren't even any users of this code, (they had
    stopped using it when they realized what they really wanted
    was tessellate_convex_quad).

 src/cairo-traps.c |  127 ++++++++++++++++++++++++++++++++++++++++++++++-------
 src/cairoint.h    |    2 +-
 2 files changed, 112 insertions(+), 17 deletions(-)

commit e324bbcbc6ca86a714aa91fe5cd010a4ce4f1753
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 12:37:01 2006 -0800

    Add a status field to cairo_traps_t to enable less error checking

 src/cairo-traps.c |  148 +++++++++++++++++++++++------------------------------
 src/cairoint.h    |    2 +
 2 files changed, 67 insertions(+), 83 deletions(-)

commit 74f5fe241e6ce424a7d56a0ae48ddad202b82248
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Nov 13 14:44:07 2006 -0800

    cairo-perf-diff: rsync only git-managed files from boilerplate/perf
    
    Previously, we were using rsync to recursively copy all files
    from boilerplate and perf when doing the performance tests. This
    had the fatal flaw that pre-built binaries would be hard coded to
    link against the cairo library from $CAIRO_DIR with an absolute
    path, (due to libtool rpath stuff).
    
    By only copying git-managed files, we only get source and the compiled
    binaries (or libtool wrappers) will now be hard-coded to link against
    the library under test.

 perf/cairo-perf-diff |   16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit 2928f6eb5f5bd207f8f41a628ad95d6552aa8246
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Sun Nov 12 20:49:34 2006 +0100

    test/pixman-rotate.c: Don't issue a show_page, it's already done in cairo-test.c

 test/pixman-rotate.c |    2 --
 1 file changed, 2 deletions(-)

commit 4f02395267dc0cccef231e548a914329dce2831f
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Sun Nov 12 20:45:50 2006 +0100

    Use SVG multipage capability.

 test/fallback-resolution.c |   33 +++------------------------------
 1 file changed, 3 insertions(+), 30 deletions(-)

commit ad6d3a8369569cefde4984c0102cacf56b159cc7
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Sun Nov 12 20:45:10 2006 +0100

    Add SVGPrint support.
    
    It's only activated when svg version >= 1.2.
    Last page without a show page call is ignored if blank.

 src/cairo-svg-surface.c |  127 +++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 113 insertions(+), 14 deletions(-)

commit 26b74049e79a6137e8556e1b3e5c3aedd780abb0
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 10:31:14 2006 -0800

    cairo-perf-diff: Use rsync instead of cp to avoid some unnecessary rebuilding

 perf/cairo-perf-diff |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f1f189b81a24730b7c5b5761165ab30bb8310bca
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 10:20:49 2006 -0800

    cairo-perf-diff: Separate old and new build directories
    
    With the fancy new, incremental cairo-perf-diff we don't want to keep
    resetting the same working tree back and forth between the old and new
    versions and rebuilding everything all over again. So use two different
    build directories instead of one.
    
    This fixes the rebuild of the library itself, but the perf stuff is still
    being rebuilt, (since it's being re-copied each time).

 perf/cairo-perf-diff |   19 ++++++++++++-------
 1 file changed, 12 insertions(+), 7 deletions(-)

commit d9b697c46ceb4849436df162d0574b08856680bb
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 10:04:01 2006 -0800

    cairo-perf-diff: Allow incremental refinement of performance results
    
    cairo-perf-diff now accepts a -f command-line option to force it to
    re-generate performance results even if something exists in the cache
    already. It also now uses raw mode and appends to the cached file
    rather than rewriting the results.
    
    Finally, it also now allows a -- option on the command line and passes
    all the subsequent command-line options to cairo-perf. This is handy for
    limiting cairo-perf to run only on a subset of the tests of interest.

 perf/cairo-perf-diff |   50 +++++++++++++++++++++++++++++++++++++++++---------
 1 file changed, 41 insertions(+), 9 deletions(-)

commit 439bf81e56955ea543a890d5e89622745598c8ea
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 10 10:00:31 2006 -0800

    Fix broken size calculation for xrealloc
    
    Another one of those "untested code == broken code" situations.

 perf/cairo-perf-diff-files.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit f6b400a292759a7d603843afa6030ebb01349855
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 8 05:45:09 2006 -0800

    perf: Add world-map performance test case.
    
    The map for this test case was originally demonstrated as a
    performance problem in this mozilla bug report:
    
    	A very slow SVG file with <path>s
    	https://bugzilla.mozilla.org/show_bug.cgi?id=332413
    
    I obtained permission from the creator of the original file to
    include the data here, (see comments in world-map.h for details).

 perf/Makefile.am  |    2 +
 perf/cairo-perf.c |    1 +
 perf/cairo-perf.h |    1 +
 perf/world-map.c  |  107 +++++++++++++++++++++++++++++
 perf/world-map.h  |  196 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 307 insertions(+)

commit 2d927eaefa1188d11c056a055321763faf43573e
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 8 05:40:17 2006 -0800

    perf/Makefile.am: Add missing zrusin-another.h file to list

 perf/Makefile.am |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 0d1340f7169920c901a0f6d6f8ecb4529e57ada4
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Nov 8 05:39:06 2006 -0800

    perf: Eliminate CAIRO_STATS_MIN_VALID_SAMPLES
    
    We don't need this at this deep level since callers can now
    implement this limiting manually since stats.iterations is
    now returned. Also, this was interfering with the -i option
    to cairo-perf anyway.

 perf/cairo-perf.c  |    7 ++-----
 perf/cairo-stats.c |    7 +------
 perf/cairo-stats.h |    9 +--------
 3 files changed, 4 insertions(+), 19 deletions(-)

commit 6d5df0e3e2e9804cede77cfd0d3659bd2d36a918
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 13:06:01 2006 -0800

    cairo-perf-diff-files: Add support for diffing "raw" files from "cairo-perf -r"

 perf/cairo-perf-diff-files.c |  161 +++++++++++++++++++++++++++++++++---------
 1 file changed, 128 insertions(+), 33 deletions(-)

commit d1e1192090c56b5fa0794faae319cfaa88fc1788
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 12:59:57 2006 -0800

    cairo-perf: Print ticks_per_ms value in raw mode so raw analysis tools can report times

 perf/cairo-perf.c |    9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 5393989272881f9128df3c4a3fc6bb2c08b06a1e
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 12:57:48 2006 -0800

    perf: Move statistics code into new cairo-stats.h for sharing

 perf/Makefile.am   |    6 ++-
 perf/cairo-perf.c  |  106 +++------------------------------------------------
 perf/cairo-perf.h  |    6 ++-
 perf/cairo-stats.c |  108 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 perf/cairo-stats.h |   51 +++++++++++++++++++++++++
 5 files changed, 174 insertions(+), 103 deletions(-)

commit 7673e3ac3fc36042efcbccc3836d8bc81bdb94b3
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 12:50:52 2006 -0800

    boilerplate: Add xrealloc function

 boilerplate/xmalloc.c |   12 ++++++++++++
 boilerplate/xmalloc.h |    3 +++
 2 files changed, 15 insertions(+)

commit 1e4515c548bd2a1440c630d779a948e5b02890e9
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Nov 7 13:15:28 2006 -0800

    [win32] implement EXTEND_REPEAT in composite when possible
    
    Optimizes EXTEND_REPEAT, especially when DDBs are in use through the
    use of PatBlt or manually expanding out the repeated blits (up to a
    limit).  Will still fall back to fallback code as necessary.

 src/cairo-win32-surface.c |  386 +++++++++++++++++++++++++++++++--------------
 1 file changed, 266 insertions(+), 120 deletions(-)

commit 6db219c3a16bbbe736653946ea5a4758656a9cd9
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Nov 3 10:04:28 2006 -0800

    [win32] clean up win32_surface_composite
    
    Make sure that all operations are correct (the operations chosen
    are listed in cairo-win32-surface.c); in particular, deal with the extra
    byte present in FORMAT_RGB24 surfaces correctly.
    
    Also adds support for calling StretchDIBits to draw RGB24
    cairo_image_surfaces directly.

 src/Makefile.win32        |    3 +-
 src/cairo-win32-private.h |    5 +-
 src/cairo-win32-surface.c |  318 +++++++++++++++++++++++++++++----------------
 src/cairoint.h            |    5 +
 test/Makefile.win32       |    1 -
 5 files changed, 218 insertions(+), 114 deletions(-)

commit 3e002a474b64c83f8768ba8918209eca9d7599a3
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Nov 3 09:47:31 2006 -0800

    [win32] Update pixman MMX code to work with MSVC
    
    Patch from Tor Lillqvist.

 pixman/src/Makefile.win32 |    3 +-
 pixman/src/fbmmx.c        |  187 ++++++++++++++++++++++++++++-----------------
 pixman/src/fbpict.c       |   57 ++++++++++++++
 3 files changed, 174 insertions(+), 73 deletions(-)

commit fc87d4148131ce01f645aec12a5e1b6d6b55d337
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 7 15:07:33 2006 -0500

    [configure] Err if a suitable pkg-config is not found

 configure.in |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit fc584e1fbb87752f6123fbc02c1c27e538dd13f0
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 01:42:21 2006 -0800

    Rewrite _cairo_matrix_transform_bounding_box to actually accept a box not a rectangle
    
    It turns out that all of the callers want a box anyway, so this
    simplfies the code in addition to being more honest to the name.
    
    (For those new to the convention, a "box" is an (x1,y2),(x2,y2)
    pair while a "rectangle" is an (x,y),(width,height) pair.)

 src/cairo-gstate.c  |    9 ++-------
 src/cairo-matrix.c  |   39 +++++++++++++++++----------------------
 src/cairo-pattern.c |   19 ++++++++-----------
 src/cairoint.h      |    4 ++--
 4 files changed, 29 insertions(+), 42 deletions(-)

commit 777eaf326a56bb3b2ec3e6408309336d2bf6754f
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 01:33:40 2006 -0800

    test/Makefile.am: Fix typo in EXTRA_DIST that was breaking distcheck

 test/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0564b5074c431c3e723d906769b5383eddae659d
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Nov 7 01:29:38 2006 -0800

    cairo-perf: Add command line options for test cases to run, listing tests, and new raw mode.

 perf/cairo-perf.c |  163 +++++++++++++++++++++++++++++++++++++++++++----------
 perf/cairo-perf.h |    7 +++
 2 files changed, 139 insertions(+), 31 deletions(-)

commit 49b72f004d4de50de86f7f350ce01aa5b48f35ae
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Nov 6 23:56:19 2006 -0800

    Add zrusin-another test cases (tessellate and fill).
    
    This new test case is the 0th polygon polygon from Zack Rusin's
    recent cairorender program as made avaialable here:
    
    	http://ktown.kde.org/~zrusin/examples/cairorender.tar.bz2
    
    This polygon contains about 1000 coordinates and looks like a
    hand-drawn version of the word another.

 perf/Makefile.am      |    3 +-
 perf/cairo-perf.c     |    1 +
 perf/cairo-perf.h     |    1 +
 perf/zrusin-another.h |  668 +++++++++++++++++++++++++++++++++++++++++++++++++
 perf/zrusin.c         |   90 +++++++
 5 files changed, 762 insertions(+), 1 deletion(-)

commit 52eb7134bd22c648a10e2b9b8c5d1409de309887
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 3 15:32:57 2006 -0800

    cairo-perf-diff: Use two-part hash to avoid stale data when perf suite changes.
    
    The perf tree's sha1 is now in the cache file name, so that
    if the performance suite itself ever changes then new data
    will be generated rather than using stale stuff from the cache.
    
    Also, we now use the src tree's sha1 rather than the commit's
    so that commits that don't change the src directory are also
    treated as identical, (which they really should be as far as
    performance of the library itself is concerned).

 perf/cairo-perf-diff |   18 +++++++++++++++---
 perf/cairo-perf.c    |    2 +-
 2 files changed, 16 insertions(+), 4 deletions(-)

commit e760d0927ee5b732392284fc19fda225f137f909
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 3 14:58:30 2006 -0800

    Don't rely on NQUARTZ or OS2 surface types unless they exist.
    
    This allows the cairo-perf stuff to build on older checkouts,
    (such as 1.2.4), so that we can usefully do things like:
    
    	cairo-perf-diff 1.2.4 HEAD

 perf/cairo-perf.c |    2 ++
 1 file changed, 2 insertions(+)

commit 4cd50965a1935bf934f39f9e35b7d1a055ae7e16
Author: Dan Amelang <dan@amelang.net>
Date:   Sun Oct 29 21:31:23 2006 -0800

    Change _cairo_fixed_from_double to use the "magic number" technique
    
    See long thread here:
    http://lists.freedesktop.org/archives/cairo/2006-October/008285.html
    
    This patch provides a 3x performance improvement (on x86) for the
    conversion of floating-point to fixed-point values as measured by
    the recent pattern_create_radial performance test:
    
    image-rgba      pattern_create_radial-16     8.98 3.36% ->   2.97 1.03%:  3.38x speedup
    ██▍
    image-rgb       pattern_create_radial-16     8.94 3.21% ->   2.97 0.18%:  3.36x speedup
    ██▍
     xlib-rgb       pattern_create_radial-16     9.55 3.17% ->   3.64 0.51%:  2.93x speedup
    █▉
     xlib-rgba      pattern_create_radial-16     9.63 3.53% ->   3.69 0.66%:  2.91x speedup
    █▉

 src/cairo-fixed.c |   48 +++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 47 insertions(+), 1 deletion(-)

commit 5376e474255b80d084dd250cab6ea5c14220a3f3
Author: Dan Amelang <dan@amelang.net>
Date:   Sun Oct 29 21:30:08 2006 -0800

    Add autoconf macro AX_C_FLOAT_WORDS_BIGENDIAN
    
    The symbol that this macro defines (FLOAT_WORDS_BIGENDIAN) can be used
    to make double arithmetic tricks portable.

 acinclude.m4 |   65 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 configure.in |    1 +
 2 files changed, 66 insertions(+)

commit 941b517024c79dfd157337565477b0a440924702
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 3 13:26:48 2006 -0800

    cairo-perf-diff: Build and run latest cairo-perf program rather than whatever was in the old checkout

 perf/cairo-perf-diff |    5 +++++
 1 file changed, 5 insertions(+)

commit e2ede57fbb8d729f066bc592e33bae23a11fa4d9
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Nov 3 12:40:09 2006 -0800

    cairo-perf-diff: Fix to still function if run from the top-level directory containing .git

 perf/cairo-perf-diff |    3 +++
 1 file changed, 3 insertions(+)

commit 8e74f9f945f4a498ec64930ddd46cc89129812bc
Author: Jinghua Luo <sunmoon1997@gmail.com>
Date:   Mon Nov 6 12:21:25 2006 +0800

    glitz: fix a memory leak in _cairo_glitz_surface_composite_trapezoids.

 src/cairo-glitz-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit e759959fd6a59d439fe5fe147326401619cb939b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 2 21:15:41 2006 -0500

    [Makefile.am] Pass tag message to git-tag in release-publish
    
    (cherry picked from 7cac87c8041f63fac2e0a2f5a29e36ed80d8d51a commit)

 Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 91ffb36faa121ccfaa57d8857c239dd3a6bb3e95
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 2 21:13:49 2006 -0500

    [Makefile.am] Minor fixes in release-publish output
    
    (cherry picked from 953332d128120e7c4f4197390984be11a80a368b commit)

 Makefile.am |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 16bc72feafac4f78552cd003680ae7133562b6f4
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 2 17:16:52 2006 -0800

    Increment CAIRO_VERSION to 1.3.1 now that a 1.2.6 release exists

 configure.in |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5500c59b9be9f7f32e8b3d0d9b5fa775e50fbe98
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 2 12:27:17 2006 -0800

    Remove typo (mean vs median)
    
    This didn't end up making a difference in practice since the
    median is assigned again later on.

 perf/cairo-perf.c |    1 -
 1 file changed, 1 deletion(-)

commit b717e987776d60cbc37434f7c918ad438e29b1a4
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Nov 2 12:21:26 2006 -0800

    cairo-perf: Change outlier elimination and report minimum times.
    
    Instead of just discarding the worst 15% of the results, we now
    do IQR-based detection and elimination of outliers. Also, instead
    of reporting mean times we now report minimum and median times.
    We still do compute the mean and standard deviation for the
    detection of when results seem stable for early bailout. And we
    do still report the standard deviation.
    
    A statistician might complain that it looks funny to report the
    median and the standard deviation together, (instead of median
    and average absolute deviation from the median, say), but I liked
    the standard deviation since it is always larger, so it might
    ensure better separatation if we use it to determine when two
    sets of results are sufficiently different to be interesting.

 perf/cairo-perf-diff-files.c |   43 +++++++++-----------
 perf/cairo-perf.c            |   92 +++++++++++++++++++++++++++++++++---------
 2 files changed, 94 insertions(+), 41 deletions(-)

commit d2d0d11bdefa012d65364b24477bb86c8475ca86
Author: Dan Amelang <dan@amelang.net>
Date:   Tue Oct 31 23:47:35 2006 -0800

    Add new perf test "pattern_create_radial"
    
    This test is really just for hammering the double to fixed-point conversion
    (in _cairo_fixed_from_double) that happens as doubles from API calls gets
    translated into internal cairo fixed-point numbers.

 perf/Makefile.am             |    1 +
 perf/cairo-perf.c            |    1 +
 perf/cairo-perf.h            |    1 +
 perf/pattern_create_radial.c |   98 ++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 101 insertions(+)

commit a618fd2cf90575ac7695b614328f1123db86b372
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Oct 27 00:51:24 2006 -0700

    cairo-perf-diff: Simplify git usage and just run cairo-perf that gets built with cairo revision
    
    Many thanks to Josh Triplett for help with theses fixes:
    
    1. Simplify the usage of git to eliminate the fragile and nasty
       stuff we were doing previously, (such as manually symlinking
       things under .git rather than just using git-clone -s).
    
    2. Don't try running latest cairo-perf with LD_LIBRARY_PATH
       pointing to built cairo version. Apparently stupid libtool
       and its use of rpath is foiling us here. Instead just run
       whatever cairo-perf gets built as part of the source that
       gets checked out.
    
    This second point means that cairo-perf-diff won't yet be useful
    for comparing the performance of old cairo revisions that pre-date
    cairo-perf. I've since been reasing and we might be able to use
    --disable-rpath to the configure script to get what we want.

 perf/cairo-perf-diff |   22 ++++++----------------
 1 file changed, 6 insertions(+), 16 deletions(-)

commit 504ea250f7c052525cf28536c767d4f9f57e7cc9
Author: Jamey Sharp <jamey@minilop.net>
Date:   Sun Oct 29 13:48:14 2006 -0800

    XCB/perf: implement boilerplate_xcb_synchronize for fair performance tests.
    
    It sure was nice when some tests showed XCB to be 1300 times faster
    than Xlib though...

 boilerplate/cairo-boilerplate.c |   13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit bc983700c463671128822e2eb9f74cbe834a1c1b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Oct 29 14:49:06 2006 -0500

    [autogen.sh] Make sed script portable

 autogen.sh |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7442b4086667ed67d9086e817af3d3c081a2b6f1
Author: Jamey Sharp <jamey@minilop.net>
Date:   Sun Oct 29 11:18:09 2006 -0800

    perf: cairo-perf-diff-files.c should generate cairo-perf-diff-files
    
    ... rather than overwriting the new cairo-perf-diff script, which
    should (by the way) be included in dist tarballs.

 perf/Makefile.am |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit b0f5af3b473e5d58e0fc07a38948c83897e1b1fc
Author: Jamey Sharp <jamey@minilop.net>
Date:   Sun Oct 29 10:59:30 2006 -0800

    Add clip-push-group to .gitignore.

 test/.gitignore |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a34ba73136a1b34c413eff78a44c28a6f1ba80f6
Author: Christian Biesinger <cbiesinger@web.de>
Date:   Fri Oct 27 23:50:57 2006 +0200

    [beos] Allow a pixel error of 1 for BeOS tests
    
    That allows us to delete the BeOS-specific reference images.

 boilerplate/cairo-boilerplate.c           |    9 ++++++---
 test/mask-beos-bitmap-argb32-ref.png      |  Bin 87641 -> 0 bytes
 test/mask-beos-bitmap-rgb24-ref.png       |  Bin 71028 -> 0 bytes
 test/mask-beos-rgb24-ref.png              |  Bin 71028 -> 0 bytes
 test/set-source-beos-bitmap-rgb24-ref.png |  Bin 124 -> 0 bytes
 test/set-source-beos-rgb24-ref.png        |  Bin 124 -> 0 bytes
 test/trap-clip-beos-bitmap-rgb24-ref.png  |  Bin 63088 -> 0 bytes
 test/trap-clip-beos-rgb24-ref.png         |  Bin 63088 -> 0 bytes
 8 files changed, 6 insertions(+), 3 deletions(-)

commit 2ec0237051cd4f756a8205cb9ecafc7bfe285a06
Author: Christian Biesinger <cbiesinger@web.de>
Date:   Fri Oct 27 23:47:15 2006 +0200

    [beos] make tests compile again

 boilerplate/cairo-test-beos.cpp |   44 +++++++++++++++++++++++++++++----------
 boilerplate/cairo-test-beos.h   |   16 ++++++++++----
 2 files changed, 45 insertions(+), 15 deletions(-)

commit e29aea745aa2c23ac9d60612813d5e415e1f8e57
Author: Christian Biesinger <cbiesinger@web.de>
Date:   Fri Oct 27 12:07:26 2006 +0200

    [win32] Add parentheses around & operator
    
    This fixes a GCC warning. Also, it fixes a bug: The precedence
    of & is not what you might expect.

 src/cairo-win32-surface.c |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 61bf9b009b47312c20d54198790542cd20fc5576
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Oct 26 15:52:21 2006 -0700

    Make xlib and xcb backends tolerant of single-bit errors in the test suite output.

 boilerplate/cairo-boilerplate.c |   12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 05a259d49368fb128b99d99f3776f8783df9d4ed
Author: Christian Biesinger <cbiesinger@web.de>
Date:   Thu Oct 26 21:40:35 2006 +0200

    [beos] Fix build error
    
    Rename cairo_rectangle_fixed_t to cairo_rectangle_int16_t
    as needed per commit 746f66c3fce6de39ac9afa7be8bcf8f74c750e85.

 src/cairo-beos-surface.cpp |   20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit acac0c19667d2166e2a26b07445fa78640dc8a33
Author: Ian Osgood <iano@quirkster.com>
Date:   Thu Oct 26 09:56:13 2006 -0700

    don't squish tiny images in test/index.html

 test/make-html.pl |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bd0f9919086f2978eb1df22cd5c1fffb7621d33f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Oct 27 00:00:24 2006 +0930

    Add OpenType/CFF Subsetting

 src/Makefile.am                         |    1 +
 src/cairo-cff-subset.c                  | 1452 +++++++++++++++++++++++++++++++
 src/cairo-pdf-surface.c                 |  107 +++
